
// -*-c++-*-
//-------------------------------------------------------------------------
//   Copyright 2002-2020 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bsimcmg.va with ADMS
//                  interface for Xyce 6.12.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.6
//
// Creation Date  : Mon, 20 Jan 2020 11:55:07
//
//-----------------------------------------------------------------------------
#ifndef Xyce_N_DEV_ADMSbsimcmg_110_h
#define Xyce_N_DEV_ADMSbsimcmg_110_h


#include <Sacado_No_Kokkos.hpp>

#include <N_DEV_Configuration.h>
#include <N_DEV_Const.h>
#include <N_DEV_DeviceBlock.h>
#include <N_DEV_DeviceInstance.h>
#include <N_DEV_DeviceModel.h>
#include <N_DEV_MOSFET1.h>


namespace Xyce {
namespace Device {
namespace ADMSbsimcmg_110 {

// This typedef is for our automatic differentiation:
typedef Sacado::Fad::SFad<double,19> AdmsFadType;
typedef Sacado::Fad::SFad<double,1> AdmsSensFadType;

class Model;
class Instance;
class InstanceSensitivity;

#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Class         : InstanceSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class InstanceSensitivity : public baseSensitivity
{
public:
  InstanceSensitivity() :
    baseSensitivity() {};

  virtual ~InstanceSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static InstanceSensitivity instSens;


//-----------------------------------------------------------------------------
// Class         : ModelSensitivity
//
// Purpose       : This class is a functor for sensitivity
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class ModelSensitivity : public baseSensitivity
{
public:
  ModelSensitivity() :
    baseSensitivity() {};

  virtual ~ModelSensitivity() {};

  virtual void operator()(
     const ParameterBase &entity,
     const std::string &param,
     std::vector<double> & dfdp,
     std::vector<double> & dqdp,
     std::vector<double> & dbdp,
     std::vector<int> & Findices,
     std::vector<int> & Qindices,
     std::vector<int> & Bindices
                          ) const ;
};

static ModelSensitivity modSens;
#endif // Xyce_ADMS_SENSITIVITIES

// general purpose free functions
// thermal voltage at kelvin temperature temp)
template <typename T> static inline T adms_vt(const T temp) {return(CONSTKoverQ*temp);};

// Figure out how to template this shiznit!
//-----------------------------------------------------------------------------


template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return ifFalse;
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const Tin &ifTrue, const double &ifFalse)
{
  if (cond)
    return ifTrue;
  else
    return Tin(ifFalse);
}

template<typename Tin>
static Tin adms_ternary_op(const bool cond, const double &ifTrue, const Tin &ifFalse)
{
  if (cond)
    return Tin(ifTrue);
  else
    return ifFalse;
}




#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Free functions used by sensitivity
//
//-----------------------------------------------------------------------------
void evaluateModelEquations(
   std::vector <double> & probeVars,
   // probe constants
   const int admsProbeID_V_N_GND,
   const int admsProbeID_V_g_ge,
   const int admsProbeID_V_s_si,
   const int admsProbeID_V_d_di,
   const int admsProbeID_V_e_ge,
   const int admsProbeID_V_ge_d,
   const int admsProbeID_V_ge_s,
   const int admsProbeID_V_di_d,
   const int admsProbeID_V_si_s,
   const int admsProbeID_V_e_s,
   const int admsProbeID_V_d_s,
   const int admsProbeID_V_g_s,
   const int admsProbeID_V_ge_e,
   const int admsProbeID_V_e_di,
   const int admsProbeID_V_e_si,
   const int admsProbeID_V_ge_di,
   const int admsProbeID_V_di_si,
   const int admsProbeID_V_ge_si,
   const int admsProbeID_Temp_t_GND,
   // node constants
   const int admsNodeID_d,
   const int admsNodeID_g,
   const int admsNodeID_s,
   const int admsNodeID_e,
   const int admsNodeID_t,
   const int admsNodeID_si,
   const int admsNodeID_di,
   const int admsNodeID_ge,
   const int admsNodeID_N,
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   AdmsSensFadType & instancePar_NFINNOM,
   bool instancePar_given_NFINNOM,
   AdmsSensFadType & instancePar_DELVTRAND,
   bool instancePar_given_DELVTRAND,
   AdmsSensFadType & instancePar_U0MULT,
   bool instancePar_given_U0MULT,
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_NFINtotal,
   AdmsSensFadType & instanceVar_TempLast,
   AdmsSensFadType & instanceVar_ids,
   double & instanceVar_sigvds,
   AdmsSensFadType & instanceVar_qd,
   AdmsSensFadType & instanceVar_qg,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_ni,
   AdmsSensFadType & instanceVar_epssub,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Eg,
   AdmsSensFadType & instanceVar_Eg0,
   AdmsSensFadType & instanceVar_Nc,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_LeffCV,
   AdmsSensFadType & instanceVar_LeffCV_acc,
   AdmsSensFadType & instanceVar_Weff0,
   AdmsSensFadType & instanceVar_WeffCV0,
   AdmsSensFadType & instanceVar_cox,
   AdmsSensFadType & instanceVar_nbody,
   AdmsSensFadType & instanceVar_phib,
   AdmsSensFadType & instanceVar_deltaPhi,
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_T3,
   AdmsSensFadType & instanceVar_Vtm,
   AdmsSensFadType & instanceVar_Vtm0,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_TRatio,
   AdmsSensFadType & instanceVar_dvth_temp,
   AdmsSensFadType & instanceVar_delTemp,
   AdmsSensFadType & instanceVar_ThetaSS,
   AdmsSensFadType & instanceVar_K0_t,
   AdmsSensFadType & instanceVar_K0SI_t,
   AdmsSensFadType & instanceVar_K2SI_t,
   AdmsSensFadType & instanceVar_K1_t,
   AdmsSensFadType & instanceVar_K2SAT_t,
   AdmsSensFadType & instanceVar_A1_t,
   AdmsSensFadType & instanceVar_A2_t,
   AdmsSensFadType & instanceVar_AIGBINV_t,
   AdmsSensFadType & instanceVar_AIGBACC_t,
   AdmsSensFadType & instanceVar_AIGC_t,
   AdmsSensFadType & instanceVar_AIGS_t,
   AdmsSensFadType & instanceVar_AIGD_t,
   AdmsSensFadType & instanceVar_BETA0_t,
   AdmsSensFadType & instanceVar_SII0_t,
   AdmsSensFadType & instanceVar_BGISL_t,
   AdmsSensFadType & instanceVar_BGIDL_t,
   AdmsSensFadType & instanceVar_igtemp,
   AdmsSensFadType & instanceVar_PTWG_t,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_ALPHA0_t,
   AdmsSensFadType & instanceVar_ALPHA1_t,
   AdmsSensFadType & instanceVar_ALPHAII0_t,
   AdmsSensFadType & instanceVar_ALPHAII1_t,
   AdmsSensFadType & instanceVar_CJS_t,
   AdmsSensFadType & instanceVar_CJSWS_t,
   AdmsSensFadType & instanceVar_CJSWGD_t,
   AdmsSensFadType & instanceVar_CJD_t,
   AdmsSensFadType & instanceVar_CJSWD_t,
   AdmsSensFadType & instanceVar_CJSWGS_t,
   AdmsSensFadType & instanceVar_PBS_t,
   AdmsSensFadType & instanceVar_PBSWS_t,
   AdmsSensFadType & instanceVar_PBSWGS_t,
   AdmsSensFadType & instanceVar_PBD_t,
   AdmsSensFadType & instanceVar_PBSWD_t,
   AdmsSensFadType & instanceVar_PBSWGD_t,
   AdmsSensFadType & instanceVar_JSS_t,
   AdmsSensFadType & instanceVar_JSWS_t,
   AdmsSensFadType & instanceVar_JSWGS_t,
   AdmsSensFadType & instanceVar_JSD_t,
   AdmsSensFadType & instanceVar_JSWD_t,
   AdmsSensFadType & instanceVar_JSWGD_t,
   AdmsSensFadType & instanceVar_JTSS_t,
   AdmsSensFadType & instanceVar_JTSD_t,
   AdmsSensFadType & instanceVar_JTSSWS_t,
   AdmsSensFadType & instanceVar_JTSSWD_t,
   AdmsSensFadType & instanceVar_JTSSWGS_t,
   AdmsSensFadType & instanceVar_JTSSWGD_t,
   AdmsSensFadType & instanceVar_NJTS_t,
   AdmsSensFadType & instanceVar_NJTSD_t,
   AdmsSensFadType & instanceVar_NJTSSW_t,
   AdmsSensFadType & instanceVar_NJTSSWD_t,
   AdmsSensFadType & instanceVar_NJTSSWG_t,
   AdmsSensFadType & instanceVar_NJTSSWGD_t,
   AdmsSensFadType & instanceVar_K2_t,
   AdmsSensFadType & instanceVar_K0SISAT_t,
   AdmsSensFadType & instanceVar_K2SISAT_t,
   AdmsSensFadType & instanceVar_q0,
   AdmsSensFadType & instanceVar_T11,
   AdmsSensFadType & instanceVar_T12,
   AdmsSensFadType & instanceVar_e0,
   AdmsSensFadType & instanceVar_e1,
   AdmsSensFadType & instanceVar_e2,
   AdmsSensFadType & instanceVar_ETA0_t,
   AdmsSensFadType & instanceVar_ETA0R_t,
   AdmsSensFadType & instanceVar_scl,
   AdmsSensFadType & instanceVar_vbi,
   AdmsSensFadType & instanceVar_tmp,
   AdmsSensFadType & instanceVar_Theta_SCE,
   AdmsSensFadType & instanceVar_Theta_SW,
   AdmsSensFadType & instanceVar_Theta_DIBL,
   AdmsSensFadType & instanceVar_Theta_RSCE,
   AdmsSensFadType & instanceVar_Theta_DITS,
   AdmsSensFadType & instanceVar_veseff,
   AdmsSensFadType & instanceVar_Tcen0,
   AdmsSensFadType & instanceVar_Tcen,
   AdmsSensFadType & instanceVar_dvch_qm,
   AdmsSensFadType & instanceVar_E0,
   AdmsSensFadType & instanceVar_E0prime,
   AdmsSensFadType & instanceVar_E1,
   AdmsSensFadType & instanceVar_E1prime,
   double & instanceVar_mx,
   double & instanceVar_mxprime,
   double & instanceVar_md,
   double & instanceVar_mdprime,
   double & instanceVar_gprime,
   double & instanceVar_gfactor,
   AdmsSensFadType & instanceVar_gam0,
   AdmsSensFadType & instanceVar_gam1,
   AdmsSensFadType & instanceVar_kT,
   AdmsSensFadType & instanceVar_qis,
   AdmsSensFadType & instanceVar_qid,
   AdmsSensFadType & instanceVar_qbs,
   AdmsSensFadType & instanceVar_qba,
   AdmsSensFadType & instanceVar_eta_mu,
   double & instanceVar_eta_mu_cv,
   AdmsSensFadType & instanceVar_u0,
   AdmsSensFadType & instanceVar_u0r,
   AdmsSensFadType & instanceVar_UA_t,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UC_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UCS_t,
   AdmsSensFadType & instanceVar_UD_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_U0_t,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_ETAMOB_t,
   AdmsSensFadType & instanceVar_EeffFactor,
   AdmsSensFadType & instanceVar_Dr,
   AdmsSensFadType & instanceVar_WeffWRFactor,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_Rdrain,
   AdmsSensFadType & instanceVar_Rsource,
   AdmsSensFadType & instanceVar_rdstemp,
   AdmsSensFadType & instanceVar_Rdsi,
   AdmsSensFadType & instanceVar_RSDR_t,
   AdmsSensFadType & instanceVar_RSDRR_t,
   AdmsSensFadType & instanceVar_RDDR_t,
   AdmsSensFadType & instanceVar_RDDRR_t,
   AdmsSensFadType & instanceVar_VSAT_t,
   AdmsSensFadType & instanceVar_VSAT1_t,
   AdmsSensFadType & instanceVar_VSAT1R_t,
   AdmsSensFadType & instanceVar_VSATCV_t,
   AdmsSensFadType & instanceVar_MEXP_t,
   AdmsSensFadType & instanceVar_MEXPR_t,
   AdmsSensFadType & instanceVar_Tb,
   AdmsSensFadType & instanceVar_VSAT_a,
   AdmsSensFadType & instanceVar_Cfr_geo,
   AdmsSensFadType & instanceVar_ggeltd,
   AdmsSensFadType & instanceVar_igbinv,
   AdmsSensFadType & instanceVar_igsd_mult,
   AdmsSensFadType & instanceVar_igsd_mult0,
   AdmsSensFadType & instanceVar_igbs,
   AdmsSensFadType & instanceVar_igbd,
   AdmsSensFadType & instanceVar_igbacc,
   AdmsSensFadType & instanceVar_igcs,
   AdmsSensFadType & instanceVar_igcd,
   AdmsSensFadType & instanceVar_igisl,
   AdmsSensFadType & instanceVar_igidl,
   AdmsSensFadType & instanceVar_vfbsd,
   AdmsSensFadType & instanceVar_igs,
   AdmsSensFadType & instanceVar_igd,
   double & instanceVar_Aechvb,
   double & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_Toxratio,
   AdmsSensFadType & instanceVar_Iii,
   AdmsSensFadType & instanceVar_cox_acc,
   AdmsSensFadType & instanceVar_qg_acc,
   AdmsSensFadType & instanceVar_qb_acc,
   AdmsSensFadType & instanceVar_qgs_fr,
   AdmsSensFadType & instanceVar_qgd_fr,
   AdmsSensFadType & instanceVar_qds_fr,
   AdmsSensFadType & instanceVar_qgs_parasitic,
   AdmsSensFadType & instanceVar_qgd_parasitic,
   AdmsSensFadType & instanceVar_Qes,
   AdmsSensFadType & instanceVar_Qed,
   AdmsSensFadType & instanceVar_Qeg,
   AdmsSensFadType & instanceVar_csbox,
   AdmsSensFadType & instanceVar_cdbox,
   AdmsSensFadType & instanceVar_cgbox,
   AdmsSensFadType & instanceVar_vfbsdcv,
   AdmsSensFadType & instanceVar_Ies,
   AdmsSensFadType & instanceVar_Ied,
   AdmsSensFadType & instanceVar_Czbs,
   AdmsSensFadType & instanceVar_Czbssw,
   AdmsSensFadType & instanceVar_Czbsswg,
   AdmsSensFadType & instanceVar_Czbd,
   AdmsSensFadType & instanceVar_Czbdsw,
   AdmsSensFadType & instanceVar_Czbdswg,
   AdmsSensFadType & instanceVar_Isbs,
   AdmsSensFadType & instanceVar_Isbd,
   AdmsSensFadType & instanceVar_Nvtms,
   AdmsSensFadType & instanceVar_Nvtmd,
   AdmsSensFadType & instanceVar_SslpRev,
   AdmsSensFadType & instanceVar_IVjsmRev,
   AdmsSensFadType & instanceVar_VjsmRev,
   AdmsSensFadType & instanceVar_SslpFwd,
   AdmsSensFadType & instanceVar_IVjsmFwd,
   AdmsSensFadType & instanceVar_VjsmFwd,
   AdmsSensFadType & instanceVar_XExpBVS,
   AdmsSensFadType & instanceVar_DslpRev,
   AdmsSensFadType & instanceVar_IVjdmRev,
   AdmsSensFadType & instanceVar_VjdmRev,
   AdmsSensFadType & instanceVar_DslpFwd,
   AdmsSensFadType & instanceVar_IVjdmFwd,
   AdmsSensFadType & instanceVar_VjdmFwd,
   AdmsSensFadType & instanceVar_XExpBVD,
   AdmsSensFadType & instanceVar_igentemp,
   AdmsSensFadType & instanceVar_idsgen,
   AdmsSensFadType & instanceVar_LINTIGEN_i,
   AdmsSensFadType & instanceVar_LINTNOI_i,
   AdmsSensFadType & instanceVar_litl,
   AdmsSensFadType & instanceVar_FNPowerAt1Hz,
   AdmsSensFadType & instanceVar_NTNOI_i,
   AdmsSensFadType & instanceVar_Gtnoi,
   AdmsSensFadType & instanceVar_sid,
   AdmsSensFadType & instanceVar_gspr,
   AdmsSensFadType & instanceVar_gdpr,
   AdmsSensFadType & instanceVar_gamma,
   AdmsSensFadType & instanceVar_delta,
   AdmsSensFadType & instanceVar_ctnoi,
   AdmsSensFadType & instanceVar_C0,
   AdmsSensFadType & instanceVar_sf,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   AdmsSensFadType & instanceVar_PHIG_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFS_i,
   AdmsSensFadType & instanceVar_COVS_i,
   AdmsSensFadType & instanceVar_COVD_i,
   AdmsSensFadType & instanceVar_CGSO_i,
   AdmsSensFadType & instanceVar_CGDO_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CGBL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_CKAPPAB_i,
   AdmsSensFadType & instanceVar_QMFACTOR_i,
   AdmsSensFadType & instanceVar_QMTCENCV_i,
   AdmsSensFadType & instanceVar_QMTCENCVA_i,
   AdmsSensFadType & instanceVar_KSATIV_i,
   AdmsSensFadType & instanceVar_KSATIVR_i,
   AdmsSensFadType & instanceVar_CDSC_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_DVT0_i,
   AdmsSensFadType & instanceVar_CITR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_K0_i,
   AdmsSensFadType & instanceVar_K01_i,
   AdmsSensFadType & instanceVar_K0SI_i,
   AdmsSensFadType & instanceVar_K0SI1_i,
   AdmsSensFadType & instanceVar_K2SI_i,
   AdmsSensFadType & instanceVar_K2SI1_i,
   AdmsSensFadType & instanceVar_PHIBE_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_K11_i,
   AdmsSensFadType & instanceVar_K2SAT_i,
   AdmsSensFadType & instanceVar_K2SAT1_i,
   AdmsSensFadType & instanceVar_DELTAVSAT_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_DELTAVSATCV_i,
   AdmsSensFadType & instanceVar_PSATCV_i,
   AdmsSensFadType & instanceVar_VSAT1_i,
   AdmsSensFadType & instanceVar_VSAT1R_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_ETAMOB_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_PRWGS_i,
   AdmsSensFadType & instanceVar_PRWGD_i,
   AdmsSensFadType & instanceVar_PDIBL1_i,
   AdmsSensFadType & instanceVar_PDIBL1R_i,
   AdmsSensFadType & instanceVar_PDIBL2_i,
   AdmsSensFadType & instanceVar_PDIBL2R_i,
   AdmsSensFadType & instanceVar_DROUT_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBINV1_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_AIGBACC1_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_AIGC1_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_AIGS1_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_POXEDGE_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_AIGD1_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_PGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_PGISL_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_ALPHA1_i,
   AdmsSensFadType & instanceVar_ALPHAII0_i,
   AdmsSensFadType & instanceVar_ALPHAII1_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_BETAII0_i,
   AdmsSensFadType & instanceVar_BETAII1_i,
   AdmsSensFadType & instanceVar_BETAII2_i,
   AdmsSensFadType & instanceVar_ESATII_i,
   AdmsSensFadType & instanceVar_LII_i,
   AdmsSensFadType & instanceVar_SII0_i,
   AdmsSensFadType & instanceVar_SII1_i,
   AdmsSensFadType & instanceVar_SII2_i,
   AdmsSensFadType & instanceVar_SIID_i,
   AdmsSensFadType & instanceVar_TII_i,
   AdmsSensFadType & instanceVar_MEXP_i,
   AdmsSensFadType & instanceVar_MEXPR_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMG_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_K1RSCE_i,
   AdmsSensFadType & instanceVar_DVTSHIFT_i,
   AdmsSensFadType & instanceVar_DVTSHIFTR_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EUR_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UA1R_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UTL_i,
   AdmsSensFadType & instanceVar_EMOBT_i,
   AdmsSensFadType & instanceVar_UC1R_i,
   AdmsSensFadType & instanceVar_UD1R_i,
   AdmsSensFadType & instanceVar_UTER_i,
   AdmsSensFadType & instanceVar_UTLR_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_ATCV_i,
   AdmsSensFadType & instanceVar_ATR_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_TSS_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_NTGEN_i,
   AdmsSensFadType & instanceVar_AIGEN_i,
   AdmsSensFadType & instanceVar_BIGEN_i,
   AdmsSensFadType & instanceVar_K0SISAT_i,
   AdmsSensFadType & instanceVar_K0SISAT1_i,
   AdmsSensFadType & instanceVar_K2SISAT_i,
   AdmsSensFadType & instanceVar_K2SISAT1_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K21_i,
   AdmsSensFadType & instanceVar_Cins,
   AdmsSensFadType & instanceVar_Ach,
   AdmsSensFadType & instanceVar_Weff_UFCM,
   AdmsSensFadType & instanceVar_qdep,
   AdmsSensFadType & instanceVar_rc,
   AdmsSensFadType & instanceVar_vth_fixed_factor_Sub,
   AdmsSensFadType & instanceVar_vth_fixed_factor_SI,
   AdmsSensFadType & instanceVar_qm,
   AdmsSensFadType & instanceVar_Qdep_ov_Cins,
   AdmsSensFadType & instanceVar_qi_acc_for_QM,
   AdmsSensFadType & instanceVar_fieldnormalizationfactor,
   double & instanceVar_auxQMfact,
   AdmsSensFadType & instanceVar_QMFACTORCVfinal,
   AdmsSensFadType & instanceVar_psipclamp,
   AdmsSensFadType & instanceVar_sqrtpsip,
   AdmsSensFadType & instanceVar_nq,
   AdmsSensFadType & instanceVar_F0,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   // basic variables
   double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <AdmsSensFadType> & staticContributions, std::vector <AdmsSensFadType> & dynamicContributions, const Instance & theInstance);

void evaluateInitialInstance(
   // instance parameters
   // reals
   AdmsSensFadType & instancePar_L,
   bool instancePar_given_L,
   AdmsSensFadType & instancePar_D,
   bool instancePar_given_D,
   AdmsSensFadType & instancePar_TFIN,
   bool instancePar_given_TFIN,
   AdmsSensFadType & instancePar_FPITCH,
   bool instancePar_given_FPITCH,
   AdmsSensFadType & instancePar_NFIN,
   bool instancePar_given_NFIN,
   AdmsSensFadType & instancePar_ASEO,
   bool instancePar_given_ASEO,
   AdmsSensFadType & instancePar_ADEO,
   bool instancePar_given_ADEO,
   AdmsSensFadType & instancePar_PSEO,
   bool instancePar_given_PSEO,
   AdmsSensFadType & instancePar_PDEO,
   bool instancePar_given_PDEO,
   AdmsSensFadType & instancePar_ASEJ,
   bool instancePar_given_ASEJ,
   AdmsSensFadType & instancePar_ADEJ,
   bool instancePar_given_ADEJ,
   AdmsSensFadType & instancePar_PSEJ,
   bool instancePar_given_PSEJ,
   AdmsSensFadType & instancePar_PDEJ,
   bool instancePar_given_PDEJ,
   AdmsSensFadType & instancePar_COVS,
   bool instancePar_given_COVS,
   AdmsSensFadType & instancePar_COVD,
   bool instancePar_given_COVD,
   AdmsSensFadType & instancePar_CGSP,
   bool instancePar_given_CGSP,
   AdmsSensFadType & instancePar_CGDP,
   bool instancePar_given_CGDP,
   AdmsSensFadType & instancePar_CDSP,
   bool instancePar_given_CDSP,
   AdmsSensFadType & instancePar_NRS,
   bool instancePar_given_NRS,
   AdmsSensFadType & instancePar_NRD,
   bool instancePar_given_NRD,
   AdmsSensFadType & instancePar_LRSD,
   bool instancePar_given_LRSD,
   AdmsSensFadType & instancePar_NFINNOM,
   bool instancePar_given_NFINNOM,
   AdmsSensFadType & instancePar_DELVTRAND,
   bool instancePar_given_DELVTRAND,
   AdmsSensFadType & instancePar_U0MULT,
   bool instancePar_given_U0MULT,
   AdmsSensFadType & instancePar_m,
   bool instancePar_given_m,
   // non-reals(including hidden)
   int instancePar_NF,
   bool instancePar_given_NF,
   int instancePar_NGCON,
   bool instancePar_given_NGCON,
   // instance variables
   // reals
   AdmsSensFadType & instanceVar_NFINtotal,
   AdmsSensFadType & instanceVar_TempLast,
   AdmsSensFadType & instanceVar_ids,
   double & instanceVar_sigvds,
   AdmsSensFadType & instanceVar_qd,
   AdmsSensFadType & instanceVar_qg,
   AdmsSensFadType & instanceVar_qs,
   AdmsSensFadType & instanceVar_qb,
   AdmsSensFadType & instanceVar_ni,
   AdmsSensFadType & instanceVar_epssub,
   AdmsSensFadType & instanceVar_epsratio,
   AdmsSensFadType & instanceVar_Eg,
   AdmsSensFadType & instanceVar_Eg0,
   AdmsSensFadType & instanceVar_Nc,
   AdmsSensFadType & instanceVar_Leff,
   AdmsSensFadType & instanceVar_LeffCV,
   AdmsSensFadType & instanceVar_LeffCV_acc,
   AdmsSensFadType & instanceVar_Weff0,
   AdmsSensFadType & instanceVar_WeffCV0,
   AdmsSensFadType & instanceVar_cox,
   AdmsSensFadType & instanceVar_nbody,
   AdmsSensFadType & instanceVar_phib,
   AdmsSensFadType & instanceVar_deltaPhi,
   AdmsSensFadType & instanceVar_T0,
   AdmsSensFadType & instanceVar_T1,
   AdmsSensFadType & instanceVar_T2,
   AdmsSensFadType & instanceVar_T3,
   AdmsSensFadType & instanceVar_Vtm,
   AdmsSensFadType & instanceVar_Vtm0,
   AdmsSensFadType & instanceVar_Tnom,
   AdmsSensFadType & instanceVar_TRatio,
   AdmsSensFadType & instanceVar_dvth_temp,
   AdmsSensFadType & instanceVar_delTemp,
   AdmsSensFadType & instanceVar_ThetaSS,
   AdmsSensFadType & instanceVar_K0_t,
   AdmsSensFadType & instanceVar_K0SI_t,
   AdmsSensFadType & instanceVar_K2SI_t,
   AdmsSensFadType & instanceVar_K1_t,
   AdmsSensFadType & instanceVar_K2SAT_t,
   AdmsSensFadType & instanceVar_A1_t,
   AdmsSensFadType & instanceVar_A2_t,
   AdmsSensFadType & instanceVar_AIGBINV_t,
   AdmsSensFadType & instanceVar_AIGBACC_t,
   AdmsSensFadType & instanceVar_AIGC_t,
   AdmsSensFadType & instanceVar_AIGS_t,
   AdmsSensFadType & instanceVar_AIGD_t,
   AdmsSensFadType & instanceVar_BETA0_t,
   AdmsSensFadType & instanceVar_SII0_t,
   AdmsSensFadType & instanceVar_BGISL_t,
   AdmsSensFadType & instanceVar_BGIDL_t,
   AdmsSensFadType & instanceVar_igtemp,
   AdmsSensFadType & instanceVar_PTWG_t,
   AdmsSensFadType & instanceVar_PTWGR_t,
   AdmsSensFadType & instanceVar_ALPHA0_t,
   AdmsSensFadType & instanceVar_ALPHA1_t,
   AdmsSensFadType & instanceVar_ALPHAII0_t,
   AdmsSensFadType & instanceVar_ALPHAII1_t,
   AdmsSensFadType & instanceVar_CJS_t,
   AdmsSensFadType & instanceVar_CJSWS_t,
   AdmsSensFadType & instanceVar_CJSWGD_t,
   AdmsSensFadType & instanceVar_CJD_t,
   AdmsSensFadType & instanceVar_CJSWD_t,
   AdmsSensFadType & instanceVar_CJSWGS_t,
   AdmsSensFadType & instanceVar_PBS_t,
   AdmsSensFadType & instanceVar_PBSWS_t,
   AdmsSensFadType & instanceVar_PBSWGS_t,
   AdmsSensFadType & instanceVar_PBD_t,
   AdmsSensFadType & instanceVar_PBSWD_t,
   AdmsSensFadType & instanceVar_PBSWGD_t,
   AdmsSensFadType & instanceVar_JSS_t,
   AdmsSensFadType & instanceVar_JSWS_t,
   AdmsSensFadType & instanceVar_JSWGS_t,
   AdmsSensFadType & instanceVar_JSD_t,
   AdmsSensFadType & instanceVar_JSWD_t,
   AdmsSensFadType & instanceVar_JSWGD_t,
   AdmsSensFadType & instanceVar_JTSS_t,
   AdmsSensFadType & instanceVar_JTSD_t,
   AdmsSensFadType & instanceVar_JTSSWS_t,
   AdmsSensFadType & instanceVar_JTSSWD_t,
   AdmsSensFadType & instanceVar_JTSSWGS_t,
   AdmsSensFadType & instanceVar_JTSSWGD_t,
   AdmsSensFadType & instanceVar_NJTS_t,
   AdmsSensFadType & instanceVar_NJTSD_t,
   AdmsSensFadType & instanceVar_NJTSSW_t,
   AdmsSensFadType & instanceVar_NJTSSWD_t,
   AdmsSensFadType & instanceVar_NJTSSWG_t,
   AdmsSensFadType & instanceVar_NJTSSWGD_t,
   AdmsSensFadType & instanceVar_K2_t,
   AdmsSensFadType & instanceVar_K0SISAT_t,
   AdmsSensFadType & instanceVar_K2SISAT_t,
   AdmsSensFadType & instanceVar_q0,
   AdmsSensFadType & instanceVar_T11,
   AdmsSensFadType & instanceVar_T12,
   AdmsSensFadType & instanceVar_e0,
   AdmsSensFadType & instanceVar_e1,
   AdmsSensFadType & instanceVar_e2,
   AdmsSensFadType & instanceVar_ETA0_t,
   AdmsSensFadType & instanceVar_ETA0R_t,
   AdmsSensFadType & instanceVar_scl,
   AdmsSensFadType & instanceVar_vbi,
   AdmsSensFadType & instanceVar_tmp,
   AdmsSensFadType & instanceVar_Theta_SCE,
   AdmsSensFadType & instanceVar_Theta_SW,
   AdmsSensFadType & instanceVar_Theta_DIBL,
   AdmsSensFadType & instanceVar_Theta_RSCE,
   AdmsSensFadType & instanceVar_Theta_DITS,
   AdmsSensFadType & instanceVar_veseff,
   AdmsSensFadType & instanceVar_Tcen0,
   AdmsSensFadType & instanceVar_Tcen,
   AdmsSensFadType & instanceVar_dvch_qm,
   AdmsSensFadType & instanceVar_E0,
   AdmsSensFadType & instanceVar_E0prime,
   AdmsSensFadType & instanceVar_E1,
   AdmsSensFadType & instanceVar_E1prime,
   double & instanceVar_mx,
   double & instanceVar_mxprime,
   double & instanceVar_md,
   double & instanceVar_mdprime,
   double & instanceVar_gprime,
   double & instanceVar_gfactor,
   AdmsSensFadType & instanceVar_gam0,
   AdmsSensFadType & instanceVar_gam1,
   AdmsSensFadType & instanceVar_kT,
   AdmsSensFadType & instanceVar_qis,
   AdmsSensFadType & instanceVar_qid,
   AdmsSensFadType & instanceVar_qbs,
   AdmsSensFadType & instanceVar_qba,
   AdmsSensFadType & instanceVar_eta_mu,
   double & instanceVar_eta_mu_cv,
   AdmsSensFadType & instanceVar_u0,
   AdmsSensFadType & instanceVar_u0r,
   AdmsSensFadType & instanceVar_UA_t,
   AdmsSensFadType & instanceVar_UAR_t,
   AdmsSensFadType & instanceVar_UC_t,
   AdmsSensFadType & instanceVar_UCR_t,
   AdmsSensFadType & instanceVar_UCS_t,
   AdmsSensFadType & instanceVar_UD_t,
   AdmsSensFadType & instanceVar_UDR_t,
   AdmsSensFadType & instanceVar_U0_t,
   AdmsSensFadType & instanceVar_U0R_t,
   AdmsSensFadType & instanceVar_ETAMOB_t,
   AdmsSensFadType & instanceVar_EeffFactor,
   AdmsSensFadType & instanceVar_Dr,
   AdmsSensFadType & instanceVar_WeffWRFactor,
   AdmsSensFadType & instanceVar_RSourceGeo,
   AdmsSensFadType & instanceVar_RDrainGeo,
   AdmsSensFadType & instanceVar_RDSWMIN_i,
   AdmsSensFadType & instanceVar_RDWMIN_i,
   AdmsSensFadType & instanceVar_RSWMIN_i,
   AdmsSensFadType & instanceVar_Rdrain,
   AdmsSensFadType & instanceVar_Rsource,
   AdmsSensFadType & instanceVar_rdstemp,
   AdmsSensFadType & instanceVar_Rdsi,
   AdmsSensFadType & instanceVar_RSDR_t,
   AdmsSensFadType & instanceVar_RSDRR_t,
   AdmsSensFadType & instanceVar_RDDR_t,
   AdmsSensFadType & instanceVar_RDDRR_t,
   AdmsSensFadType & instanceVar_VSAT_t,
   AdmsSensFadType & instanceVar_VSAT1_t,
   AdmsSensFadType & instanceVar_VSAT1R_t,
   AdmsSensFadType & instanceVar_VSATCV_t,
   AdmsSensFadType & instanceVar_MEXP_t,
   AdmsSensFadType & instanceVar_MEXPR_t,
   AdmsSensFadType & instanceVar_Tb,
   AdmsSensFadType & instanceVar_VSAT_a,
   AdmsSensFadType & instanceVar_Cfr_geo,
   AdmsSensFadType & instanceVar_ggeltd,
   AdmsSensFadType & instanceVar_igbinv,
   AdmsSensFadType & instanceVar_igsd_mult,
   AdmsSensFadType & instanceVar_igsd_mult0,
   AdmsSensFadType & instanceVar_igbs,
   AdmsSensFadType & instanceVar_igbd,
   AdmsSensFadType & instanceVar_igbacc,
   AdmsSensFadType & instanceVar_igcs,
   AdmsSensFadType & instanceVar_igcd,
   AdmsSensFadType & instanceVar_igisl,
   AdmsSensFadType & instanceVar_igidl,
   AdmsSensFadType & instanceVar_vfbsd,
   AdmsSensFadType & instanceVar_igs,
   AdmsSensFadType & instanceVar_igd,
   double & instanceVar_Aechvb,
   double & instanceVar_Bechvb,
   AdmsSensFadType & instanceVar_Toxratio,
   AdmsSensFadType & instanceVar_Iii,
   AdmsSensFadType & instanceVar_cox_acc,
   AdmsSensFadType & instanceVar_qg_acc,
   AdmsSensFadType & instanceVar_qb_acc,
   AdmsSensFadType & instanceVar_qgs_fr,
   AdmsSensFadType & instanceVar_qgd_fr,
   AdmsSensFadType & instanceVar_qds_fr,
   AdmsSensFadType & instanceVar_qgs_parasitic,
   AdmsSensFadType & instanceVar_qgd_parasitic,
   AdmsSensFadType & instanceVar_Qes,
   AdmsSensFadType & instanceVar_Qed,
   AdmsSensFadType & instanceVar_Qeg,
   AdmsSensFadType & instanceVar_csbox,
   AdmsSensFadType & instanceVar_cdbox,
   AdmsSensFadType & instanceVar_cgbox,
   AdmsSensFadType & instanceVar_vfbsdcv,
   AdmsSensFadType & instanceVar_Ies,
   AdmsSensFadType & instanceVar_Ied,
   AdmsSensFadType & instanceVar_Czbs,
   AdmsSensFadType & instanceVar_Czbssw,
   AdmsSensFadType & instanceVar_Czbsswg,
   AdmsSensFadType & instanceVar_Czbd,
   AdmsSensFadType & instanceVar_Czbdsw,
   AdmsSensFadType & instanceVar_Czbdswg,
   AdmsSensFadType & instanceVar_Isbs,
   AdmsSensFadType & instanceVar_Isbd,
   AdmsSensFadType & instanceVar_Nvtms,
   AdmsSensFadType & instanceVar_Nvtmd,
   AdmsSensFadType & instanceVar_SslpRev,
   AdmsSensFadType & instanceVar_IVjsmRev,
   AdmsSensFadType & instanceVar_VjsmRev,
   AdmsSensFadType & instanceVar_SslpFwd,
   AdmsSensFadType & instanceVar_IVjsmFwd,
   AdmsSensFadType & instanceVar_VjsmFwd,
   AdmsSensFadType & instanceVar_XExpBVS,
   AdmsSensFadType & instanceVar_DslpRev,
   AdmsSensFadType & instanceVar_IVjdmRev,
   AdmsSensFadType & instanceVar_VjdmRev,
   AdmsSensFadType & instanceVar_DslpFwd,
   AdmsSensFadType & instanceVar_IVjdmFwd,
   AdmsSensFadType & instanceVar_VjdmFwd,
   AdmsSensFadType & instanceVar_XExpBVD,
   AdmsSensFadType & instanceVar_igentemp,
   AdmsSensFadType & instanceVar_idsgen,
   AdmsSensFadType & instanceVar_LINTIGEN_i,
   AdmsSensFadType & instanceVar_LINTNOI_i,
   AdmsSensFadType & instanceVar_litl,
   AdmsSensFadType & instanceVar_FNPowerAt1Hz,
   AdmsSensFadType & instanceVar_NTNOI_i,
   AdmsSensFadType & instanceVar_Gtnoi,
   AdmsSensFadType & instanceVar_sid,
   AdmsSensFadType & instanceVar_gspr,
   AdmsSensFadType & instanceVar_gdpr,
   AdmsSensFadType & instanceVar_gamma,
   AdmsSensFadType & instanceVar_delta,
   AdmsSensFadType & instanceVar_ctnoi,
   AdmsSensFadType & instanceVar_C0,
   AdmsSensFadType & instanceVar_sf,
   AdmsSensFadType & instanceVar_gth,
   AdmsSensFadType & instanceVar_cth,
   AdmsSensFadType & instanceVar_PHIG_i,
   AdmsSensFadType & instanceVar_CFD_i,
   AdmsSensFadType & instanceVar_CFS_i,
   AdmsSensFadType & instanceVar_COVS_i,
   AdmsSensFadType & instanceVar_COVD_i,
   AdmsSensFadType & instanceVar_CGSO_i,
   AdmsSensFadType & instanceVar_CGDO_i,
   AdmsSensFadType & instanceVar_CGSL_i,
   AdmsSensFadType & instanceVar_CGDL_i,
   AdmsSensFadType & instanceVar_CGBL_i,
   AdmsSensFadType & instanceVar_CKAPPAS_i,
   AdmsSensFadType & instanceVar_CKAPPAD_i,
   AdmsSensFadType & instanceVar_CKAPPAB_i,
   AdmsSensFadType & instanceVar_QMFACTOR_i,
   AdmsSensFadType & instanceVar_QMTCENCV_i,
   AdmsSensFadType & instanceVar_QMTCENCVA_i,
   AdmsSensFadType & instanceVar_KSATIV_i,
   AdmsSensFadType & instanceVar_KSATIVR_i,
   AdmsSensFadType & instanceVar_CDSC_i,
   AdmsSensFadType & instanceVar_CDSCD_i,
   AdmsSensFadType & instanceVar_CDSCDR_i,
   AdmsSensFadType & instanceVar_CIT_i,
   AdmsSensFadType & instanceVar_DVT0_i,
   AdmsSensFadType & instanceVar_CITR_i,
   AdmsSensFadType & instanceVar_PHIN_i,
   AdmsSensFadType & instanceVar_ETA0_i,
   AdmsSensFadType & instanceVar_ETA0R_i,
   AdmsSensFadType & instanceVar_VSAT_i,
   AdmsSensFadType & instanceVar_VSATR_i,
   AdmsSensFadType & instanceVar_VSATR_t,
   AdmsSensFadType & instanceVar_DVTP0_i,
   AdmsSensFadType & instanceVar_DVTP1_i,
   AdmsSensFadType & instanceVar_K0_i,
   AdmsSensFadType & instanceVar_K01_i,
   AdmsSensFadType & instanceVar_K0SI_i,
   AdmsSensFadType & instanceVar_K0SI1_i,
   AdmsSensFadType & instanceVar_K2SI_i,
   AdmsSensFadType & instanceVar_K2SI1_i,
   AdmsSensFadType & instanceVar_PHIBE_i,
   AdmsSensFadType & instanceVar_K1_i,
   AdmsSensFadType & instanceVar_K11_i,
   AdmsSensFadType & instanceVar_K2SAT_i,
   AdmsSensFadType & instanceVar_K2SAT1_i,
   AdmsSensFadType & instanceVar_DELTAVSAT_i,
   AdmsSensFadType & instanceVar_PSAT_i,
   AdmsSensFadType & instanceVar_DELTAVSATCV_i,
   AdmsSensFadType & instanceVar_PSATCV_i,
   AdmsSensFadType & instanceVar_VSAT1_i,
   AdmsSensFadType & instanceVar_VSAT1R_i,
   AdmsSensFadType & instanceVar_PTWG_i,
   AdmsSensFadType & instanceVar_PTWGR_i,
   AdmsSensFadType & instanceVar_VSATCV_i,
   AdmsSensFadType & instanceVar_U0_i,
   AdmsSensFadType & instanceVar_U0R_i,
   AdmsSensFadType & instanceVar_ETAMOB_i,
   AdmsSensFadType & instanceVar_RDSW_i,
   AdmsSensFadType & instanceVar_PRWGS_i,
   AdmsSensFadType & instanceVar_PRWGD_i,
   AdmsSensFadType & instanceVar_PDIBL1_i,
   AdmsSensFadType & instanceVar_PDIBL1R_i,
   AdmsSensFadType & instanceVar_PDIBL2_i,
   AdmsSensFadType & instanceVar_PDIBL2R_i,
   AdmsSensFadType & instanceVar_DROUT_i,
   AdmsSensFadType & instanceVar_PVAG_i,
   AdmsSensFadType & instanceVar_AIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBINV1_i,
   AdmsSensFadType & instanceVar_BIGBINV_i,
   AdmsSensFadType & instanceVar_CIGBINV_i,
   AdmsSensFadType & instanceVar_EIGBINV_i,
   AdmsSensFadType & instanceVar_NIGBINV_i,
   AdmsSensFadType & instanceVar_AIGBACC_i,
   AdmsSensFadType & instanceVar_AIGBACC1_i,
   AdmsSensFadType & instanceVar_BIGBACC_i,
   AdmsSensFadType & instanceVar_CIGBACC_i,
   AdmsSensFadType & instanceVar_NIGBACC_i,
   AdmsSensFadType & instanceVar_AIGC_i,
   AdmsSensFadType & instanceVar_AIGC1_i,
   AdmsSensFadType & instanceVar_BIGC_i,
   AdmsSensFadType & instanceVar_CIGC_i,
   AdmsSensFadType & instanceVar_PIGCD_i,
   AdmsSensFadType & instanceVar_AIGS_i,
   AdmsSensFadType & instanceVar_AIGS1_i,
   AdmsSensFadType & instanceVar_BIGS_i,
   AdmsSensFadType & instanceVar_CIGS_i,
   AdmsSensFadType & instanceVar_POXEDGE_i,
   AdmsSensFadType & instanceVar_AIGD_i,
   AdmsSensFadType & instanceVar_AIGD1_i,
   AdmsSensFadType & instanceVar_BIGD_i,
   AdmsSensFadType & instanceVar_CIGD_i,
   AdmsSensFadType & instanceVar_AGIDL_i,
   AdmsSensFadType & instanceVar_BGIDL_i,
   AdmsSensFadType & instanceVar_CGIDL_i,
   AdmsSensFadType & instanceVar_EGIDL_i,
   AdmsSensFadType & instanceVar_PGIDL_i,
   AdmsSensFadType & instanceVar_AGISL_i,
   AdmsSensFadType & instanceVar_BGISL_i,
   AdmsSensFadType & instanceVar_CGISL_i,
   AdmsSensFadType & instanceVar_EGISL_i,
   AdmsSensFadType & instanceVar_PGISL_i,
   AdmsSensFadType & instanceVar_ALPHA0_i,
   AdmsSensFadType & instanceVar_ALPHA1_i,
   AdmsSensFadType & instanceVar_ALPHAII0_i,
   AdmsSensFadType & instanceVar_ALPHAII1_i,
   AdmsSensFadType & instanceVar_BETA0_i,
   AdmsSensFadType & instanceVar_BETAII0_i,
   AdmsSensFadType & instanceVar_BETAII1_i,
   AdmsSensFadType & instanceVar_BETAII2_i,
   AdmsSensFadType & instanceVar_ESATII_i,
   AdmsSensFadType & instanceVar_LII_i,
   AdmsSensFadType & instanceVar_SII0_i,
   AdmsSensFadType & instanceVar_SII1_i,
   AdmsSensFadType & instanceVar_SII2_i,
   AdmsSensFadType & instanceVar_SIID_i,
   AdmsSensFadType & instanceVar_TII_i,
   AdmsSensFadType & instanceVar_MEXP_i,
   AdmsSensFadType & instanceVar_MEXPR_i,
   AdmsSensFadType & instanceVar_PCLM_i,
   AdmsSensFadType & instanceVar_PCLMG_i,
   AdmsSensFadType & instanceVar_PCLMCV_i,
   AdmsSensFadType & instanceVar_PCLMR_i,
   AdmsSensFadType & instanceVar_A1_i,
   AdmsSensFadType & instanceVar_A2_i,
   AdmsSensFadType & instanceVar_A11_i,
   AdmsSensFadType & instanceVar_A21_i,
   AdmsSensFadType & instanceVar_K1RSCE_i,
   AdmsSensFadType & instanceVar_DVTSHIFT_i,
   AdmsSensFadType & instanceVar_DVTSHIFTR_i,
   AdmsSensFadType & instanceVar_UA_i,
   AdmsSensFadType & instanceVar_UC_i,
   AdmsSensFadType & instanceVar_EU_i,
   AdmsSensFadType & instanceVar_UD_i,
   AdmsSensFadType & instanceVar_UCS_i,
   AdmsSensFadType & instanceVar_UAR_i,
   AdmsSensFadType & instanceVar_EUR_i,
   AdmsSensFadType & instanceVar_UCR_i,
   AdmsSensFadType & instanceVar_UDR_i,
   AdmsSensFadType & instanceVar_UA1_i,
   AdmsSensFadType & instanceVar_UA1R_i,
   AdmsSensFadType & instanceVar_UC1_i,
   AdmsSensFadType & instanceVar_UD1_i,
   AdmsSensFadType & instanceVar_UCSTE_i,
   AdmsSensFadType & instanceVar_UTE_i,
   AdmsSensFadType & instanceVar_UTL_i,
   AdmsSensFadType & instanceVar_EMOBT_i,
   AdmsSensFadType & instanceVar_UC1R_i,
   AdmsSensFadType & instanceVar_UD1R_i,
   AdmsSensFadType & instanceVar_UTER_i,
   AdmsSensFadType & instanceVar_UTLR_i,
   AdmsSensFadType & instanceVar_PTWGT_i,
   AdmsSensFadType & instanceVar_AT_i,
   AdmsSensFadType & instanceVar_ATCV_i,
   AdmsSensFadType & instanceVar_ATR_i,
   AdmsSensFadType & instanceVar_RDW_i,
   AdmsSensFadType & instanceVar_RSW_i,
   AdmsSensFadType & instanceVar_PRT_i,
   AdmsSensFadType & instanceVar_KT1_i,
   AdmsSensFadType & instanceVar_TSS_i,
   AdmsSensFadType & instanceVar_IIT_i,
   AdmsSensFadType & instanceVar_IGT_i,
   AdmsSensFadType & instanceVar_TGIDL_i,
   AdmsSensFadType & instanceVar_NTGEN_i,
   AdmsSensFadType & instanceVar_AIGEN_i,
   AdmsSensFadType & instanceVar_BIGEN_i,
   AdmsSensFadType & instanceVar_K0SISAT_i,
   AdmsSensFadType & instanceVar_K0SISAT1_i,
   AdmsSensFadType & instanceVar_K2SISAT_i,
   AdmsSensFadType & instanceVar_K2SISAT1_i,
   AdmsSensFadType & instanceVar_K2_i,
   AdmsSensFadType & instanceVar_K21_i,
   AdmsSensFadType & instanceVar_Cins,
   AdmsSensFadType & instanceVar_Ach,
   AdmsSensFadType & instanceVar_Weff_UFCM,
   AdmsSensFadType & instanceVar_qdep,
   AdmsSensFadType & instanceVar_rc,
   AdmsSensFadType & instanceVar_vth_fixed_factor_Sub,
   AdmsSensFadType & instanceVar_vth_fixed_factor_SI,
   AdmsSensFadType & instanceVar_qm,
   AdmsSensFadType & instanceVar_Qdep_ov_Cins,
   AdmsSensFadType & instanceVar_qi_acc_for_QM,
   AdmsSensFadType & instanceVar_fieldnormalizationfactor,
   double & instanceVar_auxQMfact,
   AdmsSensFadType & instanceVar_QMFACTORCVfinal,
   AdmsSensFadType & instanceVar_psipclamp,
   AdmsSensFadType & instanceVar_sqrtpsip,
   AdmsSensFadType & instanceVar_nq,
   AdmsSensFadType & instanceVar_F0,
   // non-reals
   int instanceVar_devsign,
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature,double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance);

void evaluateInitialModel(
   // model parameters
   // reals
   AdmsSensFadType & modelPar_L,
   bool modelPar_given_L,
   AdmsSensFadType & modelPar_D,
   bool modelPar_given_D,
   AdmsSensFadType & modelPar_TFIN,
   bool modelPar_given_TFIN,
   AdmsSensFadType & modelPar_FPITCH,
   bool modelPar_given_FPITCH,
   AdmsSensFadType & modelPar_NFIN,
   bool modelPar_given_NFIN,
   AdmsSensFadType & modelPar_ASEO,
   bool modelPar_given_ASEO,
   AdmsSensFadType & modelPar_ADEO,
   bool modelPar_given_ADEO,
   AdmsSensFadType & modelPar_PSEO,
   bool modelPar_given_PSEO,
   AdmsSensFadType & modelPar_PDEO,
   bool modelPar_given_PDEO,
   AdmsSensFadType & modelPar_ASEJ,
   bool modelPar_given_ASEJ,
   AdmsSensFadType & modelPar_ADEJ,
   bool modelPar_given_ADEJ,
   AdmsSensFadType & modelPar_PSEJ,
   bool modelPar_given_PSEJ,
   AdmsSensFadType & modelPar_PDEJ,
   bool modelPar_given_PDEJ,
   AdmsSensFadType & modelPar_COVS,
   bool modelPar_given_COVS,
   AdmsSensFadType & modelPar_COVD,
   bool modelPar_given_COVD,
   AdmsSensFadType & modelPar_CGSP,
   bool modelPar_given_CGSP,
   AdmsSensFadType & modelPar_CGDP,
   bool modelPar_given_CGDP,
   AdmsSensFadType & modelPar_CDSP,
   bool modelPar_given_CDSP,
   AdmsSensFadType & modelPar_NRS,
   bool modelPar_given_NRS,
   AdmsSensFadType & modelPar_NRD,
   bool modelPar_given_NRD,
   AdmsSensFadType & modelPar_LRSD,
   bool modelPar_given_LRSD,
   AdmsSensFadType & modelPar_XL,
   bool modelPar_given_XL,
   AdmsSensFadType & modelPar_DTEMP,
   bool modelPar_given_DTEMP,
   AdmsSensFadType & modelPar_DELVTRAND,
   bool modelPar_given_DELVTRAND,
   AdmsSensFadType & modelPar_U0MULT,
   bool modelPar_given_U0MULT,
   AdmsSensFadType & modelPar_IDS0MULT,
   bool modelPar_given_IDS0MULT,
   AdmsSensFadType & modelPar_LINT,
   bool modelPar_given_LINT,
   AdmsSensFadType & modelPar_LL,
   bool modelPar_given_LL,
   AdmsSensFadType & modelPar_LLN,
   bool modelPar_given_LLN,
   AdmsSensFadType & modelPar_DLC,
   bool modelPar_given_DLC,
   AdmsSensFadType & modelPar_DLCACC,
   bool modelPar_given_DLCACC,
   AdmsSensFadType & modelPar_DLBIN,
   bool modelPar_given_DLBIN,
   AdmsSensFadType & modelPar_LLC,
   bool modelPar_given_LLC,
   AdmsSensFadType & modelPar_EOT,
   bool modelPar_given_EOT,
   AdmsSensFadType & modelPar_TOXP,
   bool modelPar_given_TOXP,
   AdmsSensFadType & modelPar_EOTBOX,
   bool modelPar_given_EOTBOX,
   AdmsSensFadType & modelPar_HFIN,
   bool modelPar_given_HFIN,
   AdmsSensFadType & modelPar_FECH,
   bool modelPar_given_FECH,
   AdmsSensFadType & modelPar_DELTAW,
   bool modelPar_given_DELTAW,
   AdmsSensFadType & modelPar_FECHCV,
   bool modelPar_given_FECHCV,
   AdmsSensFadType & modelPar_DELTAWCV,
   bool modelPar_given_DELTAWCV,
   AdmsSensFadType & modelPar_NBODY,
   bool modelPar_given_NBODY,
   AdmsSensFadType & modelPar_NBODYN1,
   bool modelPar_given_NBODYN1,
   AdmsSensFadType & modelPar_NBODYN2,
   bool modelPar_given_NBODYN2,
   AdmsSensFadType & modelPar_NSD,
   bool modelPar_given_NSD,
   AdmsSensFadType & modelPar_PHIG,
   bool modelPar_given_PHIG,
   AdmsSensFadType & modelPar_PHIGL,
   bool modelPar_given_PHIGL,
   AdmsSensFadType & modelPar_PHIGLT,
   bool modelPar_given_PHIGLT,
   AdmsSensFadType & modelPar_PHIGN1,
   bool modelPar_given_PHIGN1,
   AdmsSensFadType & modelPar_PHIGN2,
   bool modelPar_given_PHIGN2,
   AdmsSensFadType & modelPar_EPSROX,
   bool modelPar_given_EPSROX,
   AdmsSensFadType & modelPar_EPSRSUB,
   bool modelPar_given_EPSRSUB,
   AdmsSensFadType & modelPar_EASUB,
   bool modelPar_given_EASUB,
   AdmsSensFadType & modelPar_NI0SUB,
   bool modelPar_given_NI0SUB,
   AdmsSensFadType & modelPar_BG0SUB,
   bool modelPar_given_BG0SUB,
   AdmsSensFadType & modelPar_NC0SUB,
   bool modelPar_given_NC0SUB,
   AdmsSensFadType & modelPar_NGATE,
   bool modelPar_given_NGATE,
   AdmsSensFadType & modelPar_Imin,
   bool modelPar_given_Imin,
   AdmsSensFadType & modelPar_CIT,
   bool modelPar_given_CIT,
   AdmsSensFadType & modelPar_CITR,
   bool modelPar_given_CITR,
   AdmsSensFadType & modelPar_CDSC,
   bool modelPar_given_CDSC,
   AdmsSensFadType & modelPar_CDSCN1,
   bool modelPar_given_CDSCN1,
   AdmsSensFadType & modelPar_CDSCN2,
   bool modelPar_given_CDSCN2,
   AdmsSensFadType & modelPar_CDSCD,
   bool modelPar_given_CDSCD,
   AdmsSensFadType & modelPar_CDSCDN1,
   bool modelPar_given_CDSCDN1,
   AdmsSensFadType & modelPar_CDSCDN2,
   bool modelPar_given_CDSCDN2,
   AdmsSensFadType & modelPar_CDSCDR,
   bool modelPar_given_CDSCDR,
   AdmsSensFadType & modelPar_CDSCDRN1,
   bool modelPar_given_CDSCDRN1,
   AdmsSensFadType & modelPar_CDSCDRN2,
   bool modelPar_given_CDSCDRN2,
   AdmsSensFadType & modelPar_DVT0,
   bool modelPar_given_DVT0,
   AdmsSensFadType & modelPar_DVT1,
   bool modelPar_given_DVT1,
   AdmsSensFadType & modelPar_DVT1SS,
   bool modelPar_given_DVT1SS,
   AdmsSensFadType & modelPar_PHIN,
   bool modelPar_given_PHIN,
   AdmsSensFadType & modelPar_ETA0,
   bool modelPar_given_ETA0,
   AdmsSensFadType & modelPar_ETA0N1,
   bool modelPar_given_ETA0N1,
   AdmsSensFadType & modelPar_ETA0N2,
   bool modelPar_given_ETA0N2,
   AdmsSensFadType & modelPar_ETA0LT,
   bool modelPar_given_ETA0LT,
   AdmsSensFadType & modelPar_TETA0,
   bool modelPar_given_TETA0,
   AdmsSensFadType & modelPar_ETA0R,
   bool modelPar_given_ETA0R,
   AdmsSensFadType & modelPar_TETA0R,
   bool modelPar_given_TETA0R,
   AdmsSensFadType & modelPar_DSUB,
   bool modelPar_given_DSUB,
   AdmsSensFadType & modelPar_DVTP0,
   bool modelPar_given_DVTP0,
   AdmsSensFadType & modelPar_DVTP1,
   bool modelPar_given_DVTP1,
   AdmsSensFadType & modelPar_ADVTP0,
   bool modelPar_given_ADVTP0,
   AdmsSensFadType & modelPar_BDVTP0,
   bool modelPar_given_BDVTP0,
   AdmsSensFadType & modelPar_ADVTP1,
   bool modelPar_given_ADVTP1,
   AdmsSensFadType & modelPar_BDVTP1,
   bool modelPar_given_BDVTP1,
   AdmsSensFadType & modelPar_DVTP2,
   bool modelPar_given_DVTP2,
   AdmsSensFadType & modelPar_K1RSCE,
   bool modelPar_given_K1RSCE,
   AdmsSensFadType & modelPar_LPE0,
   bool modelPar_given_LPE0,
   AdmsSensFadType & modelPar_DVTSHIFT,
   bool modelPar_given_DVTSHIFT,
   AdmsSensFadType & modelPar_DVTSHIFTR,
   bool modelPar_given_DVTSHIFTR,
   AdmsSensFadType & modelPar_THETASCE,
   bool modelPar_given_THETASCE,
   AdmsSensFadType & modelPar_THETADIBL,
   bool modelPar_given_THETADIBL,
   AdmsSensFadType & modelPar_THETASW,
   bool modelPar_given_THETASW,
   AdmsSensFadType & modelPar_NVTM,
   bool modelPar_given_NVTM,
   AdmsSensFadType & modelPar_K0,
   bool modelPar_given_K0,
   AdmsSensFadType & modelPar_K01,
   bool modelPar_given_K01,
   AdmsSensFadType & modelPar_K0SI,
   bool modelPar_given_K0SI,
   AdmsSensFadType & modelPar_K0SI1,
   bool modelPar_given_K0SI1,
   AdmsSensFadType & modelPar_K2SI,
   bool modelPar_given_K2SI,
   AdmsSensFadType & modelPar_K2SI1,
   bool modelPar_given_K2SI1,
   AdmsSensFadType & modelPar_K0SISAT,
   bool modelPar_given_K0SISAT,
   AdmsSensFadType & modelPar_K0SISAT1,
   bool modelPar_given_K0SISAT1,
   AdmsSensFadType & modelPar_K2SISAT,
   bool modelPar_given_K2SISAT,
   AdmsSensFadType & modelPar_K2SISAT1,
   bool modelPar_given_K2SISAT1,
   AdmsSensFadType & modelPar_PHIBE,
   bool modelPar_given_PHIBE,
   AdmsSensFadType & modelPar_K1,
   bool modelPar_given_K1,
   AdmsSensFadType & modelPar_K11,
   bool modelPar_given_K11,
   AdmsSensFadType & modelPar_K2SAT,
   bool modelPar_given_K2SAT,
   AdmsSensFadType & modelPar_K2SAT1,
   bool modelPar_given_K2SAT1,
   AdmsSensFadType & modelPar_K2,
   bool modelPar_given_K2,
   AdmsSensFadType & modelPar_K21,
   bool modelPar_given_K21,
   AdmsSensFadType & modelPar_QMFACTOR,
   bool modelPar_given_QMFACTOR,
   AdmsSensFadType & modelPar_QMTCENCV,
   bool modelPar_given_QMTCENCV,
   AdmsSensFadType & modelPar_QMTCENCVA,
   bool modelPar_given_QMTCENCVA,
   AdmsSensFadType & modelPar_AQMTCEN,
   bool modelPar_given_AQMTCEN,
   AdmsSensFadType & modelPar_BQMTCEN,
   bool modelPar_given_BQMTCEN,
   AdmsSensFadType & modelPar_ETAQM,
   bool modelPar_given_ETAQM,
   AdmsSensFadType & modelPar_QM0,
   bool modelPar_given_QM0,
   AdmsSensFadType & modelPar_PQM,
   bool modelPar_given_PQM,
   AdmsSensFadType & modelPar_QM0ACC,
   bool modelPar_given_QM0ACC,
   AdmsSensFadType & modelPar_PQMACC,
   bool modelPar_given_PQMACC,
   AdmsSensFadType & modelPar_VSAT,
   bool modelPar_given_VSAT,
   AdmsSensFadType & modelPar_VSATR,
   bool modelPar_given_VSATR,
   AdmsSensFadType & modelPar_VSATN1,
   bool modelPar_given_VSATN1,
   AdmsSensFadType & modelPar_VSATN2,
   bool modelPar_given_VSATN2,
   AdmsSensFadType & modelPar_VSATRN1,
   bool modelPar_given_VSATRN1,
   AdmsSensFadType & modelPar_VSATRN2,
   bool modelPar_given_VSATRN2,
   AdmsSensFadType & modelPar_AVSAT,
   bool modelPar_given_AVSAT,
   AdmsSensFadType & modelPar_BVSAT,
   bool modelPar_given_BVSAT,
   AdmsSensFadType & modelPar_VSAT1,
   bool modelPar_given_VSAT1,
   AdmsSensFadType & modelPar_VSAT1N1,
   bool modelPar_given_VSAT1N1,
   AdmsSensFadType & modelPar_VSAT1N2,
   bool modelPar_given_VSAT1N2,
   AdmsSensFadType & modelPar_VSAT1R,
   bool modelPar_given_VSAT1R,
   AdmsSensFadType & modelPar_VSAT1RN1,
   bool modelPar_given_VSAT1RN1,
   AdmsSensFadType & modelPar_VSAT1RN2,
   bool modelPar_given_VSAT1RN2,
   AdmsSensFadType & modelPar_AVSAT1,
   bool modelPar_given_AVSAT1,
   AdmsSensFadType & modelPar_BVSAT1,
   bool modelPar_given_BVSAT1,
   AdmsSensFadType & modelPar_DELTAVSAT,
   bool modelPar_given_DELTAVSAT,
   AdmsSensFadType & modelPar_PSAT,
   bool modelPar_given_PSAT,
   AdmsSensFadType & modelPar_APSAT,
   bool modelPar_given_APSAT,
   AdmsSensFadType & modelPar_BPSAT,
   bool modelPar_given_BPSAT,
   AdmsSensFadType & modelPar_KSATIV,
   bool modelPar_given_KSATIV,
   AdmsSensFadType & modelPar_KSATIVR,
   bool modelPar_given_KSATIVR,
   AdmsSensFadType & modelPar_VSATCV,
   bool modelPar_given_VSATCV,
   AdmsSensFadType & modelPar_AVSATCV,
   bool modelPar_given_AVSATCV,
   AdmsSensFadType & modelPar_BVSATCV,
   bool modelPar_given_BVSATCV,
   AdmsSensFadType & modelPar_DELTAVSATCV,
   bool modelPar_given_DELTAVSATCV,
   AdmsSensFadType & modelPar_PSATCV,
   bool modelPar_given_PSATCV,
   AdmsSensFadType & modelPar_APSATCV,
   bool modelPar_given_APSATCV,
   AdmsSensFadType & modelPar_BPSATCV,
   bool modelPar_given_BPSATCV,
   AdmsSensFadType & modelPar_MEXP,
   bool modelPar_given_MEXP,
   AdmsSensFadType & modelPar_AMEXP,
   bool modelPar_given_AMEXP,
   AdmsSensFadType & modelPar_BMEXP,
   bool modelPar_given_BMEXP,
   AdmsSensFadType & modelPar_MEXPR,
   bool modelPar_given_MEXPR,
   AdmsSensFadType & modelPar_AMEXPR,
   bool modelPar_given_AMEXPR,
   AdmsSensFadType & modelPar_BMEXPR,
   bool modelPar_given_BMEXPR,
   AdmsSensFadType & modelPar_PTWG,
   bool modelPar_given_PTWG,
   AdmsSensFadType & modelPar_PTWGR,
   bool modelPar_given_PTWGR,
   AdmsSensFadType & modelPar_APTWG,
   bool modelPar_given_APTWG,
   AdmsSensFadType & modelPar_BPTWG,
   bool modelPar_given_BPTWG,
   AdmsSensFadType & modelPar_AT,
   bool modelPar_given_AT,
   AdmsSensFadType & modelPar_ATR,
   bool modelPar_given_ATR,
   AdmsSensFadType & modelPar_ATCV,
   bool modelPar_given_ATCV,
   AdmsSensFadType & modelPar_TMEXP,
   bool modelPar_given_TMEXP,
   AdmsSensFadType & modelPar_TMEXPR,
   bool modelPar_given_TMEXPR,
   AdmsSensFadType & modelPar_PTWGT,
   bool modelPar_given_PTWGT,
   AdmsSensFadType & modelPar_U0,
   bool modelPar_given_U0,
   AdmsSensFadType & modelPar_U0R,
   bool modelPar_given_U0R,
   AdmsSensFadType & modelPar_U0N1,
   bool modelPar_given_U0N1,
   AdmsSensFadType & modelPar_U0N1R,
   bool modelPar_given_U0N1R,
   AdmsSensFadType & modelPar_U0N2,
   bool modelPar_given_U0N2,
   AdmsSensFadType & modelPar_U0N2R,
   bool modelPar_given_U0N2R,
   AdmsSensFadType & modelPar_U0LT,
   bool modelPar_given_U0LT,
   AdmsSensFadType & modelPar_ETAMOB,
   bool modelPar_given_ETAMOB,
   AdmsSensFadType & modelPar_UP,
   bool modelPar_given_UP,
   AdmsSensFadType & modelPar_LPA,
   bool modelPar_given_LPA,
   AdmsSensFadType & modelPar_UPR,
   bool modelPar_given_UPR,
   AdmsSensFadType & modelPar_LPAR,
   bool modelPar_given_LPAR,
   AdmsSensFadType & modelPar_UA,
   bool modelPar_given_UA,
   AdmsSensFadType & modelPar_UAR,
   bool modelPar_given_UAR,
   AdmsSensFadType & modelPar_AUA,
   bool modelPar_given_AUA,
   AdmsSensFadType & modelPar_AUAR,
   bool modelPar_given_AUAR,
   AdmsSensFadType & modelPar_BUA,
   bool modelPar_given_BUA,
   AdmsSensFadType & modelPar_BUAR,
   bool modelPar_given_BUAR,
   AdmsSensFadType & modelPar_UC,
   bool modelPar_given_UC,
   AdmsSensFadType & modelPar_UCR,
   bool modelPar_given_UCR,
   AdmsSensFadType & modelPar_EU,
   bool modelPar_given_EU,
   AdmsSensFadType & modelPar_EUR,
   bool modelPar_given_EUR,
   AdmsSensFadType & modelPar_AEU,
   bool modelPar_given_AEU,
   AdmsSensFadType & modelPar_AEUR,
   bool modelPar_given_AEUR,
   AdmsSensFadType & modelPar_BEU,
   bool modelPar_given_BEU,
   AdmsSensFadType & modelPar_BEUR,
   bool modelPar_given_BEUR,
   AdmsSensFadType & modelPar_UD,
   bool modelPar_given_UD,
   AdmsSensFadType & modelPar_UDR,
   bool modelPar_given_UDR,
   AdmsSensFadType & modelPar_AUD,
   bool modelPar_given_AUD,
   AdmsSensFadType & modelPar_AUDR,
   bool modelPar_given_AUDR,
   AdmsSensFadType & modelPar_BUD,
   bool modelPar_given_BUD,
   AdmsSensFadType & modelPar_BUDR,
   bool modelPar_given_BUDR,
   AdmsSensFadType & modelPar_UCS,
   bool modelPar_given_UCS,
   AdmsSensFadType & modelPar_UTE,
   bool modelPar_given_UTE,
   AdmsSensFadType & modelPar_UTER,
   bool modelPar_given_UTER,
   AdmsSensFadType & modelPar_UTL,
   bool modelPar_given_UTL,
   AdmsSensFadType & modelPar_UTLR,
   bool modelPar_given_UTLR,
   AdmsSensFadType & modelPar_EMOBT,
   bool modelPar_given_EMOBT,
   AdmsSensFadType & modelPar_UA1,
   bool modelPar_given_UA1,
   AdmsSensFadType & modelPar_UA1R,
   bool modelPar_given_UA1R,
   AdmsSensFadType & modelPar_UC1,
   bool modelPar_given_UC1,
   AdmsSensFadType & modelPar_UC1R,
   bool modelPar_given_UC1R,
   AdmsSensFadType & modelPar_UD1,
   bool modelPar_given_UD1,
   AdmsSensFadType & modelPar_UD1R,
   bool modelPar_given_UD1R,
   AdmsSensFadType & modelPar_UCSTE,
   bool modelPar_given_UCSTE,
   AdmsSensFadType & modelPar_CHARGEWF,
   bool modelPar_given_CHARGEWF,
   AdmsSensFadType & modelPar_RDSWMIN,
   bool modelPar_given_RDSWMIN,
   AdmsSensFadType & modelPar_RDSW,
   bool modelPar_given_RDSW,
   AdmsSensFadType & modelPar_ARDSW,
   bool modelPar_given_ARDSW,
   AdmsSensFadType & modelPar_BRDSW,
   bool modelPar_given_BRDSW,
   AdmsSensFadType & modelPar_RSWMIN,
   bool modelPar_given_RSWMIN,
   AdmsSensFadType & modelPar_RSW,
   bool modelPar_given_RSW,
   AdmsSensFadType & modelPar_ARSW,
   bool modelPar_given_ARSW,
   AdmsSensFadType & modelPar_BRSW,
   bool modelPar_given_BRSW,
   AdmsSensFadType & modelPar_RDWMIN,
   bool modelPar_given_RDWMIN,
   AdmsSensFadType & modelPar_RDW,
   bool modelPar_given_RDW,
   AdmsSensFadType & modelPar_ARDW,
   bool modelPar_given_ARDW,
   AdmsSensFadType & modelPar_BRDW,
   bool modelPar_given_BRDW,
   AdmsSensFadType & modelPar_RSDR,
   bool modelPar_given_RSDR,
   AdmsSensFadType & modelPar_RSDRR,
   bool modelPar_given_RSDRR,
   AdmsSensFadType & modelPar_RDDR,
   bool modelPar_given_RDDR,
   AdmsSensFadType & modelPar_RDDRR,
   bool modelPar_given_RDDRR,
   AdmsSensFadType & modelPar_PRSDR,
   bool modelPar_given_PRSDR,
   AdmsSensFadType & modelPar_PRDDR,
   bool modelPar_given_PRDDR,
   AdmsSensFadType & modelPar_PRWGS,
   bool modelPar_given_PRWGS,
   AdmsSensFadType & modelPar_PRWGD,
   bool modelPar_given_PRWGD,
   AdmsSensFadType & modelPar_WR,
   bool modelPar_given_WR,
   AdmsSensFadType & modelPar_PRT,
   bool modelPar_given_PRT,
   AdmsSensFadType & modelPar_TRSDR,
   bool modelPar_given_TRSDR,
   AdmsSensFadType & modelPar_TRDDR,
   bool modelPar_given_TRDDR,
   AdmsSensFadType & modelPar_PDIBL1,
   bool modelPar_given_PDIBL1,
   AdmsSensFadType & modelPar_PDIBL1R,
   bool modelPar_given_PDIBL1R,
   AdmsSensFadType & modelPar_PDIBL2,
   bool modelPar_given_PDIBL2,
   AdmsSensFadType & modelPar_PDIBL2R,
   bool modelPar_given_PDIBL2R,
   AdmsSensFadType & modelPar_DROUT,
   bool modelPar_given_DROUT,
   AdmsSensFadType & modelPar_PVAG,
   bool modelPar_given_PVAG,
   AdmsSensFadType & modelPar_PCLM,
   bool modelPar_given_PCLM,
   AdmsSensFadType & modelPar_PCLMR,
   bool modelPar_given_PCLMR,
   AdmsSensFadType & modelPar_APCLM,
   bool modelPar_given_APCLM,
   AdmsSensFadType & modelPar_APCLMR,
   bool modelPar_given_APCLMR,
   AdmsSensFadType & modelPar_BPCLM,
   bool modelPar_given_BPCLM,
   AdmsSensFadType & modelPar_BPCLMR,
   bool modelPar_given_BPCLMR,
   AdmsSensFadType & modelPar_PCLMG,
   bool modelPar_given_PCLMG,
   AdmsSensFadType & modelPar_PCLMCV,
   bool modelPar_given_PCLMCV,
   AdmsSensFadType & modelPar_A1,
   bool modelPar_given_A1,
   AdmsSensFadType & modelPar_A11,
   bool modelPar_given_A11,
   AdmsSensFadType & modelPar_A2,
   bool modelPar_given_A2,
   AdmsSensFadType & modelPar_A21,
   bool modelPar_given_A21,
   AdmsSensFadType & modelPar_RGEXT,
   bool modelPar_given_RGEXT,
   AdmsSensFadType & modelPar_RGFIN,
   bool modelPar_given_RGFIN,
   AdmsSensFadType & modelPar_RSHS,
   bool modelPar_given_RSHS,
   AdmsSensFadType & modelPar_RSHD,
   bool modelPar_given_RSHD,
   AdmsSensFadType & modelPar_HEPI,
   bool modelPar_given_HEPI,
   AdmsSensFadType & modelPar_TSILI,
   bool modelPar_given_TSILI,
   AdmsSensFadType & modelPar_RHOC,
   bool modelPar_given_RHOC,
   AdmsSensFadType & modelPar_RHORSD,
   bool modelPar_given_RHORSD,
   AdmsSensFadType & modelPar_CRATIO,
   bool modelPar_given_CRATIO,
   AdmsSensFadType & modelPar_DELTAPRSD,
   bool modelPar_given_DELTAPRSD,
   AdmsSensFadType & modelPar_LSP,
   bool modelPar_given_LSP,
   AdmsSensFadType & modelPar_EPSRSP,
   bool modelPar_given_EPSRSP,
   AdmsSensFadType & modelPar_TGATE,
   bool modelPar_given_TGATE,
   AdmsSensFadType & modelPar_TMASK,
   bool modelPar_given_TMASK,
   AdmsSensFadType & modelPar_ASILIEND,
   bool modelPar_given_ASILIEND,
   AdmsSensFadType & modelPar_ARSDEND,
   bool modelPar_given_ARSDEND,
   AdmsSensFadType & modelPar_PRSDEND,
   bool modelPar_given_PRSDEND,
   AdmsSensFadType & modelPar_NSDE,
   bool modelPar_given_NSDE,
   AdmsSensFadType & modelPar_RGEOA,
   bool modelPar_given_RGEOA,
   AdmsSensFadType & modelPar_RGEOB,
   bool modelPar_given_RGEOB,
   AdmsSensFadType & modelPar_RGEOC,
   bool modelPar_given_RGEOC,
   AdmsSensFadType & modelPar_RGEOD,
   bool modelPar_given_RGEOD,
   AdmsSensFadType & modelPar_RGEOE,
   bool modelPar_given_RGEOE,
   AdmsSensFadType & modelPar_CGEOA,
   bool modelPar_given_CGEOA,
   AdmsSensFadType & modelPar_CGEOB,
   bool modelPar_given_CGEOB,
   AdmsSensFadType & modelPar_CGEOC,
   bool modelPar_given_CGEOC,
   AdmsSensFadType & modelPar_CGEOD,
   bool modelPar_given_CGEOD,
   AdmsSensFadType & modelPar_CGEOE,
   bool modelPar_given_CGEOE,
   AdmsSensFadType & modelPar_AIGBINV,
   bool modelPar_given_AIGBINV,
   AdmsSensFadType & modelPar_AIGBINV1,
   bool modelPar_given_AIGBINV1,
   AdmsSensFadType & modelPar_BIGBINV,
   bool modelPar_given_BIGBINV,
   AdmsSensFadType & modelPar_CIGBINV,
   bool modelPar_given_CIGBINV,
   AdmsSensFadType & modelPar_EIGBINV,
   bool modelPar_given_EIGBINV,
   AdmsSensFadType & modelPar_NIGBINV,
   bool modelPar_given_NIGBINV,
   AdmsSensFadType & modelPar_AIGBACC,
   bool modelPar_given_AIGBACC,
   AdmsSensFadType & modelPar_AIGBACC1,
   bool modelPar_given_AIGBACC1,
   AdmsSensFadType & modelPar_BIGBACC,
   bool modelPar_given_BIGBACC,
   AdmsSensFadType & modelPar_CIGBACC,
   bool modelPar_given_CIGBACC,
   AdmsSensFadType & modelPar_NIGBACC,
   bool modelPar_given_NIGBACC,
   AdmsSensFadType & modelPar_AIGC,
   bool modelPar_given_AIGC,
   AdmsSensFadType & modelPar_AIGC1,
   bool modelPar_given_AIGC1,
   AdmsSensFadType & modelPar_BIGC,
   bool modelPar_given_BIGC,
   AdmsSensFadType & modelPar_CIGC,
   bool modelPar_given_CIGC,
   AdmsSensFadType & modelPar_PIGCD,
   bool modelPar_given_PIGCD,
   AdmsSensFadType & modelPar_DLCIGS,
   bool modelPar_given_DLCIGS,
   AdmsSensFadType & modelPar_AIGS,
   bool modelPar_given_AIGS,
   AdmsSensFadType & modelPar_AIGS1,
   bool modelPar_given_AIGS1,
   AdmsSensFadType & modelPar_BIGS,
   bool modelPar_given_BIGS,
   AdmsSensFadType & modelPar_CIGS,
   bool modelPar_given_CIGS,
   AdmsSensFadType & modelPar_DLCIGD,
   bool modelPar_given_DLCIGD,
   AdmsSensFadType & modelPar_AIGD,
   bool modelPar_given_AIGD,
   AdmsSensFadType & modelPar_AIGD1,
   bool modelPar_given_AIGD1,
   AdmsSensFadType & modelPar_BIGD,
   bool modelPar_given_BIGD,
   AdmsSensFadType & modelPar_CIGD,
   bool modelPar_given_CIGD,
   AdmsSensFadType & modelPar_VFBSD,
   bool modelPar_given_VFBSD,
   AdmsSensFadType & modelPar_VFBSDCV,
   bool modelPar_given_VFBSDCV,
   AdmsSensFadType & modelPar_TOXREF,
   bool modelPar_given_TOXREF,
   AdmsSensFadType & modelPar_TOXG,
   bool modelPar_given_TOXG,
   AdmsSensFadType & modelPar_NTOX,
   bool modelPar_given_NTOX,
   AdmsSensFadType & modelPar_POXEDGE,
   bool modelPar_given_POXEDGE,
   AdmsSensFadType & modelPar_AGISL,
   bool modelPar_given_AGISL,
   AdmsSensFadType & modelPar_BGISL,
   bool modelPar_given_BGISL,
   AdmsSensFadType & modelPar_CGISL,
   bool modelPar_given_CGISL,
   AdmsSensFadType & modelPar_EGISL,
   bool modelPar_given_EGISL,
   AdmsSensFadType & modelPar_PGISL,
   bool modelPar_given_PGISL,
   AdmsSensFadType & modelPar_AGIDL,
   bool modelPar_given_AGIDL,
   AdmsSensFadType & modelPar_BGIDL,
   bool modelPar_given_BGIDL,
   AdmsSensFadType & modelPar_CGIDL,
   bool modelPar_given_CGIDL,
   AdmsSensFadType & modelPar_EGIDL,
   bool modelPar_given_EGIDL,
   AdmsSensFadType & modelPar_PGIDL,
   bool modelPar_given_PGIDL,
   AdmsSensFadType & modelPar_ALPHA0,
   bool modelPar_given_ALPHA0,
   AdmsSensFadType & modelPar_ALPHA01,
   bool modelPar_given_ALPHA01,
   AdmsSensFadType & modelPar_ALPHA1,
   bool modelPar_given_ALPHA1,
   AdmsSensFadType & modelPar_ALPHA11,
   bool modelPar_given_ALPHA11,
   AdmsSensFadType & modelPar_BETA0,
   bool modelPar_given_BETA0,
   AdmsSensFadType & modelPar_ALPHAII0,
   bool modelPar_given_ALPHAII0,
   AdmsSensFadType & modelPar_ALPHAII01,
   bool modelPar_given_ALPHAII01,
   AdmsSensFadType & modelPar_ALPHAII1,
   bool modelPar_given_ALPHAII1,
   AdmsSensFadType & modelPar_ALPHAII11,
   bool modelPar_given_ALPHAII11,
   AdmsSensFadType & modelPar_BETAII0,
   bool modelPar_given_BETAII0,
   AdmsSensFadType & modelPar_BETAII1,
   bool modelPar_given_BETAII1,
   AdmsSensFadType & modelPar_BETAII2,
   bool modelPar_given_BETAII2,
   AdmsSensFadType & modelPar_ESATII,
   bool modelPar_given_ESATII,
   AdmsSensFadType & modelPar_LII,
   bool modelPar_given_LII,
   AdmsSensFadType & modelPar_SII0,
   bool modelPar_given_SII0,
   AdmsSensFadType & modelPar_SII1,
   bool modelPar_given_SII1,
   AdmsSensFadType & modelPar_SII2,
   bool modelPar_given_SII2,
   AdmsSensFadType & modelPar_SIID,
   bool modelPar_given_SIID,
   AdmsSensFadType & modelPar_IIMOD2CLAMP1,
   bool modelPar_given_IIMOD2CLAMP1,
   AdmsSensFadType & modelPar_IIMOD2CLAMP2,
   bool modelPar_given_IIMOD2CLAMP2,
   AdmsSensFadType & modelPar_IIMOD2CLAMP3,
   bool modelPar_given_IIMOD2CLAMP3,
   AdmsSensFadType & modelPar_EOTACC,
   bool modelPar_given_EOTACC,
   AdmsSensFadType & modelPar_DELVFBACC,
   bool modelPar_given_DELVFBACC,
   AdmsSensFadType & modelPar_CFS,
   bool modelPar_given_CFS,
   AdmsSensFadType & modelPar_CFD,
   bool modelPar_given_CFD,
   AdmsSensFadType & modelPar_CGSO,
   bool modelPar_given_CGSO,
   AdmsSensFadType & modelPar_CGDO,
   bool modelPar_given_CGDO,
   AdmsSensFadType & modelPar_CGSL,
   bool modelPar_given_CGSL,
   AdmsSensFadType & modelPar_CGDL,
   bool modelPar_given_CGDL,
   AdmsSensFadType & modelPar_CKAPPAS,
   bool modelPar_given_CKAPPAS,
   AdmsSensFadType & modelPar_CKAPPAD,
   bool modelPar_given_CKAPPAD,
   AdmsSensFadType & modelPar_CGBO,
   bool modelPar_given_CGBO,
   AdmsSensFadType & modelPar_CGBN,
   bool modelPar_given_CGBN,
   AdmsSensFadType & modelPar_CGBL,
   bool modelPar_given_CGBL,
   AdmsSensFadType & modelPar_CKAPPAB,
   bool modelPar_given_CKAPPAB,
   AdmsSensFadType & modelPar_CSDESW,
   bool modelPar_given_CSDESW,
   AdmsSensFadType & modelPar_CJS,
   bool modelPar_given_CJS,
   AdmsSensFadType & modelPar_CJD,
   bool modelPar_given_CJD,
   AdmsSensFadType & modelPar_CJSWS,
   bool modelPar_given_CJSWS,
   AdmsSensFadType & modelPar_CJSWD,
   bool modelPar_given_CJSWD,
   AdmsSensFadType & modelPar_CJSWGS,
   bool modelPar_given_CJSWGS,
   AdmsSensFadType & modelPar_CJSWGD,
   bool modelPar_given_CJSWGD,
   AdmsSensFadType & modelPar_PBS,
   bool modelPar_given_PBS,
   AdmsSensFadType & modelPar_PBD,
   bool modelPar_given_PBD,
   AdmsSensFadType & modelPar_PBSWS,
   bool modelPar_given_PBSWS,
   AdmsSensFadType & modelPar_PBSWD,
   bool modelPar_given_PBSWD,
   AdmsSensFadType & modelPar_PBSWGS,
   bool modelPar_given_PBSWGS,
   AdmsSensFadType & modelPar_PBSWGD,
   bool modelPar_given_PBSWGD,
   AdmsSensFadType & modelPar_MJS,
   bool modelPar_given_MJS,
   AdmsSensFadType & modelPar_MJD,
   bool modelPar_given_MJD,
   AdmsSensFadType & modelPar_MJSWS,
   bool modelPar_given_MJSWS,
   AdmsSensFadType & modelPar_MJSWD,
   bool modelPar_given_MJSWD,
   AdmsSensFadType & modelPar_MJSWGS,
   bool modelPar_given_MJSWGS,
   AdmsSensFadType & modelPar_MJSWGD,
   bool modelPar_given_MJSWGD,
   AdmsSensFadType & modelPar_SJS,
   bool modelPar_given_SJS,
   AdmsSensFadType & modelPar_SJD,
   bool modelPar_given_SJD,
   AdmsSensFadType & modelPar_SJSWS,
   bool modelPar_given_SJSWS,
   AdmsSensFadType & modelPar_SJSWD,
   bool modelPar_given_SJSWD,
   AdmsSensFadType & modelPar_SJSWGS,
   bool modelPar_given_SJSWGS,
   AdmsSensFadType & modelPar_SJSWGD,
   bool modelPar_given_SJSWGD,
   AdmsSensFadType & modelPar_MJS2,
   bool modelPar_given_MJS2,
   AdmsSensFadType & modelPar_MJD2,
   bool modelPar_given_MJD2,
   AdmsSensFadType & modelPar_MJSWS2,
   bool modelPar_given_MJSWS2,
   AdmsSensFadType & modelPar_MJSWD2,
   bool modelPar_given_MJSWD2,
   AdmsSensFadType & modelPar_MJSWGS2,
   bool modelPar_given_MJSWGS2,
   AdmsSensFadType & modelPar_MJSWGD2,
   bool modelPar_given_MJSWGD2,
   AdmsSensFadType & modelPar_JSS,
   bool modelPar_given_JSS,
   AdmsSensFadType & modelPar_JSD,
   bool modelPar_given_JSD,
   AdmsSensFadType & modelPar_JSWS,
   bool modelPar_given_JSWS,
   AdmsSensFadType & modelPar_JSWD,
   bool modelPar_given_JSWD,
   AdmsSensFadType & modelPar_JSWGS,
   bool modelPar_given_JSWGS,
   AdmsSensFadType & modelPar_JSWGD,
   bool modelPar_given_JSWGD,
   AdmsSensFadType & modelPar_NJS,
   bool modelPar_given_NJS,
   AdmsSensFadType & modelPar_NJD,
   bool modelPar_given_NJD,
   AdmsSensFadType & modelPar_IJTHSFWD,
   bool modelPar_given_IJTHSFWD,
   AdmsSensFadType & modelPar_IJTHDFWD,
   bool modelPar_given_IJTHDFWD,
   AdmsSensFadType & modelPar_IJTHSREV,
   bool modelPar_given_IJTHSREV,
   AdmsSensFadType & modelPar_IJTHDREV,
   bool modelPar_given_IJTHDREV,
   AdmsSensFadType & modelPar_BVS,
   bool modelPar_given_BVS,
   AdmsSensFadType & modelPar_BVD,
   bool modelPar_given_BVD,
   AdmsSensFadType & modelPar_XJBVS,
   bool modelPar_given_XJBVS,
   AdmsSensFadType & modelPar_XJBVD,
   bool modelPar_given_XJBVD,
   AdmsSensFadType & modelPar_JTSS,
   bool modelPar_given_JTSS,
   AdmsSensFadType & modelPar_JTSD,
   bool modelPar_given_JTSD,
   AdmsSensFadType & modelPar_JTSSWS,
   bool modelPar_given_JTSSWS,
   AdmsSensFadType & modelPar_JTSSWD,
   bool modelPar_given_JTSSWD,
   AdmsSensFadType & modelPar_JTSSWGS,
   bool modelPar_given_JTSSWGS,
   AdmsSensFadType & modelPar_JTSSWGD,
   bool modelPar_given_JTSSWGD,
   AdmsSensFadType & modelPar_JTWEFF,
   bool modelPar_given_JTWEFF,
   AdmsSensFadType & modelPar_NJTS,
   bool modelPar_given_NJTS,
   AdmsSensFadType & modelPar_NJTSD,
   bool modelPar_given_NJTSD,
   AdmsSensFadType & modelPar_NJTSSW,
   bool modelPar_given_NJTSSW,
   AdmsSensFadType & modelPar_NJTSSWD,
   bool modelPar_given_NJTSSWD,
   AdmsSensFadType & modelPar_NJTSSWG,
   bool modelPar_given_NJTSSWG,
   AdmsSensFadType & modelPar_NJTSSWGD,
   bool modelPar_given_NJTSSWGD,
   AdmsSensFadType & modelPar_VTSS,
   bool modelPar_given_VTSS,
   AdmsSensFadType & modelPar_VTSD,
   bool modelPar_given_VTSD,
   AdmsSensFadType & modelPar_VTSSWS,
   bool modelPar_given_VTSSWS,
   AdmsSensFadType & modelPar_VTSSWD,
   bool modelPar_given_VTSSWD,
   AdmsSensFadType & modelPar_VTSSWGS,
   bool modelPar_given_VTSSWGS,
   AdmsSensFadType & modelPar_VTSSWGD,
   bool modelPar_given_VTSSWGD,
   AdmsSensFadType & modelPar_LINTIGEN,
   bool modelPar_given_LINTIGEN,
   AdmsSensFadType & modelPar_NTGEN,
   bool modelPar_given_NTGEN,
   AdmsSensFadType & modelPar_AIGEN,
   bool modelPar_given_AIGEN,
   AdmsSensFadType & modelPar_BIGEN,
   bool modelPar_given_BIGEN,
   AdmsSensFadType & modelPar_XRCRG1,
   bool modelPar_given_XRCRG1,
   AdmsSensFadType & modelPar_XRCRG2,
   bool modelPar_given_XRCRG2,
   AdmsSensFadType & modelPar_EF,
   bool modelPar_given_EF,
   AdmsSensFadType & modelPar_EM,
   bool modelPar_given_EM,
   AdmsSensFadType & modelPar_NOIA,
   bool modelPar_given_NOIA,
   AdmsSensFadType & modelPar_NOIB,
   bool modelPar_given_NOIB,
   AdmsSensFadType & modelPar_NOIC,
   bool modelPar_given_NOIC,
   AdmsSensFadType & modelPar_LINTNOI,
   bool modelPar_given_LINTNOI,
   AdmsSensFadType & modelPar_NTNOI,
   bool modelPar_given_NTNOI,
   AdmsSensFadType & modelPar_TNOIA,
   bool modelPar_given_TNOIA,
   AdmsSensFadType & modelPar_TNOIB,
   bool modelPar_given_TNOIB,
   AdmsSensFadType & modelPar_RNOIA,
   bool modelPar_given_RNOIA,
   AdmsSensFadType & modelPar_RNOIB,
   bool modelPar_given_RNOIB,
   AdmsSensFadType & modelPar_TNOIC,
   bool modelPar_given_TNOIC,
   AdmsSensFadType & modelPar_RNOIC,
   bool modelPar_given_RNOIC,
   AdmsSensFadType & modelPar_SCALEN,
   bool modelPar_given_SCALEN,
   AdmsSensFadType & modelPar_TNOM,
   bool modelPar_given_TNOM,
   AdmsSensFadType & modelPar_TBGASUB,
   bool modelPar_given_TBGASUB,
   AdmsSensFadType & modelPar_TBGBSUB,
   bool modelPar_given_TBGBSUB,
   AdmsSensFadType & modelPar_KT1,
   bool modelPar_given_KT1,
   AdmsSensFadType & modelPar_KT1L,
   bool modelPar_given_KT1L,
   AdmsSensFadType & modelPar_TSS,
   bool modelPar_given_TSS,
   AdmsSensFadType & modelPar_IIT,
   bool modelPar_given_IIT,
   AdmsSensFadType & modelPar_TII,
   bool modelPar_given_TII,
   AdmsSensFadType & modelPar_TGIDL,
   bool modelPar_given_TGIDL,
   AdmsSensFadType & modelPar_IGT,
   bool modelPar_given_IGT,
   AdmsSensFadType & modelPar_TCJ,
   bool modelPar_given_TCJ,
   AdmsSensFadType & modelPar_TCJSW,
   bool modelPar_given_TCJSW,
   AdmsSensFadType & modelPar_TCJSWG,
   bool modelPar_given_TCJSWG,
   AdmsSensFadType & modelPar_TPB,
   bool modelPar_given_TPB,
   AdmsSensFadType & modelPar_TPBSW,
   bool modelPar_given_TPBSW,
   AdmsSensFadType & modelPar_TPBSWG,
   bool modelPar_given_TPBSWG,
   AdmsSensFadType & modelPar_XTIS,
   bool modelPar_given_XTIS,
   AdmsSensFadType & modelPar_XTID,
   bool modelPar_given_XTID,
   AdmsSensFadType & modelPar_XTSS,
   bool modelPar_given_XTSS,
   AdmsSensFadType & modelPar_XTSD,
   bool modelPar_given_XTSD,
   AdmsSensFadType & modelPar_XTSSWS,
   bool modelPar_given_XTSSWS,
   AdmsSensFadType & modelPar_XTSSWD,
   bool modelPar_given_XTSSWD,
   AdmsSensFadType & modelPar_XTSSWGS,
   bool modelPar_given_XTSSWGS,
   AdmsSensFadType & modelPar_XTSSWGD,
   bool modelPar_given_XTSSWGD,
   AdmsSensFadType & modelPar_TNJTS,
   bool modelPar_given_TNJTS,
   AdmsSensFadType & modelPar_TNJTSD,
   bool modelPar_given_TNJTSD,
   AdmsSensFadType & modelPar_TNJTSSW,
   bool modelPar_given_TNJTSSW,
   AdmsSensFadType & modelPar_TNJTSSWD,
   bool modelPar_given_TNJTSSWD,
   AdmsSensFadType & modelPar_TNJTSSWG,
   bool modelPar_given_TNJTSSWG,
   AdmsSensFadType & modelPar_TNJTSSWGD,
   bool modelPar_given_TNJTSSWGD,
   AdmsSensFadType & modelPar_RTH0,
   bool modelPar_given_RTH0,
   AdmsSensFadType & modelPar_CTH0,
   bool modelPar_given_CTH0,
   AdmsSensFadType & modelPar_WTH0,
   bool modelPar_given_WTH0,
   AdmsSensFadType & modelPar_ASHEXP,
   bool modelPar_given_ASHEXP,
   AdmsSensFadType & modelPar_BSHEXP,
   bool modelPar_given_BSHEXP,
   AdmsSensFadType & modelPar_ACH_UFCM,
   bool modelPar_given_ACH_UFCM,
   AdmsSensFadType & modelPar_CINS_UFCM,
   bool modelPar_given_CINS_UFCM,
   AdmsSensFadType & modelPar_W_UFCM,
   bool modelPar_given_W_UFCM,
   AdmsSensFadType & modelPar_TFIN_TOP,
   bool modelPar_given_TFIN_TOP,
   AdmsSensFadType & modelPar_TFIN_BASE,
   bool modelPar_given_TFIN_BASE,
   AdmsSensFadType & modelPar_QMFACTORCV,
   bool modelPar_given_QMFACTORCV,
   AdmsSensFadType & modelPar_ALPHA_UFCM,
   bool modelPar_given_ALPHA_UFCM,
   AdmsSensFadType & modelPar_LMIN,
   bool modelPar_given_LMIN,
   AdmsSensFadType & modelPar_WMIN,
   bool modelPar_given_WMIN,
   AdmsSensFadType & modelPar_LMAX,
   bool modelPar_given_LMAX,
   AdmsSensFadType & modelPar_WMAX,
   bool modelPar_given_WMAX,
   AdmsSensFadType & modelPar_LNBODY,
   bool modelPar_given_LNBODY,
   AdmsSensFadType & modelPar_NNBODY,
   bool modelPar_given_NNBODY,
   AdmsSensFadType & modelPar_PNBODY,
   bool modelPar_given_PNBODY,
   AdmsSensFadType & modelPar_LPHIG,
   bool modelPar_given_LPHIG,
   AdmsSensFadType & modelPar_NPHIG,
   bool modelPar_given_NPHIG,
   AdmsSensFadType & modelPar_PPHIG,
   bool modelPar_given_PPHIG,
   AdmsSensFadType & modelPar_LNGATE,
   bool modelPar_given_LNGATE,
   AdmsSensFadType & modelPar_NNGATE,
   bool modelPar_given_NNGATE,
   AdmsSensFadType & modelPar_PNGATE,
   bool modelPar_given_PNGATE,
   AdmsSensFadType & modelPar_LCIT,
   bool modelPar_given_LCIT,
   AdmsSensFadType & modelPar_NCIT,
   bool modelPar_given_NCIT,
   AdmsSensFadType & modelPar_PCIT,
   bool modelPar_given_PCIT,
   AdmsSensFadType & modelPar_LCITR,
   bool modelPar_given_LCITR,
   AdmsSensFadType & modelPar_NCITR,
   bool modelPar_given_NCITR,
   AdmsSensFadType & modelPar_PCITR,
   bool modelPar_given_PCITR,
   AdmsSensFadType & modelPar_LCDSC,
   bool modelPar_given_LCDSC,
   AdmsSensFadType & modelPar_NCDSC,
   bool modelPar_given_NCDSC,
   AdmsSensFadType & modelPar_PCDSC,
   bool modelPar_given_PCDSC,
   AdmsSensFadType & modelPar_LCDSCD,
   bool modelPar_given_LCDSCD,
   AdmsSensFadType & modelPar_NCDSCD,
   bool modelPar_given_NCDSCD,
   AdmsSensFadType & modelPar_PCDSCD,
   bool modelPar_given_PCDSCD,
   AdmsSensFadType & modelPar_LCDSCDR,
   bool modelPar_given_LCDSCDR,
   AdmsSensFadType & modelPar_NCDSCDR,
   bool modelPar_given_NCDSCDR,
   AdmsSensFadType & modelPar_PCDSCDR,
   bool modelPar_given_PCDSCDR,
   AdmsSensFadType & modelPar_LDVT0,
   bool modelPar_given_LDVT0,
   AdmsSensFadType & modelPar_NDVT0,
   bool modelPar_given_NDVT0,
   AdmsSensFadType & modelPar_PDVT0,
   bool modelPar_given_PDVT0,
   AdmsSensFadType & modelPar_LDVT1,
   bool modelPar_given_LDVT1,
   AdmsSensFadType & modelPar_NDVT1,
   bool modelPar_given_NDVT1,
   AdmsSensFadType & modelPar_PDVT1,
   bool modelPar_given_PDVT1,
   AdmsSensFadType & modelPar_LDVT1SS,
   bool modelPar_given_LDVT1SS,
   AdmsSensFadType & modelPar_NDVT1SS,
   bool modelPar_given_NDVT1SS,
   AdmsSensFadType & modelPar_PDVT1SS,
   bool modelPar_given_PDVT1SS,
   AdmsSensFadType & modelPar_LPHIN,
   bool modelPar_given_LPHIN,
   AdmsSensFadType & modelPar_NPHIN,
   bool modelPar_given_NPHIN,
   AdmsSensFadType & modelPar_PPHIN,
   bool modelPar_given_PPHIN,
   AdmsSensFadType & modelPar_LETA0,
   bool modelPar_given_LETA0,
   AdmsSensFadType & modelPar_NETA0,
   bool modelPar_given_NETA0,
   AdmsSensFadType & modelPar_PETA0,
   bool modelPar_given_PETA0,
   AdmsSensFadType & modelPar_LETA0R,
   bool modelPar_given_LETA0R,
   AdmsSensFadType & modelPar_NETA0R,
   bool modelPar_given_NETA0R,
   AdmsSensFadType & modelPar_PETA0R,
   bool modelPar_given_PETA0R,
   AdmsSensFadType & modelPar_LDSUB,
   bool modelPar_given_LDSUB,
   AdmsSensFadType & modelPar_NDSUB,
   bool modelPar_given_NDSUB,
   AdmsSensFadType & modelPar_PDSUB,
   bool modelPar_given_PDSUB,
   AdmsSensFadType & modelPar_LK1RSCE,
   bool modelPar_given_LK1RSCE,
   AdmsSensFadType & modelPar_NK1RSCE,
   bool modelPar_given_NK1RSCE,
   AdmsSensFadType & modelPar_PK1RSCE,
   bool modelPar_given_PK1RSCE,
   AdmsSensFadType & modelPar_LLPE0,
   bool modelPar_given_LLPE0,
   AdmsSensFadType & modelPar_NLPE0,
   bool modelPar_given_NLPE0,
   AdmsSensFadType & modelPar_PLPE0,
   bool modelPar_given_PLPE0,
   AdmsSensFadType & modelPar_LDVTSHIFT,
   bool modelPar_given_LDVTSHIFT,
   AdmsSensFadType & modelPar_NDVTSHIFT,
   bool modelPar_given_NDVTSHIFT,
   AdmsSensFadType & modelPar_PDVTSHIFT,
   bool modelPar_given_PDVTSHIFT,
   AdmsSensFadType & modelPar_LDVTSHIFTR,
   bool modelPar_given_LDVTSHIFTR,
   AdmsSensFadType & modelPar_NDVTSHIFTR,
   bool modelPar_given_NDVTSHIFTR,
   AdmsSensFadType & modelPar_PDVTSHIFTR,
   bool modelPar_given_PDVTSHIFTR,
   AdmsSensFadType & modelPar_LPHIBE,
   bool modelPar_given_LPHIBE,
   AdmsSensFadType & modelPar_NPHIBE,
   bool modelPar_given_NPHIBE,
   AdmsSensFadType & modelPar_PPHIBE,
   bool modelPar_given_PPHIBE,
   AdmsSensFadType & modelPar_LK0,
   bool modelPar_given_LK0,
   AdmsSensFadType & modelPar_NK0,
   bool modelPar_given_NK0,
   AdmsSensFadType & modelPar_PK0,
   bool modelPar_given_PK0,
   AdmsSensFadType & modelPar_LK01,
   bool modelPar_given_LK01,
   AdmsSensFadType & modelPar_NK01,
   bool modelPar_given_NK01,
   AdmsSensFadType & modelPar_PK01,
   bool modelPar_given_PK01,
   AdmsSensFadType & modelPar_LK0SI,
   bool modelPar_given_LK0SI,
   AdmsSensFadType & modelPar_NK0SI,
   bool modelPar_given_NK0SI,
   AdmsSensFadType & modelPar_PK0SI,
   bool modelPar_given_PK0SI,
   AdmsSensFadType & modelPar_LK0SI1,
   bool modelPar_given_LK0SI1,
   AdmsSensFadType & modelPar_NK0SI1,
   bool modelPar_given_NK0SI1,
   AdmsSensFadType & modelPar_PK0SI1,
   bool modelPar_given_PK0SI1,
   AdmsSensFadType & modelPar_LK1,
   bool modelPar_given_LK1,
   AdmsSensFadType & modelPar_NK1,
   bool modelPar_given_NK1,
   AdmsSensFadType & modelPar_PK1,
   bool modelPar_given_PK1,
   AdmsSensFadType & modelPar_LK11,
   bool modelPar_given_LK11,
   AdmsSensFadType & modelPar_NK11,
   bool modelPar_given_NK11,
   AdmsSensFadType & modelPar_PK11,
   bool modelPar_given_PK11,
   AdmsSensFadType & modelPar_LK2SI,
   bool modelPar_given_LK2SI,
   AdmsSensFadType & modelPar_NK2SI,
   bool modelPar_given_NK2SI,
   AdmsSensFadType & modelPar_PK2SI,
   bool modelPar_given_PK2SI,
   AdmsSensFadType & modelPar_LK2SI1,
   bool modelPar_given_LK2SI1,
   AdmsSensFadType & modelPar_NK2SI1,
   bool modelPar_given_NK2SI1,
   AdmsSensFadType & modelPar_PK2SI1,
   bool modelPar_given_PK2SI1,
   AdmsSensFadType & modelPar_LK0SISAT,
   bool modelPar_given_LK0SISAT,
   AdmsSensFadType & modelPar_NK0SISAT,
   bool modelPar_given_NK0SISAT,
   AdmsSensFadType & modelPar_PK0SISAT,
   bool modelPar_given_PK0SISAT,
   AdmsSensFadType & modelPar_LK0SISAT1,
   bool modelPar_given_LK0SISAT1,
   AdmsSensFadType & modelPar_NK0SISAT1,
   bool modelPar_given_NK0SISAT1,
   AdmsSensFadType & modelPar_PK0SISAT1,
   bool modelPar_given_PK0SISAT1,
   AdmsSensFadType & modelPar_LK2SISAT,
   bool modelPar_given_LK2SISAT,
   AdmsSensFadType & modelPar_NK2SISAT,
   bool modelPar_given_NK2SISAT,
   AdmsSensFadType & modelPar_PK2SISAT,
   bool modelPar_given_PK2SISAT,
   AdmsSensFadType & modelPar_LK2SISAT1,
   bool modelPar_given_LK2SISAT1,
   AdmsSensFadType & modelPar_NK2SISAT1,
   bool modelPar_given_NK2SISAT1,
   AdmsSensFadType & modelPar_PK2SISAT1,
   bool modelPar_given_PK2SISAT1,
   AdmsSensFadType & modelPar_LK2SAT,
   bool modelPar_given_LK2SAT,
   AdmsSensFadType & modelPar_NK2SAT,
   bool modelPar_given_NK2SAT,
   AdmsSensFadType & modelPar_PK2SAT,
   bool modelPar_given_PK2SAT,
   AdmsSensFadType & modelPar_LK2SAT1,
   bool modelPar_given_LK2SAT1,
   AdmsSensFadType & modelPar_NK2SAT1,
   bool modelPar_given_NK2SAT1,
   AdmsSensFadType & modelPar_PK2SAT1,
   bool modelPar_given_PK2SAT1,
   AdmsSensFadType & modelPar_LK2,
   bool modelPar_given_LK2,
   AdmsSensFadType & modelPar_NK2,
   bool modelPar_given_NK2,
   AdmsSensFadType & modelPar_PK2,
   bool modelPar_given_PK2,
   AdmsSensFadType & modelPar_LK21,
   bool modelPar_given_LK21,
   AdmsSensFadType & modelPar_NK21,
   bool modelPar_given_NK21,
   AdmsSensFadType & modelPar_PK21,
   bool modelPar_given_PK21,
   AdmsSensFadType & modelPar_LDVTB,
   bool modelPar_given_LDVTB,
   AdmsSensFadType & modelPar_NDVTB,
   bool modelPar_given_NDVTB,
   AdmsSensFadType & modelPar_PDVTB,
   bool modelPar_given_PDVTB,
   AdmsSensFadType & modelPar_LLPEB,
   bool modelPar_given_LLPEB,
   AdmsSensFadType & modelPar_NLPEB,
   bool modelPar_given_NLPEB,
   AdmsSensFadType & modelPar_PLPEB,
   bool modelPar_given_PLPEB,
   AdmsSensFadType & modelPar_LQMFACTOR,
   bool modelPar_given_LQMFACTOR,
   AdmsSensFadType & modelPar_NQMFACTOR,
   bool modelPar_given_NQMFACTOR,
   AdmsSensFadType & modelPar_PQMFACTOR,
   bool modelPar_given_PQMFACTOR,
   AdmsSensFadType & modelPar_LQMTCENCV,
   bool modelPar_given_LQMTCENCV,
   AdmsSensFadType & modelPar_NQMTCENCV,
   bool modelPar_given_NQMTCENCV,
   AdmsSensFadType & modelPar_PQMTCENCV,
   bool modelPar_given_PQMTCENCV,
   AdmsSensFadType & modelPar_LQMTCENCVA,
   bool modelPar_given_LQMTCENCVA,
   AdmsSensFadType & modelPar_NQMTCENCVA,
   bool modelPar_given_NQMTCENCVA,
   AdmsSensFadType & modelPar_PQMTCENCVA,
   bool modelPar_given_PQMTCENCVA,
   AdmsSensFadType & modelPar_LVSAT,
   bool modelPar_given_LVSAT,
   AdmsSensFadType & modelPar_NVSAT,
   bool modelPar_given_NVSAT,
   AdmsSensFadType & modelPar_PVSAT,
   bool modelPar_given_PVSAT,
   AdmsSensFadType & modelPar_LVSATR,
   bool modelPar_given_LVSATR,
   AdmsSensFadType & modelPar_NVSATR,
   bool modelPar_given_NVSATR,
   AdmsSensFadType & modelPar_PVSATR,
   bool modelPar_given_PVSATR,
   AdmsSensFadType & modelPar_LVSAT1,
   bool modelPar_given_LVSAT1,
   AdmsSensFadType & modelPar_NVSAT1,
   bool modelPar_given_NVSAT1,
   AdmsSensFadType & modelPar_PVSAT1,
   bool modelPar_given_PVSAT1,
   AdmsSensFadType & modelPar_LVSAT1R,
   bool modelPar_given_LVSAT1R,
   AdmsSensFadType & modelPar_NVSAT1R,
   bool modelPar_given_NVSAT1R,
   AdmsSensFadType & modelPar_PVSAT1R,
   bool modelPar_given_PVSAT1R,
   AdmsSensFadType & modelPar_LPSAT,
   bool modelPar_given_LPSAT,
   AdmsSensFadType & modelPar_NPSAT,
   bool modelPar_given_NPSAT,
   AdmsSensFadType & modelPar_PPSAT,
   bool modelPar_given_PPSAT,
   AdmsSensFadType & modelPar_LDELTAVSAT,
   bool modelPar_given_LDELTAVSAT,
   AdmsSensFadType & modelPar_NDELTAVSAT,
   bool modelPar_given_NDELTAVSAT,
   AdmsSensFadType & modelPar_PDELTAVSAT,
   bool modelPar_given_PDELTAVSAT,
   AdmsSensFadType & modelPar_LKSATIV,
   bool modelPar_given_LKSATIV,
   AdmsSensFadType & modelPar_NKSATIV,
   bool modelPar_given_NKSATIV,
   AdmsSensFadType & modelPar_PKSATIV,
   bool modelPar_given_PKSATIV,
   AdmsSensFadType & modelPar_LKSATIVR,
   bool modelPar_given_LKSATIVR,
   AdmsSensFadType & modelPar_NKSATIVR,
   bool modelPar_given_NKSATIVR,
   AdmsSensFadType & modelPar_PKSATIVR,
   bool modelPar_given_PKSATIVR,
   AdmsSensFadType & modelPar_LVSATCV,
   bool modelPar_given_LVSATCV,
   AdmsSensFadType & modelPar_NVSATCV,
   bool modelPar_given_NVSATCV,
   AdmsSensFadType & modelPar_PVSATCV,
   bool modelPar_given_PVSATCV,
   AdmsSensFadType & modelPar_LPSATCV,
   bool modelPar_given_LPSATCV,
   AdmsSensFadType & modelPar_NPSATCV,
   bool modelPar_given_NPSATCV,
   AdmsSensFadType & modelPar_PPSATCV,
   bool modelPar_given_PPSATCV,
   AdmsSensFadType & modelPar_LDELTAVSATCV,
   bool modelPar_given_LDELTAVSATCV,
   AdmsSensFadType & modelPar_NDELTAVSATCV,
   bool modelPar_given_NDELTAVSATCV,
   AdmsSensFadType & modelPar_PDELTAVSATCV,
   bool modelPar_given_PDELTAVSATCV,
   AdmsSensFadType & modelPar_LMEXP,
   bool modelPar_given_LMEXP,
   AdmsSensFadType & modelPar_NMEXP,
   bool modelPar_given_NMEXP,
   AdmsSensFadType & modelPar_PMEXP,
   bool modelPar_given_PMEXP,
   AdmsSensFadType & modelPar_LMEXPR,
   bool modelPar_given_LMEXPR,
   AdmsSensFadType & modelPar_NMEXPR,
   bool modelPar_given_NMEXPR,
   AdmsSensFadType & modelPar_PMEXPR,
   bool modelPar_given_PMEXPR,
   AdmsSensFadType & modelPar_LPTWG,
   bool modelPar_given_LPTWG,
   AdmsSensFadType & modelPar_NPTWG,
   bool modelPar_given_NPTWG,
   AdmsSensFadType & modelPar_PPTWG,
   bool modelPar_given_PPTWG,
   AdmsSensFadType & modelPar_LPTWGR,
   bool modelPar_given_LPTWGR,
   AdmsSensFadType & modelPar_NPTWGR,
   bool modelPar_given_NPTWGR,
   AdmsSensFadType & modelPar_PPTWGR,
   bool modelPar_given_PPTWGR,
   AdmsSensFadType & modelPar_LU0,
   bool modelPar_given_LU0,
   AdmsSensFadType & modelPar_NU0,
   bool modelPar_given_NU0,
   AdmsSensFadType & modelPar_PU0,
   bool modelPar_given_PU0,
   AdmsSensFadType & modelPar_LU0R,
   bool modelPar_given_LU0R,
   AdmsSensFadType & modelPar_NU0R,
   bool modelPar_given_NU0R,
   AdmsSensFadType & modelPar_PU0R,
   bool modelPar_given_PU0R,
   AdmsSensFadType & modelPar_LETAMOB,
   bool modelPar_given_LETAMOB,
   AdmsSensFadType & modelPar_NETAMOB,
   bool modelPar_given_NETAMOB,
   AdmsSensFadType & modelPar_PETAMOB,
   bool modelPar_given_PETAMOB,
   AdmsSensFadType & modelPar_LUP,
   bool modelPar_given_LUP,
   AdmsSensFadType & modelPar_NUP,
   bool modelPar_given_NUP,
   AdmsSensFadType & modelPar_PUP,
   bool modelPar_given_PUP,
   AdmsSensFadType & modelPar_LUPR,
   bool modelPar_given_LUPR,
   AdmsSensFadType & modelPar_NUPR,
   bool modelPar_given_NUPR,
   AdmsSensFadType & modelPar_PUPR,
   bool modelPar_given_PUPR,
   AdmsSensFadType & modelPar_LUA,
   bool modelPar_given_LUA,
   AdmsSensFadType & modelPar_NUA,
   bool modelPar_given_NUA,
   AdmsSensFadType & modelPar_PUA,
   bool modelPar_given_PUA,
   AdmsSensFadType & modelPar_LUAR,
   bool modelPar_given_LUAR,
   AdmsSensFadType & modelPar_NUAR,
   bool modelPar_given_NUAR,
   AdmsSensFadType & modelPar_PUAR,
   bool modelPar_given_PUAR,
   AdmsSensFadType & modelPar_LUC,
   bool modelPar_given_LUC,
   AdmsSensFadType & modelPar_NUC,
   bool modelPar_given_NUC,
   AdmsSensFadType & modelPar_PUC,
   bool modelPar_given_PUC,
   AdmsSensFadType & modelPar_LUCR,
   bool modelPar_given_LUCR,
   AdmsSensFadType & modelPar_NUCR,
   bool modelPar_given_NUCR,
   AdmsSensFadType & modelPar_PUCR,
   bool modelPar_given_PUCR,
   AdmsSensFadType & modelPar_LEU,
   bool modelPar_given_LEU,
   AdmsSensFadType & modelPar_NEU,
   bool modelPar_given_NEU,
   AdmsSensFadType & modelPar_PEU,
   bool modelPar_given_PEU,
   AdmsSensFadType & modelPar_LEUR,
   bool modelPar_given_LEUR,
   AdmsSensFadType & modelPar_NEUR,
   bool modelPar_given_NEUR,
   AdmsSensFadType & modelPar_PEUR,
   bool modelPar_given_PEUR,
   AdmsSensFadType & modelPar_LUD,
   bool modelPar_given_LUD,
   AdmsSensFadType & modelPar_NUD,
   bool modelPar_given_NUD,
   AdmsSensFadType & modelPar_PUD,
   bool modelPar_given_PUD,
   AdmsSensFadType & modelPar_LUDR,
   bool modelPar_given_LUDR,
   AdmsSensFadType & modelPar_NUDR,
   bool modelPar_given_NUDR,
   AdmsSensFadType & modelPar_PUDR,
   bool modelPar_given_PUDR,
   AdmsSensFadType & modelPar_LUCS,
   bool modelPar_given_LUCS,
   AdmsSensFadType & modelPar_NUCS,
   bool modelPar_given_NUCS,
   AdmsSensFadType & modelPar_PUCS,
   bool modelPar_given_PUCS,
   AdmsSensFadType & modelPar_LPCLM,
   bool modelPar_given_LPCLM,
   AdmsSensFadType & modelPar_NPCLM,
   bool modelPar_given_NPCLM,
   AdmsSensFadType & modelPar_PPCLM,
   bool modelPar_given_PPCLM,
   AdmsSensFadType & modelPar_LPCLMR,
   bool modelPar_given_LPCLMR,
   AdmsSensFadType & modelPar_NPCLMR,
   bool modelPar_given_NPCLMR,
   AdmsSensFadType & modelPar_PPCLMR,
   bool modelPar_given_PPCLMR,
   AdmsSensFadType & modelPar_LPCLMG,
   bool modelPar_given_LPCLMG,
   AdmsSensFadType & modelPar_NPCLMG,
   bool modelPar_given_NPCLMG,
   AdmsSensFadType & modelPar_PPCLMG,
   bool modelPar_given_PPCLMG,
   AdmsSensFadType & modelPar_LPCLMCV,
   bool modelPar_given_LPCLMCV,
   AdmsSensFadType & modelPar_NPCLMCV,
   bool modelPar_given_NPCLMCV,
   AdmsSensFadType & modelPar_PPCLMCV,
   bool modelPar_given_PPCLMCV,
   AdmsSensFadType & modelPar_LA1,
   bool modelPar_given_LA1,
   AdmsSensFadType & modelPar_NA1,
   bool modelPar_given_NA1,
   AdmsSensFadType & modelPar_PA1,
   bool modelPar_given_PA1,
   AdmsSensFadType & modelPar_LA11,
   bool modelPar_given_LA11,
   AdmsSensFadType & modelPar_NA11,
   bool modelPar_given_NA11,
   AdmsSensFadType & modelPar_PA11,
   bool modelPar_given_PA11,
   AdmsSensFadType & modelPar_LA2,
   bool modelPar_given_LA2,
   AdmsSensFadType & modelPar_NA2,
   bool modelPar_given_NA2,
   AdmsSensFadType & modelPar_PA2,
   bool modelPar_given_PA2,
   AdmsSensFadType & modelPar_LA21,
   bool modelPar_given_LA21,
   AdmsSensFadType & modelPar_NA21,
   bool modelPar_given_NA21,
   AdmsSensFadType & modelPar_PA21,
   bool modelPar_given_PA21,
   AdmsSensFadType & modelPar_LRDSW,
   bool modelPar_given_LRDSW,
   AdmsSensFadType & modelPar_NRDSW,
   bool modelPar_given_NRDSW,
   AdmsSensFadType & modelPar_PRDSW,
   bool modelPar_given_PRDSW,
   AdmsSensFadType & modelPar_LRSW,
   bool modelPar_given_LRSW,
   AdmsSensFadType & modelPar_NRSW,
   bool modelPar_given_NRSW,
   AdmsSensFadType & modelPar_PRSW,
   bool modelPar_given_PRSW,
   AdmsSensFadType & modelPar_LRDW,
   bool modelPar_given_LRDW,
   AdmsSensFadType & modelPar_NRDW,
   bool modelPar_given_NRDW,
   AdmsSensFadType & modelPar_PRDW,
   bool modelPar_given_PRDW,
   AdmsSensFadType & modelPar_LPRWGS,
   bool modelPar_given_LPRWGS,
   AdmsSensFadType & modelPar_NPRWGS,
   bool modelPar_given_NPRWGS,
   AdmsSensFadType & modelPar_PPRWGS,
   bool modelPar_given_PPRWGS,
   AdmsSensFadType & modelPar_LPRWGD,
   bool modelPar_given_LPRWGD,
   AdmsSensFadType & modelPar_NPRWGD,
   bool modelPar_given_NPRWGD,
   AdmsSensFadType & modelPar_PPRWGD,
   bool modelPar_given_PPRWGD,
   AdmsSensFadType & modelPar_LWR,
   bool modelPar_given_LWR,
   AdmsSensFadType & modelPar_NWR,
   bool modelPar_given_NWR,
   AdmsSensFadType & modelPar_PWR,
   bool modelPar_given_PWR,
   AdmsSensFadType & modelPar_LPDIBL1,
   bool modelPar_given_LPDIBL1,
   AdmsSensFadType & modelPar_NPDIBL1,
   bool modelPar_given_NPDIBL1,
   AdmsSensFadType & modelPar_PPDIBL1,
   bool modelPar_given_PPDIBL1,
   AdmsSensFadType & modelPar_LPDIBL1R,
   bool modelPar_given_LPDIBL1R,
   AdmsSensFadType & modelPar_NPDIBL1R,
   bool modelPar_given_NPDIBL1R,
   AdmsSensFadType & modelPar_PPDIBL1R,
   bool modelPar_given_PPDIBL1R,
   AdmsSensFadType & modelPar_LPDIBL2,
   bool modelPar_given_LPDIBL2,
   AdmsSensFadType & modelPar_NPDIBL2,
   bool modelPar_given_NPDIBL2,
   AdmsSensFadType & modelPar_PPDIBL2,
   bool modelPar_given_PPDIBL2,
   AdmsSensFadType & modelPar_LPDIBL2R,
   bool modelPar_given_LPDIBL2R,
   AdmsSensFadType & modelPar_NPDIBL2R,
   bool modelPar_given_NPDIBL2R,
   AdmsSensFadType & modelPar_PPDIBL2R,
   bool modelPar_given_PPDIBL2R,
   AdmsSensFadType & modelPar_LDROUT,
   bool modelPar_given_LDROUT,
   AdmsSensFadType & modelPar_NDROUT,
   bool modelPar_given_NDROUT,
   AdmsSensFadType & modelPar_PDROUT,
   bool modelPar_given_PDROUT,
   AdmsSensFadType & modelPar_LPVAG,
   bool modelPar_given_LPVAG,
   AdmsSensFadType & modelPar_NPVAG,
   bool modelPar_given_NPVAG,
   AdmsSensFadType & modelPar_PPVAG,
   bool modelPar_given_PPVAG,
   AdmsSensFadType & modelPar_LAIGBINV,
   bool modelPar_given_LAIGBINV,
   AdmsSensFadType & modelPar_NAIGBINV,
   bool modelPar_given_NAIGBINV,
   AdmsSensFadType & modelPar_PAIGBINV,
   bool modelPar_given_PAIGBINV,
   AdmsSensFadType & modelPar_LAIGBINV1,
   bool modelPar_given_LAIGBINV1,
   AdmsSensFadType & modelPar_NAIGBINV1,
   bool modelPar_given_NAIGBINV1,
   AdmsSensFadType & modelPar_PAIGBINV1,
   bool modelPar_given_PAIGBINV1,
   AdmsSensFadType & modelPar_LBIGBINV,
   bool modelPar_given_LBIGBINV,
   AdmsSensFadType & modelPar_NBIGBINV,
   bool modelPar_given_NBIGBINV,
   AdmsSensFadType & modelPar_PBIGBINV,
   bool modelPar_given_PBIGBINV,
   AdmsSensFadType & modelPar_LCIGBINV,
   bool modelPar_given_LCIGBINV,
   AdmsSensFadType & modelPar_NCIGBINV,
   bool modelPar_given_NCIGBINV,
   AdmsSensFadType & modelPar_PCIGBINV,
   bool modelPar_given_PCIGBINV,
   AdmsSensFadType & modelPar_LEIGBINV,
   bool modelPar_given_LEIGBINV,
   AdmsSensFadType & modelPar_NEIGBINV,
   bool modelPar_given_NEIGBINV,
   AdmsSensFadType & modelPar_PEIGBINV,
   bool modelPar_given_PEIGBINV,
   AdmsSensFadType & modelPar_LNIGBINV,
   bool modelPar_given_LNIGBINV,
   AdmsSensFadType & modelPar_NNIGBINV,
   bool modelPar_given_NNIGBINV,
   AdmsSensFadType & modelPar_PNIGBINV,
   bool modelPar_given_PNIGBINV,
   AdmsSensFadType & modelPar_LAIGBACC,
   bool modelPar_given_LAIGBACC,
   AdmsSensFadType & modelPar_NAIGBACC,
   bool modelPar_given_NAIGBACC,
   AdmsSensFadType & modelPar_PAIGBACC,
   bool modelPar_given_PAIGBACC,
   AdmsSensFadType & modelPar_LAIGBACC1,
   bool modelPar_given_LAIGBACC1,
   AdmsSensFadType & modelPar_NAIGBACC1,
   bool modelPar_given_NAIGBACC1,
   AdmsSensFadType & modelPar_PAIGBACC1,
   bool modelPar_given_PAIGBACC1,
   AdmsSensFadType & modelPar_LBIGBACC,
   bool modelPar_given_LBIGBACC,
   AdmsSensFadType & modelPar_NBIGBACC,
   bool modelPar_given_NBIGBACC,
   AdmsSensFadType & modelPar_PBIGBACC,
   bool modelPar_given_PBIGBACC,
   AdmsSensFadType & modelPar_LCIGBACC,
   bool modelPar_given_LCIGBACC,
   AdmsSensFadType & modelPar_NCIGBACC,
   bool modelPar_given_NCIGBACC,
   AdmsSensFadType & modelPar_PCIGBACC,
   bool modelPar_given_PCIGBACC,
   AdmsSensFadType & modelPar_LNIGBACC,
   bool modelPar_given_LNIGBACC,
   AdmsSensFadType & modelPar_NNIGBACC,
   bool modelPar_given_NNIGBACC,
   AdmsSensFadType & modelPar_PNIGBACC,
   bool modelPar_given_PNIGBACC,
   AdmsSensFadType & modelPar_LAIGC,
   bool modelPar_given_LAIGC,
   AdmsSensFadType & modelPar_NAIGC,
   bool modelPar_given_NAIGC,
   AdmsSensFadType & modelPar_PAIGC,
   bool modelPar_given_PAIGC,
   AdmsSensFadType & modelPar_LAIGC1,
   bool modelPar_given_LAIGC1,
   AdmsSensFadType & modelPar_NAIGC1,
   bool modelPar_given_NAIGC1,
   AdmsSensFadType & modelPar_PAIGC1,
   bool modelPar_given_PAIGC1,
   AdmsSensFadType & modelPar_LBIGC,
   bool modelPar_given_LBIGC,
   AdmsSensFadType & modelPar_NBIGC,
   bool modelPar_given_NBIGC,
   AdmsSensFadType & modelPar_PBIGC,
   bool modelPar_given_PBIGC,
   AdmsSensFadType & modelPar_LCIGC,
   bool modelPar_given_LCIGC,
   AdmsSensFadType & modelPar_NCIGC,
   bool modelPar_given_NCIGC,
   AdmsSensFadType & modelPar_PCIGC,
   bool modelPar_given_PCIGC,
   AdmsSensFadType & modelPar_LPIGCD,
   bool modelPar_given_LPIGCD,
   AdmsSensFadType & modelPar_NPIGCD,
   bool modelPar_given_NPIGCD,
   AdmsSensFadType & modelPar_PPIGCD,
   bool modelPar_given_PPIGCD,
   AdmsSensFadType & modelPar_LAIGS,
   bool modelPar_given_LAIGS,
   AdmsSensFadType & modelPar_NAIGS,
   bool modelPar_given_NAIGS,
   AdmsSensFadType & modelPar_PAIGS,
   bool modelPar_given_PAIGS,
   AdmsSensFadType & modelPar_LAIGS1,
   bool modelPar_given_LAIGS1,
   AdmsSensFadType & modelPar_NAIGS1,
   bool modelPar_given_NAIGS1,
   AdmsSensFadType & modelPar_PAIGS1,
   bool modelPar_given_PAIGS1,
   AdmsSensFadType & modelPar_LBIGS,
   bool modelPar_given_LBIGS,
   AdmsSensFadType & modelPar_NBIGS,
   bool modelPar_given_NBIGS,
   AdmsSensFadType & modelPar_PBIGS,
   bool modelPar_given_PBIGS,
   AdmsSensFadType & modelPar_LCIGS,
   bool modelPar_given_LCIGS,
   AdmsSensFadType & modelPar_NCIGS,
   bool modelPar_given_NCIGS,
   AdmsSensFadType & modelPar_PCIGS,
   bool modelPar_given_PCIGS,
   AdmsSensFadType & modelPar_LAIGD,
   bool modelPar_given_LAIGD,
   AdmsSensFadType & modelPar_NAIGD,
   bool modelPar_given_NAIGD,
   AdmsSensFadType & modelPar_PAIGD,
   bool modelPar_given_PAIGD,
   AdmsSensFadType & modelPar_LAIGD1,
   bool modelPar_given_LAIGD1,
   AdmsSensFadType & modelPar_NAIGD1,
   bool modelPar_given_NAIGD1,
   AdmsSensFadType & modelPar_PAIGD1,
   bool modelPar_given_PAIGD1,
   AdmsSensFadType & modelPar_LBIGD,
   bool modelPar_given_LBIGD,
   AdmsSensFadType & modelPar_NBIGD,
   bool modelPar_given_NBIGD,
   AdmsSensFadType & modelPar_PBIGD,
   bool modelPar_given_PBIGD,
   AdmsSensFadType & modelPar_LCIGD,
   bool modelPar_given_LCIGD,
   AdmsSensFadType & modelPar_NCIGD,
   bool modelPar_given_NCIGD,
   AdmsSensFadType & modelPar_PCIGD,
   bool modelPar_given_PCIGD,
   AdmsSensFadType & modelPar_LNTOX,
   bool modelPar_given_LNTOX,
   AdmsSensFadType & modelPar_NNTOX,
   bool modelPar_given_NNTOX,
   AdmsSensFadType & modelPar_PNTOX,
   bool modelPar_given_PNTOX,
   AdmsSensFadType & modelPar_LPOXEDGE,
   bool modelPar_given_LPOXEDGE,
   AdmsSensFadType & modelPar_NPOXEDGE,
   bool modelPar_given_NPOXEDGE,
   AdmsSensFadType & modelPar_PPOXEDGE,
   bool modelPar_given_PPOXEDGE,
   AdmsSensFadType & modelPar_LAGISL,
   bool modelPar_given_LAGISL,
   AdmsSensFadType & modelPar_NAGISL,
   bool modelPar_given_NAGISL,
   AdmsSensFadType & modelPar_PAGISL,
   bool modelPar_given_PAGISL,
   AdmsSensFadType & modelPar_LBGISL,
   bool modelPar_given_LBGISL,
   AdmsSensFadType & modelPar_NBGISL,
   bool modelPar_given_NBGISL,
   AdmsSensFadType & modelPar_PBGISL,
   bool modelPar_given_PBGISL,
   AdmsSensFadType & modelPar_LCGISL,
   bool modelPar_given_LCGISL,
   AdmsSensFadType & modelPar_NCGISL,
   bool modelPar_given_NCGISL,
   AdmsSensFadType & modelPar_PCGISL,
   bool modelPar_given_PCGISL,
   AdmsSensFadType & modelPar_LEGISL,
   bool modelPar_given_LEGISL,
   AdmsSensFadType & modelPar_NEGISL,
   bool modelPar_given_NEGISL,
   AdmsSensFadType & modelPar_PEGISL,
   bool modelPar_given_PEGISL,
   AdmsSensFadType & modelPar_LPGISL,
   bool modelPar_given_LPGISL,
   AdmsSensFadType & modelPar_NPGISL,
   bool modelPar_given_NPGISL,
   AdmsSensFadType & modelPar_PPGISL,
   bool modelPar_given_PPGISL,
   AdmsSensFadType & modelPar_LAGIDL,
   bool modelPar_given_LAGIDL,
   AdmsSensFadType & modelPar_NAGIDL,
   bool modelPar_given_NAGIDL,
   AdmsSensFadType & modelPar_PAGIDL,
   bool modelPar_given_PAGIDL,
   AdmsSensFadType & modelPar_LBGIDL,
   bool modelPar_given_LBGIDL,
   AdmsSensFadType & modelPar_NBGIDL,
   bool modelPar_given_NBGIDL,
   AdmsSensFadType & modelPar_PBGIDL,
   bool modelPar_given_PBGIDL,
   AdmsSensFadType & modelPar_LCGIDL,
   bool modelPar_given_LCGIDL,
   AdmsSensFadType & modelPar_NCGIDL,
   bool modelPar_given_NCGIDL,
   AdmsSensFadType & modelPar_PCGIDL,
   bool modelPar_given_PCGIDL,
   AdmsSensFadType & modelPar_LEGIDL,
   bool modelPar_given_LEGIDL,
   AdmsSensFadType & modelPar_NEGIDL,
   bool modelPar_given_NEGIDL,
   AdmsSensFadType & modelPar_PEGIDL,
   bool modelPar_given_PEGIDL,
   AdmsSensFadType & modelPar_LPGIDL,
   bool modelPar_given_LPGIDL,
   AdmsSensFadType & modelPar_NPGIDL,
   bool modelPar_given_NPGIDL,
   AdmsSensFadType & modelPar_PPGIDL,
   bool modelPar_given_PPGIDL,
   AdmsSensFadType & modelPar_LALPHA0,
   bool modelPar_given_LALPHA0,
   AdmsSensFadType & modelPar_NALPHA0,
   bool modelPar_given_NALPHA0,
   AdmsSensFadType & modelPar_PALPHA0,
   bool modelPar_given_PALPHA0,
   AdmsSensFadType & modelPar_LALPHA1,
   bool modelPar_given_LALPHA1,
   AdmsSensFadType & modelPar_NALPHA1,
   bool modelPar_given_NALPHA1,
   AdmsSensFadType & modelPar_PALPHA1,
   bool modelPar_given_PALPHA1,
   AdmsSensFadType & modelPar_LALPHAII0,
   bool modelPar_given_LALPHAII0,
   AdmsSensFadType & modelPar_NALPHAII0,
   bool modelPar_given_NALPHAII0,
   AdmsSensFadType & modelPar_PALPHAII0,
   bool modelPar_given_PALPHAII0,
   AdmsSensFadType & modelPar_LALPHAII1,
   bool modelPar_given_LALPHAII1,
   AdmsSensFadType & modelPar_NALPHAII1,
   bool modelPar_given_NALPHAII1,
   AdmsSensFadType & modelPar_PALPHAII1,
   bool modelPar_given_PALPHAII1,
   AdmsSensFadType & modelPar_LBETA0,
   bool modelPar_given_LBETA0,
   AdmsSensFadType & modelPar_NBETA0,
   bool modelPar_given_NBETA0,
   AdmsSensFadType & modelPar_PBETA0,
   bool modelPar_given_PBETA0,
   AdmsSensFadType & modelPar_LBETAII0,
   bool modelPar_given_LBETAII0,
   AdmsSensFadType & modelPar_NBETAII0,
   bool modelPar_given_NBETAII0,
   AdmsSensFadType & modelPar_PBETAII0,
   bool modelPar_given_PBETAII0,
   AdmsSensFadType & modelPar_LBETAII1,
   bool modelPar_given_LBETAII1,
   AdmsSensFadType & modelPar_NBETAII1,
   bool modelPar_given_NBETAII1,
   AdmsSensFadType & modelPar_PBETAII1,
   bool modelPar_given_PBETAII1,
   AdmsSensFadType & modelPar_LBETAII2,
   bool modelPar_given_LBETAII2,
   AdmsSensFadType & modelPar_NBETAII2,
   bool modelPar_given_NBETAII2,
   AdmsSensFadType & modelPar_PBETAII2,
   bool modelPar_given_PBETAII2,
   AdmsSensFadType & modelPar_LESATII,
   bool modelPar_given_LESATII,
   AdmsSensFadType & modelPar_NESATII,
   bool modelPar_given_NESATII,
   AdmsSensFadType & modelPar_PESATII,
   bool modelPar_given_PESATII,
   AdmsSensFadType & modelPar_LLII,
   bool modelPar_given_LLII,
   AdmsSensFadType & modelPar_NLII,
   bool modelPar_given_NLII,
   AdmsSensFadType & modelPar_PLII,
   bool modelPar_given_PLII,
   AdmsSensFadType & modelPar_LSII0,
   bool modelPar_given_LSII0,
   AdmsSensFadType & modelPar_NSII0,
   bool modelPar_given_NSII0,
   AdmsSensFadType & modelPar_PSII0,
   bool modelPar_given_PSII0,
   AdmsSensFadType & modelPar_LSII1,
   bool modelPar_given_LSII1,
   AdmsSensFadType & modelPar_NSII1,
   bool modelPar_given_NSII1,
   AdmsSensFadType & modelPar_PSII1,
   bool modelPar_given_PSII1,
   AdmsSensFadType & modelPar_LSII2,
   bool modelPar_given_LSII2,
   AdmsSensFadType & modelPar_NSII2,
   bool modelPar_given_NSII2,
   AdmsSensFadType & modelPar_PSII2,
   bool modelPar_given_PSII2,
   AdmsSensFadType & modelPar_LSIID,
   bool modelPar_given_LSIID,
   AdmsSensFadType & modelPar_NSIID,
   bool modelPar_given_NSIID,
   AdmsSensFadType & modelPar_PSIID,
   bool modelPar_given_PSIID,
   AdmsSensFadType & modelPar_LCFS,
   bool modelPar_given_LCFS,
   AdmsSensFadType & modelPar_NCFS,
   bool modelPar_given_NCFS,
   AdmsSensFadType & modelPar_PCFS,
   bool modelPar_given_PCFS,
   AdmsSensFadType & modelPar_LCFD,
   bool modelPar_given_LCFD,
   AdmsSensFadType & modelPar_NCFD,
   bool modelPar_given_NCFD,
   AdmsSensFadType & modelPar_PCFD,
   bool modelPar_given_PCFD,
   AdmsSensFadType & modelPar_LCOVS,
   bool modelPar_given_LCOVS,
   AdmsSensFadType & modelPar_NCOVS,
   bool modelPar_given_NCOVS,
   AdmsSensFadType & modelPar_PCOVS,
   bool modelPar_given_PCOVS,
   AdmsSensFadType & modelPar_LCOVD,
   bool modelPar_given_LCOVD,
   AdmsSensFadType & modelPar_NCOVD,
   bool modelPar_given_NCOVD,
   AdmsSensFadType & modelPar_PCOVD,
   bool modelPar_given_PCOVD,
   AdmsSensFadType & modelPar_LCGSL,
   bool modelPar_given_LCGSL,
   AdmsSensFadType & modelPar_NCGSL,
   bool modelPar_given_NCGSL,
   AdmsSensFadType & modelPar_PCGSL,
   bool modelPar_given_PCGSL,
   AdmsSensFadType & modelPar_LCGDL,
   bool modelPar_given_LCGDL,
   AdmsSensFadType & modelPar_NCGDL,
   bool modelPar_given_NCGDL,
   AdmsSensFadType & modelPar_PCGDL,
   bool modelPar_given_PCGDL,
   AdmsSensFadType & modelPar_LCKAPPAS,
   bool modelPar_given_LCKAPPAS,
   AdmsSensFadType & modelPar_NCKAPPAS,
   bool modelPar_given_NCKAPPAS,
   AdmsSensFadType & modelPar_PCKAPPAS,
   bool modelPar_given_PCKAPPAS,
   AdmsSensFadType & modelPar_LCKAPPAD,
   bool modelPar_given_LCKAPPAD,
   AdmsSensFadType & modelPar_NCKAPPAD,
   bool modelPar_given_NCKAPPAD,
   AdmsSensFadType & modelPar_PCKAPPAD,
   bool modelPar_given_PCKAPPAD,
   AdmsSensFadType & modelPar_LCGBL,
   bool modelPar_given_LCGBL,
   AdmsSensFadType & modelPar_NCGBL,
   bool modelPar_given_NCGBL,
   AdmsSensFadType & modelPar_PCGBL,
   bool modelPar_given_PCGBL,
   AdmsSensFadType & modelPar_LCKAPPAB,
   bool modelPar_given_LCKAPPAB,
   AdmsSensFadType & modelPar_NCKAPPAB,
   bool modelPar_given_NCKAPPAB,
   AdmsSensFadType & modelPar_PCKAPPAB,
   bool modelPar_given_PCKAPPAB,
   AdmsSensFadType & modelPar_LNTGEN,
   bool modelPar_given_LNTGEN,
   AdmsSensFadType & modelPar_NNTGEN,
   bool modelPar_given_NNTGEN,
   AdmsSensFadType & modelPar_PNTGEN,
   bool modelPar_given_PNTGEN,
   AdmsSensFadType & modelPar_LAIGEN,
   bool modelPar_given_LAIGEN,
   AdmsSensFadType & modelPar_NAIGEN,
   bool modelPar_given_NAIGEN,
   AdmsSensFadType & modelPar_PAIGEN,
   bool modelPar_given_PAIGEN,
   AdmsSensFadType & modelPar_LBIGEN,
   bool modelPar_given_LBIGEN,
   AdmsSensFadType & modelPar_NBIGEN,
   bool modelPar_given_NBIGEN,
   AdmsSensFadType & modelPar_PBIGEN,
   bool modelPar_given_PBIGEN,
   AdmsSensFadType & modelPar_LXRCRG1,
   bool modelPar_given_LXRCRG1,
   AdmsSensFadType & modelPar_NXRCRG1,
   bool modelPar_given_NXRCRG1,
   AdmsSensFadType & modelPar_PXRCRG1,
   bool modelPar_given_PXRCRG1,
   AdmsSensFadType & modelPar_LXRCRG2,
   bool modelPar_given_LXRCRG2,
   AdmsSensFadType & modelPar_NXRCRG2,
   bool modelPar_given_NXRCRG2,
   AdmsSensFadType & modelPar_PXRCRG2,
   bool modelPar_given_PXRCRG2,
   AdmsSensFadType & modelPar_LUTE,
   bool modelPar_given_LUTE,
   AdmsSensFadType & modelPar_NUTE,
   bool modelPar_given_NUTE,
   AdmsSensFadType & modelPar_PUTE,
   bool modelPar_given_PUTE,
   AdmsSensFadType & modelPar_LUTER,
   bool modelPar_given_LUTER,
   AdmsSensFadType & modelPar_NUTER,
   bool modelPar_given_NUTER,
   AdmsSensFadType & modelPar_PUTER,
   bool modelPar_given_PUTER,
   AdmsSensFadType & modelPar_LUTL,
   bool modelPar_given_LUTL,
   AdmsSensFadType & modelPar_NUTL,
   bool modelPar_given_NUTL,
   AdmsSensFadType & modelPar_PUTL,
   bool modelPar_given_PUTL,
   AdmsSensFadType & modelPar_LUTLR,
   bool modelPar_given_LUTLR,
   AdmsSensFadType & modelPar_NUTLR,
   bool modelPar_given_NUTLR,
   AdmsSensFadType & modelPar_PUTLR,
   bool modelPar_given_PUTLR,
   AdmsSensFadType & modelPar_LEMOBT,
   bool modelPar_given_LEMOBT,
   AdmsSensFadType & modelPar_NEMOBT,
   bool modelPar_given_NEMOBT,
   AdmsSensFadType & modelPar_PEMOBT,
   bool modelPar_given_PEMOBT,
   AdmsSensFadType & modelPar_LUA1,
   bool modelPar_given_LUA1,
   AdmsSensFadType & modelPar_NUA1,
   bool modelPar_given_NUA1,
   AdmsSensFadType & modelPar_PUA1,
   bool modelPar_given_PUA1,
   AdmsSensFadType & modelPar_LUA1R,
   bool modelPar_given_LUA1R,
   AdmsSensFadType & modelPar_NUA1R,
   bool modelPar_given_NUA1R,
   AdmsSensFadType & modelPar_PUA1R,
   bool modelPar_given_PUA1R,
   AdmsSensFadType & modelPar_LUC1,
   bool modelPar_given_LUC1,
   AdmsSensFadType & modelPar_NUC1,
   bool modelPar_given_NUC1,
   AdmsSensFadType & modelPar_PUC1,
   bool modelPar_given_PUC1,
   AdmsSensFadType & modelPar_LUC1R,
   bool modelPar_given_LUC1R,
   AdmsSensFadType & modelPar_NUC1R,
   bool modelPar_given_NUC1R,
   AdmsSensFadType & modelPar_PUC1R,
   bool modelPar_given_PUC1R,
   AdmsSensFadType & modelPar_LUD1,
   bool modelPar_given_LUD1,
   AdmsSensFadType & modelPar_NUD1,
   bool modelPar_given_NUD1,
   AdmsSensFadType & modelPar_PUD1,
   bool modelPar_given_PUD1,
   AdmsSensFadType & modelPar_LUD1R,
   bool modelPar_given_LUD1R,
   AdmsSensFadType & modelPar_NUD1R,
   bool modelPar_given_NUD1R,
   AdmsSensFadType & modelPar_PUD1R,
   bool modelPar_given_PUD1R,
   AdmsSensFadType & modelPar_LUCSTE,
   bool modelPar_given_LUCSTE,
   AdmsSensFadType & modelPar_NUCSTE,
   bool modelPar_given_NUCSTE,
   AdmsSensFadType & modelPar_PUCSTE,
   bool modelPar_given_PUCSTE,
   AdmsSensFadType & modelPar_LPTWGT,
   bool modelPar_given_LPTWGT,
   AdmsSensFadType & modelPar_NPTWGT,
   bool modelPar_given_NPTWGT,
   AdmsSensFadType & modelPar_PPTWGT,
   bool modelPar_given_PPTWGT,
   AdmsSensFadType & modelPar_LAT,
   bool modelPar_given_LAT,
   AdmsSensFadType & modelPar_NAT,
   bool modelPar_given_NAT,
   AdmsSensFadType & modelPar_PAT,
   bool modelPar_given_PAT,
   AdmsSensFadType & modelPar_LATR,
   bool modelPar_given_LATR,
   AdmsSensFadType & modelPar_NATR,
   bool modelPar_given_NATR,
   AdmsSensFadType & modelPar_PATR,
   bool modelPar_given_PATR,
   AdmsSensFadType & modelPar_LATCV,
   bool modelPar_given_LATCV,
   AdmsSensFadType & modelPar_NATCV,
   bool modelPar_given_NATCV,
   AdmsSensFadType & modelPar_PATCV,
   bool modelPar_given_PATCV,
   AdmsSensFadType & modelPar_LSTTHETASAT,
   bool modelPar_given_LSTTHETASAT,
   AdmsSensFadType & modelPar_NSTTHETASAT,
   bool modelPar_given_NSTTHETASAT,
   AdmsSensFadType & modelPar_PSTTHETASAT,
   bool modelPar_given_PSTTHETASAT,
   AdmsSensFadType & modelPar_LPRT,
   bool modelPar_given_LPRT,
   AdmsSensFadType & modelPar_NPRT,
   bool modelPar_given_NPRT,
   AdmsSensFadType & modelPar_PPRT,
   bool modelPar_given_PPRT,
   AdmsSensFadType & modelPar_LKT1,
   bool modelPar_given_LKT1,
   AdmsSensFadType & modelPar_NKT1,
   bool modelPar_given_NKT1,
   AdmsSensFadType & modelPar_PKT1,
   bool modelPar_given_PKT1,
   AdmsSensFadType & modelPar_LTSS,
   bool modelPar_given_LTSS,
   AdmsSensFadType & modelPar_NTSS,
   bool modelPar_given_NTSS,
   AdmsSensFadType & modelPar_PTSS,
   bool modelPar_given_PTSS,
   AdmsSensFadType & modelPar_LIIT,
   bool modelPar_given_LIIT,
   AdmsSensFadType & modelPar_NIIT,
   bool modelPar_given_NIIT,
   AdmsSensFadType & modelPar_PIIT,
   bool modelPar_given_PIIT,
   AdmsSensFadType & modelPar_LTII,
   bool modelPar_given_LTII,
   AdmsSensFadType & modelPar_NTII,
   bool modelPar_given_NTII,
   AdmsSensFadType & modelPar_PTII,
   bool modelPar_given_PTII,
   AdmsSensFadType & modelPar_LTGIDL,
   bool modelPar_given_LTGIDL,
   AdmsSensFadType & modelPar_NTGIDL,
   bool modelPar_given_NTGIDL,
   AdmsSensFadType & modelPar_PTGIDL,
   bool modelPar_given_PTGIDL,
   AdmsSensFadType & modelPar_LIGT,
   bool modelPar_given_LIGT,
   AdmsSensFadType & modelPar_NIGT,
   bool modelPar_given_NIGT,
   AdmsSensFadType & modelPar_PIGT,
   bool modelPar_given_PIGT,
   // non-reals (including hidden)
   int modelPar_NF,
   bool modelPar_given_NF,
   int modelPar_NGCON,
   bool modelPar_given_NGCON,
   int modelPar_DEVTYPE,
   bool modelPar_given_DEVTYPE,
   int modelPar_TYPE,
   bool modelPar_given_TYPE,
   int modelPar_BULKMOD,
   bool modelPar_given_BULKMOD,
   int modelPar_GEOMOD,
   bool modelPar_given_GEOMOD,
   int modelPar_CGEO1SW,
   bool modelPar_given_CGEO1SW,
   int modelPar_RDSMOD,
   bool modelPar_given_RDSMOD,
   int modelPar_ASYMMOD,
   bool modelPar_given_ASYMMOD,
   int modelPar_IGCMOD,
   bool modelPar_given_IGCMOD,
   int modelPar_IGBMOD,
   bool modelPar_given_IGBMOD,
   int modelPar_GIDLMOD,
   bool modelPar_given_GIDLMOD,
   int modelPar_IIMOD,
   bool modelPar_given_IIMOD,
   int modelPar_TNOIMOD,
   bool modelPar_given_TNOIMOD,
   int modelPar_NQSMOD,
   bool modelPar_given_NQSMOD,
   int modelPar_SHMOD,
   bool modelPar_given_SHMOD,
   int modelPar_TEMPMOD,
   bool modelPar_given_TEMPMOD,
   int modelPar_RGATEMOD,
   bool modelPar_given_RGATEMOD,
   int modelPar_RGEOMOD,
   bool modelPar_given_RGEOMOD,
   int modelPar_CGEOMOD,
   bool modelPar_given_CGEOMOD,
   int modelPar_SH_WARN,
   bool modelPar_given_SH_WARN,
   int modelPar_IGCLAMP,
   bool modelPar_given_IGCLAMP,
   int modelPar_SDTERM,
   bool modelPar_given_SDTERM,
   int modelPar_NSEG,
   bool modelPar_given_NSEG,
   double admsTemperature, double ADMSgmin_arg, const Instance & theInstance);

#endif // Xyce_ADMS_SENSITIVITIES


// Limited exponential --- NOT what verilog LRM says, but what qucs,
// ng-spice, and zspice do.

template <typename T>
T limexp(const T &x)
{
  if ((x) < 80.0)
    return (exp(x));
  else
    return (exp(80.0)*(x-79.0));
}

// Maybe this will do as a substitute for a sacado-provided "floor" and "ceil"?
// It is wrong to try to propagate the Sacado derivatives to the return
// value, as the floor and ceil functions have zero derivative w.r.t. any
// of the variables in the argument, except when X is an integer at which
// point the derivative is undefined.
template <typename T>
double ADMSfloor(const T & x)
{
  return (floor(x.val()));
}

template <typename T>
double ADMSceil(const T & x)
{
  return (ceil(x.val()));
}


struct Traits: public DeviceTraits<Model, Instance, MOSFET1::Traits>
{
  static const char *name() {return "BSIM-CMG FINFET v110.0.0";}
  static const char *deviceTypeName() {return "m level 110";}

  static int numNodes() {return 4;}
  static int numOptionalNodes() {return 1;}
  static bool modelRequired() {return true;}
  static bool isLinearDevice() {return false;}

  static Device *factory(const Configuration &configuration, const FactoryBlock &factory_block);
  static void loadModelParameters(ParametricData<Model> &model_parameters);
  static void loadInstanceParameters(ParametricData<Instance> &instance_parameters);
};

//-----------------------------------------------------------------------------
// Class         : Instance

//
// Purpose       : This class represents a single instance  of the
//                 device.  It mainly contains indices and pointers into
//                 the matrix equation (see the resistor instance class for
//                 more details).
//
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Instance : public DeviceInstance
{
  friend class ParametricData<Instance>;
  friend class Model;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend struct Traits;

public:
  Instance(
     const Configuration &       configuration,
     const InstanceBlock &       instance_block,
     Model &                     model,
     const FactoryBlock &        factory_block);

  ~Instance();

private:
  Instance(const Instance &);
  Instance &operator=(const Instance &);

public:
  void registerLIDs( const LocalIdVector & intLIDVecRef,
                     const LocalIdVector & extLIDVecRef );
  void registerStoreLIDs( const LocalIdVector & stoLIDVecRef );
  void setupPointers();

  void loadNodeSymbols(Util::SymbolTable &symbol_table) const;

  const JacobianStamp & jacobianStamp() const;
  void registerJacLIDs( const JacobianStamp & jacLIDVec );

  void registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef);

  bool processParams();
  bool updateTemperature ( const double & temp = -999.0 );
  bool updateIntermediateVars ();
  bool updatePrimaryState ();
  bool updateSecondaryState ();

  // load functions, residual:
  bool loadDAEQVector ();
  bool loadDAEFVector ();

  // load functions, Jacobian:
  bool loadDAEdQdx ();
  bool loadDAEdFdx ();

  void collapseNodes();
  int getNumNoiseSources () const;  // 14
  void setupNoiseSources (Xyce::Analysis::NoiseData & noiseData);
  void getNoiseSources (Xyce::Analysis::NoiseData & noiseData);

private:

public:
  // iterator reference to the bsimcmg_110 model which owns this instance.
  // Getters and setters
  Model &getModel()
  {
    return model_;
  }

private:

  Model & model_;   //< Owning Model
  // Begin verilog Instance Variables
  //   Instance Parameters
  double L;
  double D;
  double TFIN;
  double FPITCH;
  int NF;
  double NFIN;
  int NGCON;
  double ASEO;
  double ADEO;
  double PSEO;
  double PDEO;
  double ASEJ;
  double ADEJ;
  double PSEJ;
  double PDEJ;
  double COVS;
  double COVD;
  double CGSP;
  double CGDP;
  double CDSP;
  double NRS;
  double NRD;
  double LRSD;
  double NFINNOM;
  double DELVTRAND;
  double U0MULT;
  double m;
  //  Variables of global_instance scope
  int devsign;
  double NFINtotal;
  double TempLast;
  double d_TempLast_dTemp_t_GND;
  double ids;
  double d_ids_dTemp_t_GND;
  double d_ids_dV_di_si;
  double d_ids_dV_ge_e;
  double d_ids_dV_e_si;
  double d_ids_dV_e_di;
  double d_ids_dV_ge_si;
  double d_ids_dV_ge_di;
  double sigvds;
  double qd;
  double d_qd_dV_di_si;
  double d_qd_dV_e_si;
  double d_qd_dV_e_di;
  double d_qd_dV_ge_si;
  double d_qd_dTemp_t_GND;
  double d_qd_dV_ge_e;
  double qg;
  double d_qg_dV_di_si;
  double d_qg_dV_e_si;
  double d_qg_dV_e_di;
  double d_qg_dV_ge_si;
  double d_qg_dTemp_t_GND;
  double d_qg_dV_ge_e;
  double qs;
  double d_qs_dV_ge_di;
  double d_qs_dV_di_si;
  double d_qs_dV_e_si;
  double d_qs_dV_e_di;
  double d_qs_dV_ge_si;
  double d_qs_dTemp_t_GND;
  double d_qs_dV_ge_e;
  double qb;
  double ni;
  double d_ni_dTemp_t_GND;
  double epssub;
  double epsratio;
  double Eg;
  double d_Eg_dTemp_t_GND;
  double Eg0;
  double Nc;
  double d_Nc_dTemp_t_GND;
  double Leff;
  double LeffCV;
  double LeffCV_acc;
  double Weff0;
  double WeffCV0;
  double cox;
  double nbody;
  double phib;
  double d_phib_dTemp_t_GND;
  double deltaPhi;
  double d_deltaPhi_dTemp_t_GND;
  double T0;
  double d_T0_dV_ge_di;
  double d_T0_dV_ge_e;
  double d_T0_dV_e_si;
  double d_T0_dV_e_di;
  double d_T0_dV_ge_si;
  double d_T0_dV_di_si;
  double d_T0_dTemp_t_GND;
  double T1;
  double d_T1_dV_di_d;
  double d_T1_dV_si_s;
  double d_T1_dV_ge_di;
  double d_T1_dV_ge_e;
  double d_T1_dV_e_si;
  double d_T1_dV_e_di;
  double d_T1_dV_ge_si;
  double d_T1_dV_di_si;
  double d_T1_dTemp_t_GND;
  double T2;
  double d_T2_dV_di_d;
  double d_T2_dV_si_s;
  double d_T2_dV_ge_di;
  double d_T2_dV_ge_e;
  double d_T2_dV_ge_si;
  double d_T2_dV_e_si;
  double d_T2_dV_e_di;
  double d_T2_dV_di_si;
  double d_T2_dTemp_t_GND;
  double T3;
  double d_T3_dV_di_d;
  double d_T3_dV_si_s;
  double d_T3_dV_ge_di;
  double d_T3_dV_ge_e;
  double d_T3_dV_di_si;
  double d_T3_dV_e_si;
  double d_T3_dV_e_di;
  double d_T3_dV_ge_si;
  double d_T3_dTemp_t_GND;
  double Vtm;
  double d_Vtm_dTemp_t_GND;
  double Vtm0;
  double Tnom;
  double TRatio;
  double d_TRatio_dTemp_t_GND;
  double dvth_temp;
  double d_dvth_temp_dTemp_t_GND;
  double delTemp;
  double d_delTemp_dTemp_t_GND;
  double ThetaSS;
  double d_ThetaSS_dTemp_t_GND;
  double K0_t;
  double d_K0_t_dTemp_t_GND;
  double K0SI_t;
  double d_K0SI_t_dTemp_t_GND;
  double K2SI_t;
  double d_K2SI_t_dTemp_t_GND;
  double K1_t;
  double d_K1_t_dTemp_t_GND;
  double K2SAT_t;
  double d_K2SAT_t_dTemp_t_GND;
  double A1_t;
  double d_A1_t_dTemp_t_GND;
  double A2_t;
  double d_A2_t_dTemp_t_GND;
  double AIGBINV_t;
  double d_AIGBINV_t_dTemp_t_GND;
  double AIGBACC_t;
  double d_AIGBACC_t_dTemp_t_GND;
  double AIGC_t;
  double d_AIGC_t_dTemp_t_GND;
  double AIGS_t;
  double d_AIGS_t_dTemp_t_GND;
  double AIGD_t;
  double d_AIGD_t_dTemp_t_GND;
  double BETA0_t;
  double d_BETA0_t_dTemp_t_GND;
  double SII0_t;
  double d_SII0_t_dTemp_t_GND;
  double BGISL_t;
  double d_BGISL_t_dTemp_t_GND;
  double BGIDL_t;
  double d_BGIDL_t_dTemp_t_GND;
  double igtemp;
  double d_igtemp_dTemp_t_GND;
  double PTWG_t;
  double d_PTWG_t_dTemp_t_GND;
  double PTWGR_t;
  double d_PTWGR_t_dTemp_t_GND;
  double ALPHA0_t;
  double d_ALPHA0_t_dTemp_t_GND;
  double ALPHA1_t;
  double d_ALPHA1_t_dTemp_t_GND;
  double ALPHAII0_t;
  double d_ALPHAII0_t_dTemp_t_GND;
  double ALPHAII1_t;
  double d_ALPHAII1_t_dTemp_t_GND;
  double CJS_t;
  double d_CJS_t_dTemp_t_GND;
  double CJSWS_t;
  double d_CJSWS_t_dTemp_t_GND;
  double CJSWGD_t;
  double d_CJSWGD_t_dTemp_t_GND;
  double CJD_t;
  double d_CJD_t_dTemp_t_GND;
  double CJSWD_t;
  double d_CJSWD_t_dTemp_t_GND;
  double CJSWGS_t;
  double d_CJSWGS_t_dTemp_t_GND;
  double PBS_t;
  double d_PBS_t_dTemp_t_GND;
  double PBSWS_t;
  double d_PBSWS_t_dTemp_t_GND;
  double PBSWGS_t;
  double d_PBSWGS_t_dTemp_t_GND;
  double PBD_t;
  double d_PBD_t_dTemp_t_GND;
  double PBSWD_t;
  double d_PBSWD_t_dTemp_t_GND;
  double PBSWGD_t;
  double d_PBSWGD_t_dTemp_t_GND;
  double JSS_t;
  double d_JSS_t_dTemp_t_GND;
  double JSWS_t;
  double d_JSWS_t_dTemp_t_GND;
  double JSWGS_t;
  double d_JSWGS_t_dTemp_t_GND;
  double JSD_t;
  double d_JSD_t_dTemp_t_GND;
  double JSWD_t;
  double d_JSWD_t_dTemp_t_GND;
  double JSWGD_t;
  double d_JSWGD_t_dTemp_t_GND;
  double JTSS_t;
  double d_JTSS_t_dTemp_t_GND;
  double JTSD_t;
  double d_JTSD_t_dTemp_t_GND;
  double JTSSWS_t;
  double d_JTSSWS_t_dTemp_t_GND;
  double JTSSWD_t;
  double d_JTSSWD_t_dTemp_t_GND;
  double JTSSWGS_t;
  double d_JTSSWGS_t_dTemp_t_GND;
  double JTSSWGD_t;
  double d_JTSSWGD_t_dTemp_t_GND;
  double NJTS_t;
  double d_NJTS_t_dTemp_t_GND;
  double NJTSD_t;
  double d_NJTSD_t_dTemp_t_GND;
  double NJTSSW_t;
  double d_NJTSSW_t_dTemp_t_GND;
  double NJTSSWD_t;
  double d_NJTSSWD_t_dTemp_t_GND;
  double NJTSSWG_t;
  double d_NJTSSWG_t_dTemp_t_GND;
  double NJTSSWGD_t;
  double d_NJTSSWGD_t_dTemp_t_GND;
  double K2_t;
  double d_K2_t_dTemp_t_GND;
  double K0SISAT_t;
  double d_K0SISAT_t_dTemp_t_GND;
  double K2SISAT_t;
  double d_K2SISAT_t_dTemp_t_GND;
  double q0;
  double d_q0_dTemp_t_GND;
  double d_q0_dV_di_si;
  double T11;
  double d_T11_dV_ge_e;
  double d_T11_dV_e_si;
  double d_T11_dV_e_di;
  double d_T11_dV_ge_si;
  double d_T11_dV_di_si;
  double d_T11_dTemp_t_GND;
  double T12;
  double d_T12_dV_ge_e;
  double d_T12_dV_e_si;
  double d_T12_dV_e_di;
  double d_T12_dV_ge_si;
  double d_T12_dV_di_si;
  double d_T12_dTemp_t_GND;
  double e0;
  double d_e0_dV_ge_e;
  double d_e0_dV_ge_si;
  double d_e0_dV_e_si;
  double d_e0_dV_e_di;
  double d_e0_dV_di_si;
  double d_e0_dTemp_t_GND;
  double e1;
  double d_e1_dV_ge_e;
  double d_e1_dV_di_si;
  double d_e1_dV_e_si;
  double d_e1_dV_e_di;
  double d_e1_dV_ge_si;
  double d_e1_dTemp_t_GND;
  double e2;
  double d_e2_dV_di_si;
  double d_e2_dV_e_si;
  double d_e2_dV_e_di;
  double d_e2_dV_ge_si;
  double d_e2_dTemp_t_GND;
  double ETA0_t;
  double d_ETA0_t_dTemp_t_GND;
  double ETA0R_t;
  double d_ETA0R_t_dTemp_t_GND;
  double scl;
  double vbi;
  double d_vbi_dTemp_t_GND;
  double tmp;
  double Theta_SCE;
  double Theta_SW;
  double Theta_DIBL;
  double Theta_RSCE;
  double Theta_DITS;
  double veseff;
  double d_veseff_dV_e_si;
  double d_veseff_dV_e_di;
  double d_veseff_dV_di_si;
  double d_veseff_dTemp_t_GND;
  double Tcen0;
  double Tcen;
  double d_Tcen_dV_ge_e;
  double d_Tcen_dV_di_si;
  double d_Tcen_dV_e_si;
  double d_Tcen_dV_e_di;
  double d_Tcen_dV_ge_si;
  double d_Tcen_dTemp_t_GND;
  double dvch_qm;
  double d_dvch_qm_dTemp_t_GND;
  double E0;
  double E0prime;
  double E1;
  double E1prime;
  double mx;
  double mxprime;
  double md;
  double mdprime;
  double gprime;
  double gfactor;
  double gam0;
  double d_gam0_dTemp_t_GND;
  double gam1;
  double d_gam1_dTemp_t_GND;
  double kT;
  double d_kT_dTemp_t_GND;
  double qis;
  double d_qis_dV_di_si;
  double d_qis_dV_e_si;
  double d_qis_dV_e_di;
  double d_qis_dV_ge_si;
  double d_qis_dTemp_t_GND;
  double qid;
  double d_qid_dV_di_si;
  double d_qid_dV_e_si;
  double d_qid_dV_e_di;
  double d_qid_dV_ge_si;
  double d_qid_dTemp_t_GND;
  double qbs;
  double qba;
  double d_qba_dTemp_t_GND;
  double d_qba_dV_di_si;
  double d_qba_dV_ge_e;
  double d_qba_dV_e_si;
  double d_qba_dV_e_di;
  double d_qba_dV_ge_si;
  double eta_mu;
  double d_eta_mu_dTemp_t_GND;
  double eta_mu_cv;
  double u0;
  double d_u0_dTemp_t_GND;
  double u0r;
  double d_u0r_dTemp_t_GND;
  double UA_t;
  double d_UA_t_dTemp_t_GND;
  double UAR_t;
  double d_UAR_t_dTemp_t_GND;
  double UC_t;
  double d_UC_t_dTemp_t_GND;
  double UCR_t;
  double d_UCR_t_dTemp_t_GND;
  double UCS_t;
  double d_UCS_t_dTemp_t_GND;
  double UD_t;
  double d_UD_t_dTemp_t_GND;
  double UDR_t;
  double d_UDR_t_dTemp_t_GND;
  double U0_t;
  double d_U0_t_dTemp_t_GND;
  double U0R_t;
  double d_U0R_t_dTemp_t_GND;
  double ETAMOB_t;
  double d_ETAMOB_t_dTemp_t_GND;
  double EeffFactor;
  double Dr;
  double d_Dr_dTemp_t_GND;
  double d_Dr_dV_di_si;
  double d_Dr_dV_ge_e;
  double d_Dr_dV_e_si;
  double d_Dr_dV_e_di;
  double d_Dr_dV_ge_si;
  double d_Dr_dV_ge_di;
  double WeffWRFactor;
  double RSourceGeo;
  double RDrainGeo;
  double RDSWMIN_i;
  double RDWMIN_i;
  double RSWMIN_i;
  double Rdrain;
  double d_Rdrain_dTemp_t_GND;
  double d_Rdrain_dV_di_d;
  double d_Rdrain_dV_si_s;
  double d_Rdrain_dV_ge_e;
  double d_Rdrain_dV_di_si;
  double d_Rdrain_dV_e_si;
  double d_Rdrain_dV_e_di;
  double d_Rdrain_dV_ge_si;
  double d_Rdrain_dV_ge_di;
  double Rsource;
  double d_Rsource_dTemp_t_GND;
  double d_Rsource_dV_si_s;
  double d_Rsource_dV_ge_e;
  double d_Rsource_dV_di_si;
  double d_Rsource_dV_e_si;
  double d_Rsource_dV_e_di;
  double d_Rsource_dV_ge_si;
  double rdstemp;
  double d_rdstemp_dTemp_t_GND;
  double Rdsi;
  double d_Rdsi_dTemp_t_GND;
  double d_Rdsi_dV_ge_di;
  double d_Rdsi_dV_ge_e;
  double d_Rdsi_dV_e_si;
  double d_Rdsi_dV_e_di;
  double d_Rdsi_dV_ge_si;
  double d_Rdsi_dV_di_si;
  double RSDR_t;
  double d_RSDR_t_dTemp_t_GND;
  double RSDRR_t;
  double d_RSDRR_t_dTemp_t_GND;
  double RDDR_t;
  double d_RDDR_t_dTemp_t_GND;
  double RDDRR_t;
  double d_RDDRR_t_dTemp_t_GND;
  double VSAT_t;
  double d_VSAT_t_dTemp_t_GND;
  double VSAT1_t;
  double d_VSAT1_t_dTemp_t_GND;
  double VSAT1R_t;
  double d_VSAT1R_t_dTemp_t_GND;
  double VSATCV_t;
  double d_VSATCV_t_dTemp_t_GND;
  double MEXP_t;
  double d_MEXP_t_dTemp_t_GND;
  double MEXPR_t;
  double d_MEXPR_t_dTemp_t_GND;
  double Tb;
  double d_Tb_dV_di_si;
  double d_Tb_dV_e_si;
  double d_Tb_dV_e_di;
  double d_Tb_dV_ge_si;
  double d_Tb_dTemp_t_GND;
  double VSAT_a;
  double d_VSAT_a_dTemp_t_GND;
  double d_VSAT_a_dV_di_si;
  double Cfr_geo;
  double ggeltd;
  double igbinv;
  double d_igbinv_dV_ge_e;
  double d_igbinv_dV_di_si;
  double d_igbinv_dTemp_t_GND;
  double d_igbinv_dV_e_si;
  double d_igbinv_dV_e_di;
  double d_igbinv_dV_ge_si;
  double d_igbinv_dV_ge_di;
  double d_igbinv_dV_di_d;
  double d_igbinv_dV_si_s;
  double igsd_mult;
  double d_igsd_mult_dTemp_t_GND;
  double igsd_mult0;
  double igbs;
  double d_igbs_dV_ge_e;
  double d_igbs_dV_di_si;
  double d_igbs_dTemp_t_GND;
  double d_igbs_dV_e_si;
  double d_igbs_dV_e_di;
  double d_igbs_dV_ge_si;
  double d_igbs_dV_ge_di;
  double d_igbs_dV_di_d;
  double d_igbs_dV_si_s;
  double igbd;
  double d_igbd_dV_ge_e;
  double d_igbd_dV_di_si;
  double d_igbd_dTemp_t_GND;
  double d_igbd_dV_e_si;
  double d_igbd_dV_e_di;
  double d_igbd_dV_ge_si;
  double d_igbd_dV_ge_di;
  double d_igbd_dV_di_d;
  double d_igbd_dV_si_s;
  double igbacc;
  double d_igbacc_dV_ge_e;
  double d_igbacc_dV_di_si;
  double d_igbacc_dTemp_t_GND;
  double d_igbacc_dV_e_si;
  double d_igbacc_dV_e_di;
  double d_igbacc_dV_ge_si;
  double d_igbacc_dV_ge_di;
  double d_igbacc_dV_di_d;
  double d_igbacc_dV_si_s;
  double igcs;
  double d_igcs_dV_ge_di;
  double d_igcs_dV_ge_e;
  double d_igcs_dV_di_si;
  double d_igcs_dV_e_si;
  double d_igcs_dV_e_di;
  double d_igcs_dV_ge_si;
  double d_igcs_dTemp_t_GND;
  double d_igcs_dV_di_d;
  double d_igcs_dV_si_s;
  double igcd;
  double d_igcd_dV_ge_di;
  double d_igcd_dV_ge_e;
  double d_igcd_dV_di_si;
  double d_igcd_dV_e_si;
  double d_igcd_dV_e_di;
  double d_igcd_dV_ge_si;
  double d_igcd_dTemp_t_GND;
  double d_igcd_dV_di_d;
  double d_igcd_dV_si_s;
  double igisl;
  double d_igisl_dV_ge_di;
  double d_igisl_dV_di_d;
  double d_igisl_dV_si_s;
  double d_igisl_dV_ge_e;
  double d_igisl_dV_di_si;
  double d_igisl_dTemp_t_GND;
  double d_igisl_dV_e_si;
  double d_igisl_dV_e_di;
  double d_igisl_dV_ge_si;
  double igidl;
  double d_igidl_dV_ge_di;
  double d_igidl_dV_di_d;
  double d_igidl_dV_si_s;
  double d_igidl_dV_ge_e;
  double d_igidl_dV_di_si;
  double d_igidl_dTemp_t_GND;
  double d_igidl_dV_e_si;
  double d_igidl_dV_e_di;
  double d_igidl_dV_ge_si;
  double vfbsd;
  double d_vfbsd_dTemp_t_GND;
  double igs;
  double d_igs_dTemp_t_GND;
  double d_igs_dV_ge_si;
  double d_igs_dV_ge_di;
  double d_igs_dV_ge_e;
  double d_igs_dV_e_si;
  double d_igs_dV_e_di;
  double d_igs_dV_di_si;
  double igd;
  double d_igd_dTemp_t_GND;
  double d_igd_dV_ge_si;
  double d_igd_dV_ge_di;
  double d_igd_dV_ge_e;
  double d_igd_dV_e_si;
  double d_igd_dV_e_di;
  double d_igd_dV_di_si;
  double Aechvb;
  double Bechvb;
  double Toxratio;
  double Iii;
  double d_Iii_dV_ge_di;
  double d_Iii_dV_ge_e;
  double d_Iii_dV_e_si;
  double d_Iii_dV_e_di;
  double d_Iii_dV_ge_si;
  double d_Iii_dV_di_si;
  double d_Iii_dTemp_t_GND;
  double cox_acc;
  double d_cox_acc_dV_ge_e;
  double d_cox_acc_dV_di_si;
  double d_cox_acc_dV_e_si;
  double d_cox_acc_dV_e_di;
  double d_cox_acc_dV_ge_si;
  double d_cox_acc_dTemp_t_GND;
  double qg_acc;
  double d_qg_acc_dV_ge_di;
  double d_qg_acc_dV_ge_e;
  double d_qg_acc_dV_e_si;
  double d_qg_acc_dV_e_di;
  double d_qg_acc_dV_ge_si;
  double d_qg_acc_dV_di_si;
  double d_qg_acc_dTemp_t_GND;
  double qb_acc;
  double d_qb_acc_dV_ge_di;
  double d_qb_acc_dV_ge_e;
  double d_qb_acc_dV_e_si;
  double d_qb_acc_dV_e_di;
  double d_qb_acc_dV_ge_si;
  double d_qb_acc_dV_di_si;
  double d_qb_acc_dTemp_t_GND;
  double qgs_fr;
  double d_qgs_fr_dV_ge_s;
  double d_qgs_fr_dV_ge_di;
  double d_qgs_fr_dV_ge_e;
  double d_qgs_fr_dV_e_si;
  double d_qgs_fr_dV_e_di;
  double d_qgs_fr_dV_ge_si;
  double d_qgs_fr_dV_di_si;
  double d_qgs_fr_dTemp_t_GND;
  double qgd_fr;
  double d_qgd_fr_dV_ge_d;
  double d_qgd_fr_dV_ge_di;
  double d_qgd_fr_dV_ge_e;
  double d_qgd_fr_dV_e_si;
  double d_qgd_fr_dV_e_di;
  double d_qgd_fr_dV_ge_si;
  double d_qgd_fr_dV_di_si;
  double d_qgd_fr_dTemp_t_GND;
  double qds_fr;
  double d_qds_fr_dV_d_s;
  double qgs_parasitic;
  double d_qgs_parasitic_dV_ge_s;
  double d_qgs_parasitic_dV_ge_di;
  double d_qgs_parasitic_dV_ge_e;
  double d_qgs_parasitic_dV_e_si;
  double d_qgs_parasitic_dV_e_di;
  double d_qgs_parasitic_dV_ge_si;
  double d_qgs_parasitic_dV_di_si;
  double d_qgs_parasitic_dTemp_t_GND;
  double qgd_parasitic;
  double d_qgd_parasitic_dV_ge_d;
  double d_qgd_parasitic_dV_ge_di;
  double d_qgd_parasitic_dV_ge_e;
  double d_qgd_parasitic_dV_e_si;
  double d_qgd_parasitic_dV_e_di;
  double d_qgd_parasitic_dV_ge_si;
  double d_qgd_parasitic_dV_di_si;
  double d_qgd_parasitic_dTemp_t_GND;
  double Qes;
  double d_Qes_dV_di_d;
  double d_Qes_dV_si_s;
  double d_Qes_dTemp_t_GND;
  double d_Qes_dV_ge_di;
  double d_Qes_dV_ge_e;
  double d_Qes_dV_e_si;
  double d_Qes_dV_e_di;
  double d_Qes_dV_ge_si;
  double d_Qes_dV_di_si;
  double Qed;
  double d_Qed_dV_di_d;
  double d_Qed_dV_si_s;
  double d_Qed_dTemp_t_GND;
  double d_Qed_dV_ge_di;
  double d_Qed_dV_ge_e;
  double d_Qed_dV_e_si;
  double d_Qed_dV_e_di;
  double d_Qed_dV_ge_si;
  double d_Qed_dV_di_si;
  double Qeg;
  double d_Qeg_dV_ge_di;
  double d_Qeg_dV_ge_e;
  double d_Qeg_dV_di_si;
  double d_Qeg_dV_e_si;
  double d_Qeg_dV_e_di;
  double d_Qeg_dV_ge_si;
  double d_Qeg_dTemp_t_GND;
  double d_Qeg_dV_e_ge;
  double csbox;
  double cdbox;
  double cgbox;
  double vfbsdcv;
  double d_vfbsdcv_dTemp_t_GND;
  double Ies;
  double d_Ies_dV_ge_di;
  double d_Ies_dV_ge_e;
  double d_Ies_dV_e_si;
  double d_Ies_dV_e_di;
  double d_Ies_dV_ge_si;
  double d_Ies_dV_di_si;
  double d_Ies_dTemp_t_GND;
  double Ied;
  double d_Ied_dV_ge_di;
  double d_Ied_dV_ge_e;
  double d_Ied_dV_e_si;
  double d_Ied_dV_e_di;
  double d_Ied_dV_ge_si;
  double d_Ied_dV_di_si;
  double d_Ied_dTemp_t_GND;
  double Czbs;
  double d_Czbs_dTemp_t_GND;
  double Czbssw;
  double d_Czbssw_dTemp_t_GND;
  double Czbsswg;
  double d_Czbsswg_dTemp_t_GND;
  double Czbd;
  double d_Czbd_dTemp_t_GND;
  double Czbdsw;
  double d_Czbdsw_dTemp_t_GND;
  double Czbdswg;
  double d_Czbdswg_dTemp_t_GND;
  double Isbs;
  double d_Isbs_dTemp_t_GND;
  double Isbd;
  double d_Isbd_dTemp_t_GND;
  double Nvtms;
  double d_Nvtms_dTemp_t_GND;
  double Nvtmd;
  double d_Nvtmd_dTemp_t_GND;
  double SslpRev;
  double d_SslpRev_dTemp_t_GND;
  double IVjsmRev;
  double d_IVjsmRev_dTemp_t_GND;
  double VjsmRev;
  double d_VjsmRev_dTemp_t_GND;
  double SslpFwd;
  double d_SslpFwd_dTemp_t_GND;
  double IVjsmFwd;
  double d_IVjsmFwd_dTemp_t_GND;
  double VjsmFwd;
  double d_VjsmFwd_dTemp_t_GND;
  double XExpBVS;
  double d_XExpBVS_dTemp_t_GND;
  double DslpRev;
  double d_DslpRev_dTemp_t_GND;
  double IVjdmRev;
  double d_IVjdmRev_dTemp_t_GND;
  double VjdmRev;
  double d_VjdmRev_dTemp_t_GND;
  double DslpFwd;
  double d_DslpFwd_dTemp_t_GND;
  double IVjdmFwd;
  double d_IVjdmFwd_dTemp_t_GND;
  double VjdmFwd;
  double d_VjdmFwd_dTemp_t_GND;
  double XExpBVD;
  double d_XExpBVD_dTemp_t_GND;
  double igentemp;
  double d_igentemp_dTemp_t_GND;
  double idsgen;
  double d_idsgen_dTemp_t_GND;
  double d_idsgen_dV_ge_di;
  double d_idsgen_dV_ge_e;
  double d_idsgen_dV_e_si;
  double d_idsgen_dV_e_di;
  double d_idsgen_dV_ge_si;
  double d_idsgen_dV_di_si;
  double LINTIGEN_i;
  double LINTNOI_i;
  double litl;
  double FNPowerAt1Hz;
  double d_FNPowerAt1Hz_dV_ge_di;
  double d_FNPowerAt1Hz_dV_ge_e;
  double d_FNPowerAt1Hz_dV_e_si;
  double d_FNPowerAt1Hz_dV_e_di;
  double d_FNPowerAt1Hz_dV_ge_si;
  double d_FNPowerAt1Hz_dV_di_si;
  double d_FNPowerAt1Hz_dTemp_t_GND;
  double d_FNPowerAt1Hz_dV_di_d;
  double d_FNPowerAt1Hz_dV_si_s;
  double NTNOI_i;
  double Gtnoi;
  double d_Gtnoi_dV_ge_di;
  double d_Gtnoi_dV_ge_e;
  double d_Gtnoi_dV_e_si;
  double d_Gtnoi_dV_e_di;
  double d_Gtnoi_dV_ge_si;
  double d_Gtnoi_dV_di_si;
  double d_Gtnoi_dTemp_t_GND;
  double d_Gtnoi_dV_di_d;
  double d_Gtnoi_dV_si_s;
  double sid;
  double d_sid_dTemp_t_GND;
  double d_sid_dV_ge_di;
  double d_sid_dV_ge_e;
  double d_sid_dV_e_si;
  double d_sid_dV_e_di;
  double d_sid_dV_ge_si;
  double d_sid_dV_di_si;
  double d_sid_dV_di_d;
  double d_sid_dV_si_s;
  double gspr;
  double d_gspr_dTemp_t_GND;
  double d_gspr_dV_si_s;
  double d_gspr_dV_ge_e;
  double d_gspr_dV_di_si;
  double d_gspr_dV_e_si;
  double d_gspr_dV_e_di;
  double d_gspr_dV_ge_si;
  double gdpr;
  double d_gdpr_dTemp_t_GND;
  double d_gdpr_dV_di_d;
  double d_gdpr_dV_si_s;
  double d_gdpr_dV_ge_e;
  double d_gdpr_dV_di_si;
  double d_gdpr_dV_e_si;
  double d_gdpr_dV_e_di;
  double d_gdpr_dV_ge_si;
  double d_gdpr_dV_ge_di;
  double gamma;
  double d_gamma_dV_ge_di;
  double d_gamma_dV_di_d;
  double d_gamma_dV_si_s;
  double d_gamma_dV_ge_e;
  double d_gamma_dV_di_si;
  double d_gamma_dTemp_t_GND;
  double d_gamma_dV_e_si;
  double d_gamma_dV_e_di;
  double d_gamma_dV_ge_si;
  double delta;
  double d_delta_dV_di_d;
  double d_delta_dV_si_s;
  double d_delta_dV_ge_di;
  double d_delta_dV_ge_e;
  double d_delta_dV_e_si;
  double d_delta_dV_e_di;
  double d_delta_dV_ge_si;
  double d_delta_dV_di_si;
  double d_delta_dTemp_t_GND;
  double ctnoi;
  double d_ctnoi_dV_ge_di;
  double d_ctnoi_dV_di_d;
  double d_ctnoi_dV_si_s;
  double d_ctnoi_dV_ge_e;
  double d_ctnoi_dV_di_si;
  double d_ctnoi_dV_e_si;
  double d_ctnoi_dV_e_di;
  double d_ctnoi_dV_ge_si;
  double d_ctnoi_dTemp_t_GND;
  double C0;
  double d_C0_dV_ge_e;
  double d_C0_dV_di_si;
  double d_C0_dV_e_si;
  double d_C0_dV_e_di;
  double d_C0_dV_ge_si;
  double d_C0_dTemp_t_GND;
  double sf;
  double d_sf_dTemp_t_GND;
  double d_sf_dV_di_si;
  double d_sf_dV_e_si;
  double d_sf_dV_e_di;
  double d_sf_dV_ge_si;
  double d_sf_dV_ge_di;
  double d_sf_dV_di_d;
  double d_sf_dV_si_s;
  double d_sf_dV_ge_e;
  double gth;
  double cth;
  double PHIG_i;
  double CFD_i;
  double CFS_i;
  double COVS_i;
  double d_COVS_i_dV_ge_di;
  double d_COVS_i_dV_ge_e;
  double d_COVS_i_dV_e_si;
  double d_COVS_i_dV_e_di;
  double d_COVS_i_dV_ge_si;
  double d_COVS_i_dV_di_si;
  double d_COVS_i_dTemp_t_GND;
  double COVD_i;
  double d_COVD_i_dV_ge_di;
  double d_COVD_i_dV_ge_e;
  double d_COVD_i_dV_e_si;
  double d_COVD_i_dV_e_di;
  double d_COVD_i_dV_ge_si;
  double d_COVD_i_dV_di_si;
  double d_COVD_i_dTemp_t_GND;
  double CGSO_i;
  double CGDO_i;
  double CGSL_i;
  double CGDL_i;
  double CGBL_i;
  double CKAPPAS_i;
  double CKAPPAD_i;
  double CKAPPAB_i;
  double QMFACTOR_i;
  double QMTCENCV_i;
  double QMTCENCVA_i;
  double KSATIV_i;
  double KSATIVR_i;
  double CDSC_i;
  double CDSCD_i;
  double CDSCDR_i;
  double CIT_i;
  double DVT0_i;
  double CITR_i;
  double PHIN_i;
  double ETA0_i;
  double ETA0R_i;
  double VSAT_i;
  double VSATR_i;
  double VSATR_t;
  double d_VSATR_t_dTemp_t_GND;
  double DVTP0_i;
  double DVTP1_i;
  double K0_i;
  double K01_i;
  double K0SI_i;
  double K0SI1_i;
  double K2SI_i;
  double K2SI1_i;
  double PHIBE_i;
  double K1_i;
  double K11_i;
  double K2SAT_i;
  double K2SAT1_i;
  double DELTAVSAT_i;
  double PSAT_i;
  double DELTAVSATCV_i;
  double PSATCV_i;
  double VSAT1_i;
  double VSAT1R_i;
  double PTWG_i;
  double PTWGR_i;
  double VSATCV_i;
  double U0_i;
  double U0R_i;
  double ETAMOB_i;
  double RDSW_i;
  double PRWGS_i;
  double PRWGD_i;
  double PDIBL1_i;
  double PDIBL1R_i;
  double PDIBL2_i;
  double PDIBL2R_i;
  double DROUT_i;
  double PVAG_i;
  double AIGBINV_i;
  double AIGBINV1_i;
  double BIGBINV_i;
  double CIGBINV_i;
  double EIGBINV_i;
  double NIGBINV_i;
  double AIGBACC_i;
  double AIGBACC1_i;
  double BIGBACC_i;
  double CIGBACC_i;
  double NIGBACC_i;
  double AIGC_i;
  double AIGC1_i;
  double BIGC_i;
  double CIGC_i;
  double PIGCD_i;
  double AIGS_i;
  double AIGS1_i;
  double BIGS_i;
  double CIGS_i;
  double POXEDGE_i;
  double AIGD_i;
  double AIGD1_i;
  double BIGD_i;
  double CIGD_i;
  double AGIDL_i;
  double BGIDL_i;
  double CGIDL_i;
  double EGIDL_i;
  double PGIDL_i;
  double AGISL_i;
  double BGISL_i;
  double CGISL_i;
  double EGISL_i;
  double PGISL_i;
  double ALPHA0_i;
  double ALPHA1_i;
  double ALPHAII0_i;
  double ALPHAII1_i;
  double BETA0_i;
  double BETAII0_i;
  double BETAII1_i;
  double BETAII2_i;
  double ESATII_i;
  double LII_i;
  double SII0_i;
  double SII1_i;
  double SII2_i;
  double SIID_i;
  double TII_i;
  double MEXP_i;
  double MEXPR_i;
  double PCLM_i;
  double PCLMG_i;
  double PCLMCV_i;
  double PCLMR_i;
  double A1_i;
  double A2_i;
  double A11_i;
  double A21_i;
  double K1RSCE_i;
  double DVTSHIFT_i;
  double DVTSHIFTR_i;
  double UA_i;
  double UC_i;
  double EU_i;
  double UD_i;
  double UCS_i;
  double UAR_i;
  double EUR_i;
  double UCR_i;
  double UDR_i;
  double UA1_i;
  double UA1R_i;
  double UC1_i;
  double UD1_i;
  double UCSTE_i;
  double UTE_i;
  double UTL_i;
  double EMOBT_i;
  double UC1R_i;
  double UD1R_i;
  double UTER_i;
  double UTLR_i;
  double PTWGT_i;
  double AT_i;
  double ATCV_i;
  double ATR_i;
  double RDW_i;
  double RSW_i;
  double PRT_i;
  double KT1_i;
  double TSS_i;
  double IIT_i;
  double IGT_i;
  double TGIDL_i;
  double NTGEN_i;
  double AIGEN_i;
  double BIGEN_i;
  double K0SISAT_i;
  double K0SISAT1_i;
  double K2SISAT_i;
  double K2SISAT1_i;
  double K2_i;
  double K21_i;
  double Cins;
  double Ach;
  double Weff_UFCM;
  double qdep;
  double d_qdep_dTemp_t_GND;
  double d_qdep_dV_di_si;
  double rc;
  double vth_fixed_factor_Sub;
  double d_vth_fixed_factor_Sub_dTemp_t_GND;
  double d_vth_fixed_factor_Sub_dV_di_si;
  double vth_fixed_factor_SI;
  double d_vth_fixed_factor_SI_dTemp_t_GND;
  double d_vth_fixed_factor_SI_dV_di_si;
  double qm;
  double d_qm_dV_di_si;
  double d_qm_dV_e_si;
  double d_qm_dV_e_di;
  double d_qm_dV_ge_si;
  double d_qm_dTemp_t_GND;
  double Qdep_ov_Cins;
  double qi_acc_for_QM;
  double d_qi_acc_for_QM_dTemp_t_GND;
  double d_qi_acc_for_QM_dV_di_si;
  double d_qi_acc_for_QM_dV_ge_e;
  double d_qi_acc_for_QM_dV_e_si;
  double d_qi_acc_for_QM_dV_e_di;
  double d_qi_acc_for_QM_dV_ge_si;
  double fieldnormalizationfactor;
  double d_fieldnormalizationfactor_dTemp_t_GND;
  double auxQMfact;
  double QMFACTORCVfinal;
  double d_QMFACTORCVfinal_dTemp_t_GND;
  double psipclamp;
  double d_psipclamp_dV_ge_e;
  double d_psipclamp_dV_di_si;
  double d_psipclamp_dV_e_si;
  double d_psipclamp_dV_e_di;
  double d_psipclamp_dV_ge_si;
  double d_psipclamp_dTemp_t_GND;
  double sqrtpsip;
  double d_sqrtpsip_dV_ge_e;
  double d_sqrtpsip_dV_di_si;
  double d_sqrtpsip_dV_e_si;
  double d_sqrtpsip_dV_e_di;
  double d_sqrtpsip_dV_ge_si;
  double d_sqrtpsip_dTemp_t_GND;
  double nq;
  double d_nq_dTemp_t_GND;
  double d_nq_dV_di_si;
  double d_nq_dV_ge_e;
  double d_nq_dV_e_si;
  double d_nq_dV_e_di;
  double d_nq_dV_ge_si;
  double F0;
  double d_F0_dV_ge_si;
  double d_F0_dV_e_si;
  double d_F0_dV_e_di;
  double d_F0_dV_di_si;
  double d_F0_dTemp_t_GND;
  // end verilog Instance Variables=====
  // Nodal LID Variables
  int li_d;
  int li_g;
  int li_s;
  int li_e;
  int li_t;
  int li_si;
  int li_di;
  int li_ge;
  int li_N;
  // end Nodal LID Variables
  // Branch LID Variables
  // end Branch LID Variables
  // Lead (branch) LID Variables
  int li_branch_id;
  int li_branch_ig;
  int li_branch_is;
  int li_branch_ie;
  // end Lead (branch) LID Variables
  // Jacobian  pointers
  double * f_di_Equ_ge_Node_Ptr;
  double * f_di_Equ_di_Node_Ptr;
  double * f_si_Equ_ge_Node_Ptr;
  double * f_si_Equ_di_Node_Ptr;
  double * f_di_Equ_si_Node_Ptr;
  double * f_si_Equ_si_Node_Ptr;
  double * f_di_Equ_e_Node_Ptr;
  double * f_si_Equ_e_Node_Ptr;
  double * f_di_Equ_t_Node_Ptr;
  double * f_si_Equ_t_Node_Ptr;
  double * f_ge_Equ_ge_Node_Ptr;
  double * f_ge_Equ_e_Node_Ptr;
  double * f_ge_Equ_t_Node_Ptr;
  double * f_ge_Equ_si_Node_Ptr;
  double * f_ge_Equ_di_Node_Ptr;
  double * f_ge_Equ_s_Node_Ptr;
  double * f_si_Equ_s_Node_Ptr;
  double * f_ge_Equ_d_Node_Ptr;
  double * f_si_Equ_d_Node_Ptr;
  double * f_di_Equ_s_Node_Ptr;
  double * f_di_Equ_d_Node_Ptr;
  double * f_e_Equ_ge_Node_Ptr;
  double * f_e_Equ_si_Node_Ptr;
  double * f_e_Equ_e_Node_Ptr;
  double * f_e_Equ_di_Node_Ptr;
  double * f_e_Equ_t_Node_Ptr;
  double * f_e_Equ_s_Node_Ptr;
  double * f_e_Equ_d_Node_Ptr;
  double * f_d_Equ_d_Node_Ptr;
  double * f_d_Equ_s_Node_Ptr;
  double * f_s_Equ_d_Node_Ptr;
  double * f_s_Equ_s_Node_Ptr;
  double * f_s_Equ_t_Node_Ptr;
  double * f_s_Equ_di_Node_Ptr;
  double * f_s_Equ_si_Node_Ptr;
  double * f_s_Equ_ge_Node_Ptr;
  double * f_s_Equ_e_Node_Ptr;
  double * f_d_Equ_t_Node_Ptr;
  double * f_d_Equ_di_Node_Ptr;
  double * f_d_Equ_si_Node_Ptr;
  double * f_d_Equ_ge_Node_Ptr;
  double * f_d_Equ_e_Node_Ptr;
  double * f_g_Equ_g_Node_Ptr;
  double * f_g_Equ_ge_Node_Ptr;
  double * f_ge_Equ_g_Node_Ptr;
  double * f_g_Equ_t_Node_Ptr;
  double * f_di_Equ_N_Node_Ptr;
  double * f_si_Equ_N_Node_Ptr;
  double * f_N_Equ_ge_Node_Ptr;
  double * f_N_Equ_e_Node_Ptr;
  double * f_N_Equ_si_Node_Ptr;
  double * f_N_Equ_s_Node_Ptr;
  double * f_N_Equ_di_Node_Ptr;
  double * f_N_Equ_d_Node_Ptr;
  double * f_N_Equ_t_Node_Ptr;
  double * f_N_Equ_N_Node_Ptr;
  double * f_ge_Equ_N_Node_Ptr;
  double * f_t_Equ_s_Node_Ptr;
  double * f_t_Equ_si_Node_Ptr;
  double * f_t_Equ_di_Node_Ptr;
  double * f_t_Equ_d_Node_Ptr;
  double * f_t_Equ_ge_Node_Ptr;
  double * f_t_Equ_e_Node_Ptr;
  double * f_t_Equ_t_Node_Ptr;
  double * q_di_Equ_ge_Node_Ptr;
  double * q_di_Equ_di_Node_Ptr;
  double * q_si_Equ_ge_Node_Ptr;
  double * q_si_Equ_di_Node_Ptr;
  double * q_di_Equ_si_Node_Ptr;
  double * q_si_Equ_si_Node_Ptr;
  double * q_di_Equ_e_Node_Ptr;
  double * q_si_Equ_e_Node_Ptr;
  double * q_di_Equ_t_Node_Ptr;
  double * q_si_Equ_t_Node_Ptr;
  double * q_ge_Equ_ge_Node_Ptr;
  double * q_ge_Equ_e_Node_Ptr;
  double * q_ge_Equ_t_Node_Ptr;
  double * q_ge_Equ_si_Node_Ptr;
  double * q_ge_Equ_di_Node_Ptr;
  double * q_ge_Equ_s_Node_Ptr;
  double * q_si_Equ_s_Node_Ptr;
  double * q_ge_Equ_d_Node_Ptr;
  double * q_si_Equ_d_Node_Ptr;
  double * q_di_Equ_s_Node_Ptr;
  double * q_di_Equ_d_Node_Ptr;
  double * q_e_Equ_ge_Node_Ptr;
  double * q_e_Equ_si_Node_Ptr;
  double * q_e_Equ_e_Node_Ptr;
  double * q_e_Equ_di_Node_Ptr;
  double * q_e_Equ_t_Node_Ptr;
  double * q_e_Equ_s_Node_Ptr;
  double * q_e_Equ_d_Node_Ptr;
  double * q_d_Equ_d_Node_Ptr;
  double * q_d_Equ_s_Node_Ptr;
  double * q_s_Equ_d_Node_Ptr;
  double * q_s_Equ_s_Node_Ptr;
  double * q_s_Equ_t_Node_Ptr;
  double * q_s_Equ_di_Node_Ptr;
  double * q_s_Equ_si_Node_Ptr;
  double * q_s_Equ_ge_Node_Ptr;
  double * q_s_Equ_e_Node_Ptr;
  double * q_d_Equ_t_Node_Ptr;
  double * q_d_Equ_di_Node_Ptr;
  double * q_d_Equ_si_Node_Ptr;
  double * q_d_Equ_ge_Node_Ptr;
  double * q_d_Equ_e_Node_Ptr;
  double * q_g_Equ_g_Node_Ptr;
  double * q_g_Equ_ge_Node_Ptr;
  double * q_ge_Equ_g_Node_Ptr;
  double * q_g_Equ_t_Node_Ptr;
  double * q_di_Equ_N_Node_Ptr;
  double * q_si_Equ_N_Node_Ptr;
  double * q_N_Equ_ge_Node_Ptr;
  double * q_N_Equ_e_Node_Ptr;
  double * q_N_Equ_si_Node_Ptr;
  double * q_N_Equ_s_Node_Ptr;
  double * q_N_Equ_di_Node_Ptr;
  double * q_N_Equ_d_Node_Ptr;
  double * q_N_Equ_t_Node_Ptr;
  double * q_N_Equ_N_Node_Ptr;
  double * q_ge_Equ_N_Node_Ptr;
  double * q_t_Equ_s_Node_Ptr;
  double * q_t_Equ_si_Node_Ptr;
  double * q_t_Equ_di_Node_Ptr;
  double * q_t_Equ_d_Node_Ptr;
  double * q_t_Equ_ge_Node_Ptr;
  double * q_t_Equ_e_Node_Ptr;
  double * q_t_Equ_t_Node_Ptr;
  // Jacobian offsets
  int A_di_Equ_ge_NodeOffset;
  int A_di_Equ_di_NodeOffset;
  int A_si_Equ_ge_NodeOffset;
  int A_si_Equ_di_NodeOffset;
  int A_di_Equ_si_NodeOffset;
  int A_si_Equ_si_NodeOffset;
  int A_di_Equ_e_NodeOffset;
  int A_si_Equ_e_NodeOffset;
  int A_di_Equ_t_NodeOffset;
  int A_si_Equ_t_NodeOffset;
  int A_ge_Equ_ge_NodeOffset;
  int A_ge_Equ_e_NodeOffset;
  int A_ge_Equ_t_NodeOffset;
  int A_ge_Equ_si_NodeOffset;
  int A_ge_Equ_di_NodeOffset;
  int A_ge_Equ_s_NodeOffset;
  int A_si_Equ_s_NodeOffset;
  int A_ge_Equ_d_NodeOffset;
  int A_si_Equ_d_NodeOffset;
  int A_di_Equ_s_NodeOffset;
  int A_di_Equ_d_NodeOffset;
  int A_e_Equ_ge_NodeOffset;
  int A_e_Equ_si_NodeOffset;
  int A_e_Equ_e_NodeOffset;
  int A_e_Equ_di_NodeOffset;
  int A_e_Equ_t_NodeOffset;
  int A_e_Equ_s_NodeOffset;
  int A_e_Equ_d_NodeOffset;
  int A_d_Equ_d_NodeOffset;
  int A_d_Equ_s_NodeOffset;
  int A_s_Equ_d_NodeOffset;
  int A_s_Equ_s_NodeOffset;
  int A_s_Equ_t_NodeOffset;
  int A_s_Equ_di_NodeOffset;
  int A_s_Equ_si_NodeOffset;
  int A_s_Equ_ge_NodeOffset;
  int A_s_Equ_e_NodeOffset;
  int A_d_Equ_t_NodeOffset;
  int A_d_Equ_di_NodeOffset;
  int A_d_Equ_si_NodeOffset;
  int A_d_Equ_ge_NodeOffset;
  int A_d_Equ_e_NodeOffset;
  int A_g_Equ_g_NodeOffset;
  int A_g_Equ_ge_NodeOffset;
  int A_ge_Equ_g_NodeOffset;
  int A_g_Equ_t_NodeOffset;
  int A_di_Equ_N_NodeOffset;
  int A_si_Equ_N_NodeOffset;
  int A_N_Equ_ge_NodeOffset;
  int A_N_Equ_e_NodeOffset;
  int A_N_Equ_si_NodeOffset;
  int A_N_Equ_s_NodeOffset;
  int A_N_Equ_di_NodeOffset;
  int A_N_Equ_d_NodeOffset;
  int A_N_Equ_t_NodeOffset;
  int A_N_Equ_N_NodeOffset;
  int A_ge_Equ_N_NodeOffset;
  int A_t_Equ_s_NodeOffset;
  int A_t_Equ_si_NodeOffset;
  int A_t_Equ_di_NodeOffset;
  int A_t_Equ_d_NodeOffset;
  int A_t_Equ_ge_NodeOffset;
  int A_t_Equ_e_NodeOffset;
  int A_t_Equ_t_NodeOffset;
  // end of Jacobian and pointers
  // node numbers
  static const int admsNodeID_d = 0;
  static const int admsNodeID_g = 1;
  static const int admsNodeID_s = 2;
  static const int admsNodeID_e = 3;
  static const int admsNodeID_t = 4;
  static const int admsNodeID_si = 5;
  static const int admsNodeID_di = 6;
  static const int admsNodeID_ge = 7;
  static const int admsNodeID_N = 8;
  static const int admsNodeID_GND = -1;
  // end node numbers
  // Additional IDs for branch equations
  // end branch numbers
  // Probe numbers
  static const int admsProbeID_V_N_GND = 0;
  static const int admsProbeID_V_g_ge = 1;
  static const int admsProbeID_V_s_si = 2;
  static const int admsProbeID_V_d_di = 3;
  static const int admsProbeID_V_e_ge = 4;
  static const int admsProbeID_V_ge_d = 5;
  static const int admsProbeID_V_ge_s = 6;
  static const int admsProbeID_V_di_d = 7;
  static const int admsProbeID_V_si_s = 8;
  static const int admsProbeID_V_e_s = 9;
  static const int admsProbeID_V_d_s = 10;
  static const int admsProbeID_V_g_s = 11;
  static const int admsProbeID_V_ge_e = 12;
  static const int admsProbeID_V_e_di = 13;
  static const int admsProbeID_V_e_si = 14;
  static const int admsProbeID_V_ge_di = 15;
  static const int admsProbeID_V_di_si = 16;
  static const int admsProbeID_V_ge_si = 17;
  static const int admsProbeID_Temp_t_GND = 18;
  // end probe numbers
  // Store LIDs
  // end store LIDs
  // bools for collapsing nodes
  bool collapseNode_si;
  bool collapseNode_di;
  bool collapseNode_ge;
  bool collapseNode_N;
  // Arrays to hold probes
  std::vector < double > probeVars;
  std::vector < std::vector < double > > d_probeVars;
  // Arrays to hold contributions
  // dynamic contributions are differentiated w.r.t time
  std::vector < double > staticContributions;
  std::vector < std::vector < double > > d_staticContributions;
  std::vector < double > dynamicContributions;
  std::vector < std::vector < double > > d_dynamicContributions;
  //vectors to hold noise information for communication between methods
  std::vector<double> noiseContribsPower;
  std::vector<double> noiseContribsExponent;


  // this is what we'll use when any model uses $temperature.  We'll
  // set it in updateTemperature, and initialize it to whatever
  // is in devOptions when the instance is constructed.
  double admsTemperature;

  // vt at $temperature;
  double adms_vt_nom;


  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" parameter to use
  double admsInstTemp;


  JacobianStamp jacStamp;
  IdVector nodeMap;
  PairMap pairToJacStampMap;

  // These instance-owned vectors are for storage of lead current data
  std::vector<double> leadCurrentF;
  std::vector<double> leadCurrentQ;

  // These variables would normally get scoped as instance class if we actually used them
  // as the original verilog, but they're only used in computation of commented-out output
  // variables, and so get mis-identified as local to initial_instance by ADMS right now.
  // We are manually adding them in as instance class variables here and commenting out the
  // local declaration in the processParams function.
  double NGATE_i;

  // THESE VARIABLES ADDED BY HAND
  // They are used solely to store output variables like Vth from
  // updateIntermediateVars prior to copying to the store vector
  double VTH_output;
  double IDS_output;
  double GM_output;
  double VDS_output;
  double VBS_output;
  double VGS_output;
  double VDSAT_output;

  // store vector lids for output variables, added by hand:
  int li_store_vth;
  int li_store_ids;
  int li_store_gm;
  int li_store_vds;
  int li_store_vbs;
  int li_store_vgs;
  int li_store_vdsat;

};



namespace AnalogFunctions
{

// Analog Function lexp
template<typename ScalarT> ScalarT lexp(ScalarT x)
{


  ScalarT lexp;
  {
    if ((x>80.0))
    {
      lexp = (5.540622384e34*((1.0+x)-80.0));
    }
    else
    {
      if ((x<(-80.0)))
      {
        lexp = 1.804851387e-35;
      }
      else
      {
        lexp = exp(x);
      }
    }
  }
  return(lexp);
}
// Derivative of Analog Function lexp
double d_lexp(double x  , double d_x  );
// Evaluator class for Analog Function lexp
class lexpEvaluator
{
  struct returnType
  {
    double value;
    double deriv_WRT_x;
  };
public:
  // constructor takes all same arguments as regular templated function,
  // even though it doesn't USE the output args
  lexpEvaluator(double x);
  // function that returns the precomputed values.  This, too, takes
  // all the same arguments as the regular function, though it ONLY
  // uses the output arguments
  double getValues(double  x);
  // function that returns the total derivative of the function and its
  // output arguments with respect to some variable.  We pass in the
  // normal arguments(none of which are used) and the derivatives of those
  // arguments with respect to the desired variable.  We compute the
  // derivatives using the chain rule and our precomputed derivatives
  // with respect to input variables
  double getDerivs(double x  , double d_x);
private:
  returnType lexpReturn_;
  returnType evaluator_(double x);
};


// Analog Function lln
template<typename ScalarT> ScalarT lln(ScalarT x)
{


  ScalarT lln;
  {
    lln = log(std::max(x,static_cast<double>(1.0e-38)));
  }
  return(lln);
}
// Derivative of Analog Function lln
double d_lln(double x  , double d_x  );
// Evaluator class for Analog Function lln
class llnEvaluator
{
  struct returnType
  {
    double value;
    double deriv_WRT_x;
  };
public:
  // constructor takes all same arguments as regular templated function,
  // even though it doesn't USE the output args
  llnEvaluator(double x);
  // function that returns the precomputed values.  This, too, takes
  // all the same arguments as the regular function, though it ONLY
  // uses the output arguments
  double getValues(double  x);
  // function that returns the total derivative of the function and its
  // output arguments with respect to some variable.  We pass in the
  // normal arguments(none of which are used) and the derivatives of those
  // arguments with respect to the desired variable.  We compute the
  // derivatives using the chain rule and our precomputed derivatives
  // with respect to input variables
  double getDerivs(double x  , double d_x);
private:
  returnType llnReturn_;
  returnType evaluator_(double x);
};


// Analog Function hypsmooth
template<typename ScalarT> ScalarT hypsmooth(ScalarT x, ScalarT c)
{


  ScalarT hypsmooth;
  {
    hypsmooth = (0.5*(x+sqrt(((x*x)+((4.0*c)*c)))));
  }
  return(hypsmooth);
}
// Derivative of Analog Function hypsmooth
double d_hypsmooth(double x , double c  , double d_x  , double d_c  );
// Evaluator class for Analog Function hypsmooth
class hypsmoothEvaluator
{
  struct returnType
  {
    double value;
    double deriv_WRT_x;
    double deriv_WRT_c;
  };
public:
  // constructor takes all same arguments as regular templated function,
  // even though it doesn't USE the output args
  hypsmoothEvaluator(double x, double c);
  // function that returns the precomputed values.  This, too, takes
  // all the same arguments as the regular function, though it ONLY
  // uses the output arguments
  double getValues(double  x, double  c);
  // function that returns the total derivative of the function and its
  // output arguments with respect to some variable.  We pass in the
  // normal arguments(none of which are used) and the derivatives of those
  // arguments with respect to the desired variable.  We compute the
  // derivatives using the chain rule and our precomputed derivatives
  // with respect to input variables
  double getDerivs(double x , double c  , double d_x, double d_c);
private:
  returnType hypsmoothReturn_;
  returnType evaluator_(double x, double c);
};


// Analog Function hypmax
template<typename ScalarT> ScalarT hypmax(ScalarT x, ScalarT xmin, ScalarT c)
{


  ScalarT hypmax;
  {
    hypmax = (xmin+(0.5*(((x-xmin)-c)+sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4.0*xmin)*c))))));
  }
  return(hypmax);
}
// Derivative of Analog Function hypmax
double d_hypmax(double x , double xmin , double c  , double d_x  , double d_xmin  , double d_c  );
// Evaluator class for Analog Function hypmax
class hypmaxEvaluator
{
  struct returnType
  {
    double value;
    double deriv_WRT_x;
    double deriv_WRT_xmin;
    double deriv_WRT_c;
  };
public:
  // constructor takes all same arguments as regular templated function,
  // even though it doesn't USE the output args
  hypmaxEvaluator(double x, double xmin, double c);
  // function that returns the precomputed values.  This, too, takes
  // all the same arguments as the regular function, though it ONLY
  // uses the output arguments
  double getValues(double  x, double  xmin, double  c);
  // function that returns the total derivative of the function and its
  // output arguments with respect to some variable.  We pass in the
  // normal arguments(none of which are used) and the derivatives of those
  // arguments with respect to the desired variable.  We compute the
  // derivatives using the chain rule and our precomputed derivatives
  // with respect to input variables
  double getDerivs(double x , double xmin , double c  , double d_x, double d_xmin, double d_c);
private:
  returnType hypmaxReturn_;
  returnType evaluator_(double x, double xmin, double c);
};


// Analog Function Tempdep
template<typename ScalarT> ScalarT Tempdep(ScalarT PARAML, ScalarT PARAMT, ScalarT DELTEMP, ScalarT TEMPMOD)
{


  ScalarT Tempdep;
  {
    if ((TEMPMOD!=0))
    {
      Tempdep = (PARAML+hypmax<ScalarT>((PARAMT*DELTEMP),(-PARAML),1.0e-6));
    }
    else
    {
      Tempdep = (PARAML*hypsmooth<ScalarT>(((1.0+(PARAMT*DELTEMP))-1.0e-6),1.0e-3));
    }
  }
  return(Tempdep);
}
// Derivative of Analog Function Tempdep
double d_Tempdep(double PARAML , double PARAMT , double DELTEMP , double TEMPMOD  , double d_PARAML  , double d_PARAMT  , double d_DELTEMP  , double d_TEMPMOD  );
// Evaluator class for Analog Function Tempdep
class TempdepEvaluator
{
  struct returnType
  {
    double value;
    double deriv_WRT_PARAML;
    double deriv_WRT_PARAMT;
    double deriv_WRT_DELTEMP;
    double deriv_WRT_TEMPMOD;
  };
public:
  // constructor takes all same arguments as regular templated function,
  // even though it doesn't USE the output args
  TempdepEvaluator(double PARAML, double PARAMT, double DELTEMP, double TEMPMOD);
  // function that returns the precomputed values.  This, too, takes
  // all the same arguments as the regular function, though it ONLY
  // uses the output arguments
  double getValues(double  PARAML, double  PARAMT, double  DELTEMP, double  TEMPMOD);
  // function that returns the total derivative of the function and its
  // output arguments with respect to some variable.  We pass in the
  // normal arguments(none of which are used) and the derivatives of those
  // arguments with respect to the desired variable.  We compute the
  // derivatives using the chain rule and our precomputed derivatives
  // with respect to input variables
  double getDerivs(double PARAML , double PARAMT , double DELTEMP , double TEMPMOD  , double d_PARAML, double d_PARAMT, double d_DELTEMP, double d_TEMPMOD);
private:
  returnType TempdepReturn_;
  returnType evaluator_(double PARAML, double PARAMT, double DELTEMP, double TEMPMOD);
};

}


//-----------------------------------------------------------------------------
// Class         : Model

// Purpose       :
// Special Notes :
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
class Model : public DeviceModel
{
  typedef std::vector<Instance *> InstanceVector;

  friend class ParametricData<Model>;
  friend class Instance;
#ifdef Xyce_ADMS_SENSITIVITIES
  friend class InstanceSensitivity;
  friend class ModelSensitivity;
#endif // Xyce_ADMS_SENSITIVITIES
  friend struct Traits;

public:
  Model(
     const Configuration &       configuration,
     const ModelBlock &          model_block,
     const FactoryBlock &        factory_block);

  ~Model();

private:
  Model(const Model &);
  Model &operator=(const Model &);

public:
  virtual void forEachInstance(DeviceInstanceOp &op) const /* override */;
  virtual std::ostream &printOutInstances(std::ostream &os) const;
  bool processParams();
  bool processInstanceParams();

private:

public:
  void addInstance(Instance *instance)
  {
    instanceContainer.push_back(instance);
  }

  void setupBaseInstanceContainer()
  {
    std::vector<Instance*>::iterator iter = instanceContainer.begin();
    std::vector<Instance*>::iterator end   = instanceContainer.end();
    for ( ; iter!=end; ++iter)
    {
      Xyce::Device::DeviceModel::baseInstanceContainer.push_back( static_cast<Xyce::Device::DeviceInstance *>(*iter) );
    }
  }

private:
  std::vector<Instance*> instanceContainer;

private:

  // This one is for the annoying bogus "XyceADMSInstTemp" parameter
  // that we need so we can set it from the device manager when there's no
  // "TEMP" model parameter to use
  double admsModTemp;
  // Begin verilog Model Variables
  //   Model Parameters
  double L;
  double D;
  double TFIN;
  double FPITCH;
  int NF;
  double NFIN;
  int NGCON;
  double ASEO;
  double ADEO;
  double PSEO;
  double PDEO;
  double ASEJ;
  double ADEJ;
  double PSEJ;
  double PDEJ;
  double COVS;
  double COVD;
  double CGSP;
  double CGDP;
  double CDSP;
  double NRS;
  double NRD;
  double LRSD;
  double XL;
  double DTEMP;
  double DELVTRAND;
  double U0MULT;
  double IDS0MULT;
  int DEVTYPE;
  int TYPE;
  int BULKMOD;
  int GEOMOD;
  int CGEO1SW;
  int RDSMOD;
  int ASYMMOD;
  int IGCMOD;
  int IGBMOD;
  int GIDLMOD;
  int IIMOD;
  int TNOIMOD;
  int NQSMOD;
  int SHMOD;
  int TEMPMOD;
  int RGATEMOD;
  int RGEOMOD;
  int CGEOMOD;
  int SH_WARN;
  int IGCLAMP;
  double LINT;
  double LL;
  double LLN;
  double DLC;
  double DLCACC;
  double DLBIN;
  double LLC;
  double EOT;
  double TOXP;
  double EOTBOX;
  double HFIN;
  double FECH;
  double DELTAW;
  double FECHCV;
  double DELTAWCV;
  double NBODY;
  double NBODYN1;
  double NBODYN2;
  double NSD;
  double PHIG;
  double PHIGL;
  double PHIGLT;
  double PHIGN1;
  double PHIGN2;
  double EPSROX;
  double EPSRSUB;
  double EASUB;
  double NI0SUB;
  double BG0SUB;
  double NC0SUB;
  double NGATE;
  double Imin;
  double CIT;
  double CITR;
  double CDSC;
  double CDSCN1;
  double CDSCN2;
  double CDSCD;
  double CDSCDN1;
  double CDSCDN2;
  double CDSCDR;
  double CDSCDRN1;
  double CDSCDRN2;
  double DVT0;
  double DVT1;
  double DVT1SS;
  double PHIN;
  double ETA0;
  double ETA0N1;
  double ETA0N2;
  double ETA0LT;
  double TETA0;
  double ETA0R;
  double TETA0R;
  double DSUB;
  double DVTP0;
  double DVTP1;
  double ADVTP0;
  double BDVTP0;
  double ADVTP1;
  double BDVTP1;
  double DVTP2;
  double K1RSCE;
  double LPE0;
  double DVTSHIFT;
  double DVTSHIFTR;
  double THETASCE;
  double THETADIBL;
  double THETASW;
  double NVTM;
  double K0;
  double K01;
  double K0SI;
  double K0SI1;
  double K2SI;
  double K2SI1;
  double K0SISAT;
  double K0SISAT1;
  double K2SISAT;
  double K2SISAT1;
  double PHIBE;
  double K1;
  double K11;
  double K2SAT;
  double K2SAT1;
  double K2;
  double K21;
  double QMFACTOR;
  double QMTCENCV;
  double QMTCENCVA;
  double AQMTCEN;
  double BQMTCEN;
  double ETAQM;
  double QM0;
  double PQM;
  double QM0ACC;
  double PQMACC;
  double VSAT;
  double VSATR;
  double VSATN1;
  double VSATN2;
  double VSATRN1;
  double VSATRN2;
  double AVSAT;
  double BVSAT;
  double VSAT1;
  double VSAT1N1;
  double VSAT1N2;
  double VSAT1R;
  double VSAT1RN1;
  double VSAT1RN2;
  double AVSAT1;
  double BVSAT1;
  double DELTAVSAT;
  double PSAT;
  double APSAT;
  double BPSAT;
  double KSATIV;
  double KSATIVR;
  double VSATCV;
  double AVSATCV;
  double BVSATCV;
  double DELTAVSATCV;
  double PSATCV;
  double APSATCV;
  double BPSATCV;
  double MEXP;
  double AMEXP;
  double BMEXP;
  double MEXPR;
  double AMEXPR;
  double BMEXPR;
  double PTWG;
  double PTWGR;
  double APTWG;
  double BPTWG;
  double AT;
  double ATR;
  double ATCV;
  double TMEXP;
  double TMEXPR;
  double PTWGT;
  double U0;
  double U0R;
  double U0N1;
  double U0N1R;
  double U0N2;
  double U0N2R;
  double U0LT;
  double ETAMOB;
  double UP;
  double LPA;
  double UPR;
  double LPAR;
  double UA;
  double UAR;
  double AUA;
  double AUAR;
  double BUA;
  double BUAR;
  double UC;
  double UCR;
  double EU;
  double EUR;
  double AEU;
  double AEUR;
  double BEU;
  double BEUR;
  double UD;
  double UDR;
  double AUD;
  double AUDR;
  double BUD;
  double BUDR;
  double UCS;
  double UTE;
  double UTER;
  double UTL;
  double UTLR;
  double EMOBT;
  double UA1;
  double UA1R;
  double UC1;
  double UC1R;
  double UD1;
  double UD1R;
  double UCSTE;
  double CHARGEWF;
  double RDSWMIN;
  double RDSW;
  double ARDSW;
  double BRDSW;
  double RSWMIN;
  double RSW;
  double ARSW;
  double BRSW;
  double RDWMIN;
  double RDW;
  double ARDW;
  double BRDW;
  double RSDR;
  double RSDRR;
  double RDDR;
  double RDDRR;
  double PRSDR;
  double PRDDR;
  double PRWGS;
  double PRWGD;
  double WR;
  double PRT;
  double TRSDR;
  double TRDDR;
  double PDIBL1;
  double PDIBL1R;
  double PDIBL2;
  double PDIBL2R;
  double DROUT;
  double PVAG;
  double PCLM;
  double PCLMR;
  double APCLM;
  double APCLMR;
  double BPCLM;
  double BPCLMR;
  double PCLMG;
  double PCLMCV;
  double A1;
  double A11;
  double A2;
  double A21;
  double RGEXT;
  double RGFIN;
  double RSHS;
  double RSHD;
  double HEPI;
  double TSILI;
  double RHOC;
  double RHORSD;
  double CRATIO;
  double DELTAPRSD;
  int SDTERM;
  double LSP;
  double EPSRSP;
  double TGATE;
  double TMASK;
  double ASILIEND;
  double ARSDEND;
  double PRSDEND;
  double NSDE;
  double RGEOA;
  double RGEOB;
  double RGEOC;
  double RGEOD;
  double RGEOE;
  double CGEOA;
  double CGEOB;
  double CGEOC;
  double CGEOD;
  double CGEOE;
  double AIGBINV;
  double AIGBINV1;
  double BIGBINV;
  double CIGBINV;
  double EIGBINV;
  double NIGBINV;
  double AIGBACC;
  double AIGBACC1;
  double BIGBACC;
  double CIGBACC;
  double NIGBACC;
  double AIGC;
  double AIGC1;
  double BIGC;
  double CIGC;
  double PIGCD;
  double DLCIGS;
  double AIGS;
  double AIGS1;
  double BIGS;
  double CIGS;
  double DLCIGD;
  double AIGD;
  double AIGD1;
  double BIGD;
  double CIGD;
  double VFBSD;
  double VFBSDCV;
  double TOXREF;
  double TOXG;
  double NTOX;
  double POXEDGE;
  double AGISL;
  double BGISL;
  double CGISL;
  double EGISL;
  double PGISL;
  double AGIDL;
  double BGIDL;
  double CGIDL;
  double EGIDL;
  double PGIDL;
  double ALPHA0;
  double ALPHA01;
  double ALPHA1;
  double ALPHA11;
  double BETA0;
  double ALPHAII0;
  double ALPHAII01;
  double ALPHAII1;
  double ALPHAII11;
  double BETAII0;
  double BETAII1;
  double BETAII2;
  double ESATII;
  double LII;
  double SII0;
  double SII1;
  double SII2;
  double SIID;
  double IIMOD2CLAMP1;
  double IIMOD2CLAMP2;
  double IIMOD2CLAMP3;
  double EOTACC;
  double DELVFBACC;
  double CFS;
  double CFD;
  double CGSO;
  double CGDO;
  double CGSL;
  double CGDL;
  double CKAPPAS;
  double CKAPPAD;
  double CGBO;
  double CGBN;
  double CGBL;
  double CKAPPAB;
  double CSDESW;
  double CJS;
  double CJD;
  double CJSWS;
  double CJSWD;
  double CJSWGS;
  double CJSWGD;
  double PBS;
  double PBD;
  double PBSWS;
  double PBSWD;
  double PBSWGS;
  double PBSWGD;
  double MJS;
  double MJD;
  double MJSWS;
  double MJSWD;
  double MJSWGS;
  double MJSWGD;
  double SJS;
  double SJD;
  double SJSWS;
  double SJSWD;
  double SJSWGS;
  double SJSWGD;
  double MJS2;
  double MJD2;
  double MJSWS2;
  double MJSWD2;
  double MJSWGS2;
  double MJSWGD2;
  double JSS;
  double JSD;
  double JSWS;
  double JSWD;
  double JSWGS;
  double JSWGD;
  double NJS;
  double NJD;
  double IJTHSFWD;
  double IJTHDFWD;
  double IJTHSREV;
  double IJTHDREV;
  double BVS;
  double BVD;
  double XJBVS;
  double XJBVD;
  double JTSS;
  double JTSD;
  double JTSSWS;
  double JTSSWD;
  double JTSSWGS;
  double JTSSWGD;
  double JTWEFF;
  double NJTS;
  double NJTSD;
  double NJTSSW;
  double NJTSSWD;
  double NJTSSWG;
  double NJTSSWGD;
  double VTSS;
  double VTSD;
  double VTSSWS;
  double VTSSWD;
  double VTSSWGS;
  double VTSSWGD;
  double LINTIGEN;
  double NTGEN;
  double AIGEN;
  double BIGEN;
  double XRCRG1;
  double XRCRG2;
  int NSEG;
  double EF;
  double EM;
  double NOIA;
  double NOIB;
  double NOIC;
  double LINTNOI;
  double NTNOI;
  double TNOIA;
  double TNOIB;
  double RNOIA;
  double RNOIB;
  double TNOIC;
  double RNOIC;
  double SCALEN;
  double TNOM;
  double TBGASUB;
  double TBGBSUB;
  double KT1;
  double KT1L;
  double TSS;
  double IIT;
  double TII;
  double TGIDL;
  double IGT;
  double TCJ;
  double TCJSW;
  double TCJSWG;
  double TPB;
  double TPBSW;
  double TPBSWG;
  double XTIS;
  double XTID;
  double XTSS;
  double XTSD;
  double XTSSWS;
  double XTSSWD;
  double XTSSWGS;
  double XTSSWGD;
  double TNJTS;
  double TNJTSD;
  double TNJTSSW;
  double TNJTSSWD;
  double TNJTSSWG;
  double TNJTSSWGD;
  double RTH0;
  double CTH0;
  double WTH0;
  double ASHEXP;
  double BSHEXP;
  double ACH_UFCM;
  double CINS_UFCM;
  double W_UFCM;
  double TFIN_TOP;
  double TFIN_BASE;
  double QMFACTORCV;
  double ALPHA_UFCM;
  double LMIN;
  double WMIN;
  double LMAX;
  double WMAX;
  double LNBODY;
  double NNBODY;
  double PNBODY;
  double LPHIG;
  double NPHIG;
  double PPHIG;
  double LNGATE;
  double NNGATE;
  double PNGATE;
  double LCIT;
  double NCIT;
  double PCIT;
  double LCITR;
  double NCITR;
  double PCITR;
  double LCDSC;
  double NCDSC;
  double PCDSC;
  double LCDSCD;
  double NCDSCD;
  double PCDSCD;
  double LCDSCDR;
  double NCDSCDR;
  double PCDSCDR;
  double LDVT0;
  double NDVT0;
  double PDVT0;
  double LDVT1;
  double NDVT1;
  double PDVT1;
  double LDVT1SS;
  double NDVT1SS;
  double PDVT1SS;
  double LPHIN;
  double NPHIN;
  double PPHIN;
  double LETA0;
  double NETA0;
  double PETA0;
  double LETA0R;
  double NETA0R;
  double PETA0R;
  double LDSUB;
  double NDSUB;
  double PDSUB;
  double LK1RSCE;
  double NK1RSCE;
  double PK1RSCE;
  double LLPE0;
  double NLPE0;
  double PLPE0;
  double LDVTSHIFT;
  double NDVTSHIFT;
  double PDVTSHIFT;
  double LDVTSHIFTR;
  double NDVTSHIFTR;
  double PDVTSHIFTR;
  double LPHIBE;
  double NPHIBE;
  double PPHIBE;
  double LK0;
  double NK0;
  double PK0;
  double LK01;
  double NK01;
  double PK01;
  double LK0SI;
  double NK0SI;
  double PK0SI;
  double LK0SI1;
  double NK0SI1;
  double PK0SI1;
  double LK1;
  double NK1;
  double PK1;
  double LK11;
  double NK11;
  double PK11;
  double LK2SI;
  double NK2SI;
  double PK2SI;
  double LK2SI1;
  double NK2SI1;
  double PK2SI1;
  double LK0SISAT;
  double NK0SISAT;
  double PK0SISAT;
  double LK0SISAT1;
  double NK0SISAT1;
  double PK0SISAT1;
  double LK2SISAT;
  double NK2SISAT;
  double PK2SISAT;
  double LK2SISAT1;
  double NK2SISAT1;
  double PK2SISAT1;
  double LK2SAT;
  double NK2SAT;
  double PK2SAT;
  double LK2SAT1;
  double NK2SAT1;
  double PK2SAT1;
  double LK2;
  double NK2;
  double PK2;
  double LK21;
  double NK21;
  double PK21;
  double LDVTB;
  double NDVTB;
  double PDVTB;
  double LLPEB;
  double NLPEB;
  double PLPEB;
  double LQMFACTOR;
  double NQMFACTOR;
  double PQMFACTOR;
  double LQMTCENCV;
  double NQMTCENCV;
  double PQMTCENCV;
  double LQMTCENCVA;
  double NQMTCENCVA;
  double PQMTCENCVA;
  double LVSAT;
  double NVSAT;
  double PVSAT;
  double LVSATR;
  double NVSATR;
  double PVSATR;
  double LVSAT1;
  double NVSAT1;
  double PVSAT1;
  double LVSAT1R;
  double NVSAT1R;
  double PVSAT1R;
  double LPSAT;
  double NPSAT;
  double PPSAT;
  double LDELTAVSAT;
  double NDELTAVSAT;
  double PDELTAVSAT;
  double LKSATIV;
  double NKSATIV;
  double PKSATIV;
  double LKSATIVR;
  double NKSATIVR;
  double PKSATIVR;
  double LVSATCV;
  double NVSATCV;
  double PVSATCV;
  double LPSATCV;
  double NPSATCV;
  double PPSATCV;
  double LDELTAVSATCV;
  double NDELTAVSATCV;
  double PDELTAVSATCV;
  double LMEXP;
  double NMEXP;
  double PMEXP;
  double LMEXPR;
  double NMEXPR;
  double PMEXPR;
  double LPTWG;
  double NPTWG;
  double PPTWG;
  double LPTWGR;
  double NPTWGR;
  double PPTWGR;
  double LU0;
  double NU0;
  double PU0;
  double LU0R;
  double NU0R;
  double PU0R;
  double LETAMOB;
  double NETAMOB;
  double PETAMOB;
  double LUP;
  double NUP;
  double PUP;
  double LUPR;
  double NUPR;
  double PUPR;
  double LUA;
  double NUA;
  double PUA;
  double LUAR;
  double NUAR;
  double PUAR;
  double LUC;
  double NUC;
  double PUC;
  double LUCR;
  double NUCR;
  double PUCR;
  double LEU;
  double NEU;
  double PEU;
  double LEUR;
  double NEUR;
  double PEUR;
  double LUD;
  double NUD;
  double PUD;
  double LUDR;
  double NUDR;
  double PUDR;
  double LUCS;
  double NUCS;
  double PUCS;
  double LPCLM;
  double NPCLM;
  double PPCLM;
  double LPCLMR;
  double NPCLMR;
  double PPCLMR;
  double LPCLMG;
  double NPCLMG;
  double PPCLMG;
  double LPCLMCV;
  double NPCLMCV;
  double PPCLMCV;
  double LA1;
  double NA1;
  double PA1;
  double LA11;
  double NA11;
  double PA11;
  double LA2;
  double NA2;
  double PA2;
  double LA21;
  double NA21;
  double PA21;
  double LRDSW;
  double NRDSW;
  double PRDSW;
  double LRSW;
  double NRSW;
  double PRSW;
  double LRDW;
  double NRDW;
  double PRDW;
  double LPRWGS;
  double NPRWGS;
  double PPRWGS;
  double LPRWGD;
  double NPRWGD;
  double PPRWGD;
  double LWR;
  double NWR;
  double PWR;
  double LPDIBL1;
  double NPDIBL1;
  double PPDIBL1;
  double LPDIBL1R;
  double NPDIBL1R;
  double PPDIBL1R;
  double LPDIBL2;
  double NPDIBL2;
  double PPDIBL2;
  double LPDIBL2R;
  double NPDIBL2R;
  double PPDIBL2R;
  double LDROUT;
  double NDROUT;
  double PDROUT;
  double LPVAG;
  double NPVAG;
  double PPVAG;
  double LAIGBINV;
  double NAIGBINV;
  double PAIGBINV;
  double LAIGBINV1;
  double NAIGBINV1;
  double PAIGBINV1;
  double LBIGBINV;
  double NBIGBINV;
  double PBIGBINV;
  double LCIGBINV;
  double NCIGBINV;
  double PCIGBINV;
  double LEIGBINV;
  double NEIGBINV;
  double PEIGBINV;
  double LNIGBINV;
  double NNIGBINV;
  double PNIGBINV;
  double LAIGBACC;
  double NAIGBACC;
  double PAIGBACC;
  double LAIGBACC1;
  double NAIGBACC1;
  double PAIGBACC1;
  double LBIGBACC;
  double NBIGBACC;
  double PBIGBACC;
  double LCIGBACC;
  double NCIGBACC;
  double PCIGBACC;
  double LNIGBACC;
  double NNIGBACC;
  double PNIGBACC;
  double LAIGC;
  double NAIGC;
  double PAIGC;
  double LAIGC1;
  double NAIGC1;
  double PAIGC1;
  double LBIGC;
  double NBIGC;
  double PBIGC;
  double LCIGC;
  double NCIGC;
  double PCIGC;
  double LPIGCD;
  double NPIGCD;
  double PPIGCD;
  double LAIGS;
  double NAIGS;
  double PAIGS;
  double LAIGS1;
  double NAIGS1;
  double PAIGS1;
  double LBIGS;
  double NBIGS;
  double PBIGS;
  double LCIGS;
  double NCIGS;
  double PCIGS;
  double LAIGD;
  double NAIGD;
  double PAIGD;
  double LAIGD1;
  double NAIGD1;
  double PAIGD1;
  double LBIGD;
  double NBIGD;
  double PBIGD;
  double LCIGD;
  double NCIGD;
  double PCIGD;
  double LNTOX;
  double NNTOX;
  double PNTOX;
  double LPOXEDGE;
  double NPOXEDGE;
  double PPOXEDGE;
  double LAGISL;
  double NAGISL;
  double PAGISL;
  double LBGISL;
  double NBGISL;
  double PBGISL;
  double LCGISL;
  double NCGISL;
  double PCGISL;
  double LEGISL;
  double NEGISL;
  double PEGISL;
  double LPGISL;
  double NPGISL;
  double PPGISL;
  double LAGIDL;
  double NAGIDL;
  double PAGIDL;
  double LBGIDL;
  double NBGIDL;
  double PBGIDL;
  double LCGIDL;
  double NCGIDL;
  double PCGIDL;
  double LEGIDL;
  double NEGIDL;
  double PEGIDL;
  double LPGIDL;
  double NPGIDL;
  double PPGIDL;
  double LALPHA0;
  double NALPHA0;
  double PALPHA0;
  double LALPHA1;
  double NALPHA1;
  double PALPHA1;
  double LALPHAII0;
  double NALPHAII0;
  double PALPHAII0;
  double LALPHAII1;
  double NALPHAII1;
  double PALPHAII1;
  double LBETA0;
  double NBETA0;
  double PBETA0;
  double LBETAII0;
  double NBETAII0;
  double PBETAII0;
  double LBETAII1;
  double NBETAII1;
  double PBETAII1;
  double LBETAII2;
  double NBETAII2;
  double PBETAII2;
  double LESATII;
  double NESATII;
  double PESATII;
  double LLII;
  double NLII;
  double PLII;
  double LSII0;
  double NSII0;
  double PSII0;
  double LSII1;
  double NSII1;
  double PSII1;
  double LSII2;
  double NSII2;
  double PSII2;
  double LSIID;
  double NSIID;
  double PSIID;
  double LCFS;
  double NCFS;
  double PCFS;
  double LCFD;
  double NCFD;
  double PCFD;
  double LCOVS;
  double NCOVS;
  double PCOVS;
  double LCOVD;
  double NCOVD;
  double PCOVD;
  double LCGSL;
  double NCGSL;
  double PCGSL;
  double LCGDL;
  double NCGDL;
  double PCGDL;
  double LCKAPPAS;
  double NCKAPPAS;
  double PCKAPPAS;
  double LCKAPPAD;
  double NCKAPPAD;
  double PCKAPPAD;
  double LCGBL;
  double NCGBL;
  double PCGBL;
  double LCKAPPAB;
  double NCKAPPAB;
  double PCKAPPAB;
  double LNTGEN;
  double NNTGEN;
  double PNTGEN;
  double LAIGEN;
  double NAIGEN;
  double PAIGEN;
  double LBIGEN;
  double NBIGEN;
  double PBIGEN;
  double LXRCRG1;
  double NXRCRG1;
  double PXRCRG1;
  double LXRCRG2;
  double NXRCRG2;
  double PXRCRG2;
  double LUTE;
  double NUTE;
  double PUTE;
  double LUTER;
  double NUTER;
  double PUTER;
  double LUTL;
  double NUTL;
  double PUTL;
  double LUTLR;
  double NUTLR;
  double PUTLR;
  double LEMOBT;
  double NEMOBT;
  double PEMOBT;
  double LUA1;
  double NUA1;
  double PUA1;
  double LUA1R;
  double NUA1R;
  double PUA1R;
  double LUC1;
  double NUC1;
  double PUC1;
  double LUC1R;
  double NUC1R;
  double PUC1R;
  double LUD1;
  double NUD1;
  double PUD1;
  double LUD1R;
  double NUD1R;
  double PUD1R;
  double LUCSTE;
  double NUCSTE;
  double PUCSTE;
  double LPTWGT;
  double NPTWGT;
  double PPTWGT;
  double LAT;
  double NAT;
  double PAT;
  double LATR;
  double NATR;
  double PATR;
  double LATCV;
  double NATCV;
  double PATCV;
  double LSTTHETASAT;
  double NSTTHETASAT;
  double PSTTHETASAT;
  double LPRT;
  double NPRT;
  double PPRT;
  double LKT1;
  double NKT1;
  double PKT1;
  double LTSS;
  double NTSS;
  double PTSS;
  double LIIT;
  double NIIT;
  double PIIT;
  double LTII;
  double NTII;
  double PTII;
  double LTGIDL;
  double NTGIDL;
  double PTGIDL;
  double LIGT;
  double NIGT;
  double PIGT;
  //  Variables of global_model scope
  // end verilog model variables=====
};

void registerDevice(const DeviceCountMap& deviceMap = DeviceCountMap(),
                    const std::set<int>& levelSet = std::set<int>());

} // namespace ADMSbsimcmg_110
} // namespace Device
} // namespace Xyce
#endif //Xyce_N_DEV_ADMSbsimcmg_110_h
